#!/bin/bash

# source /usr/share/sambaedu/includes/libs-common.sh
source /usr/share/sambaedu/includes/config.inc.sh


function usage {
	echo "script permettant la lecture des parametres Sambaedu" 
	echo "usage: $0 -a -c -d -e -g -r -s -w -h -u"
	echo "       -a :  Tous les parametres en même temps"
	echo "       -c :  parametres clients"
	echo "       -d :  parametres dhcp"
	echo "       -e :  parametres ENT"
	echo "       -h :  show this help ;)"
	echo "       -r :  parametres radius"
	echo "       -s :  parametres principaux sambaedu"
	echo "       -w :  parametres wpkg"
	exit $1
}

if [ $# -eq "0" ]  # Script appele sans argument?
then
  echo "option incorrecte"
  usage 1 
fi

while getopts ":acdeghrswu" cmd
do
	case $cmd in	
	a) display_conf all;;
	c) display_conf clients ;;
	d) display_conf dhcp ;;
	e) display_conf ent ;;
	g) display_conf gpo="gpo" ;;
	r) display_conf radius ;;
	s) display_conf sambaedu ;;
	w) display_conf wpkg ;;
	u|h) usage 1 ;;
        \?) echo "bad option!"
        usage 1 ;;
	*) echo "bad option!"
	usage 1 ;;
	esac
done

exit 0
