#!/bin/bash
#
#
##### Permet de faire la mise à jour de debian et sambaedu #####

# last update 02-2020
if [ "$1" = "--help" -o "$1" = "-h" ]
then
        echo "Script permettant la mise a jour du système debian et sambaedu"
        echo "Usage : sans option pour un mode intéractif ou avec --auto pour le mode muet"
        exit
fi

proxy=$(grep "http_proxy=" /etc/profile | head -n 1 | sed -e "s#.*//##;s/\"//")

if [ ! -z "$proxy" ]; then
export http_proxy="http://$proxy"
export https_proxy="http://$proxy"
export ftp_proxy="http://$proxy"
fi

report="/root/mailtoadmin"
conf_msmtp="/etc/msmtprc"    
if [ -e "$conf_msmtp" ] ; then
    mail_admin=$(grep root /etc/aliases | cut -d " " -f2)
    from=$(grep "^from" $conf_msmtp | cut -d " " -f2)
    echo "To: $mail_admin
From: $from
Subject: Mise à jour système SambaEdu" > $report
    echo "" >> $report
fi
# exit 0
LADATE=$(date +%x)
LADATE2=$(date "+%Y.%m.%d")

debug="0" #desactivation debug si =0
MAIL_REPORT()
{


if [ ! -z "$mail_admin" ]; then
    
    #On envoie un mail à root
    cat $report | mail $mail_admin
else
    echo "Le serveur n'est pas configuré pour envoyer des mails"
fi
}

LINE_TEST()
{
ping -c1  www.google.fr >/dev/null
if [ "$?" != "0" ]; then
        echo "Votre connexion internet ne semble pas fonctionnelle !!" | tee -a $report
        exit 1
fi
}
clear
echo "<pre>"

echo "************************************"
echo "* SCRIPT DE MISE A JOUR SYSTEME    *"
echo "************************************"
echo


if [ "$1" == "--auto" ]
then
        ### mode auto : on installe les deps, on repond oui aux questions, on rend debconf silencieux et on lance un permse3 en mode rapide ###

        option="-y --allow-unauthenticated"
        PERMSE3_OPTION="--light"
        DEBIAN_PRIORITY="critical"
        DEBIAN_FRONTEND="noninteractive"
        export  DEBIAN_FRONTEND DEBIAN_PRIORITY
else
        ### mode interactif debconf est moins bavard mais pas muet permse3 sera plus precis mais plus long aussi ###
		option="--allow-unauthenticated"
        PERMSE3_OPTION="--full"
        DEBIAN_PRIORITY="critical"
        DEBIAN_FRONTEND="noninteractive"
        export  DEBIAN_FRONTEND DEBIAN_PRIORITY

fi

export  DEBIAN_PRIORITY
[ "$debug" != "1" ] && apt-get clean

USE_SPACE=$(df -hPl | grep "/var$" | awk '{print $5}' | sed -e s/%//)


if [ "$USE_SPACE" -le 90 ]; then
        echo "SCRIPT DE MISE A JOUR SYSTEME $LADATE :" >> $report
        echo "" >> $report
        LC_ALL=C apt-get dist-upgrade $option | tee -a $report
        echo "" | tee -a $report
#         echo "Correction de droits si besoin...." | tee -a $report
#         /usr/share/sambaedu/scripts/permse3 $PERMSE3_OPTION | tee -a $report

        # teste si apache a besoin d'etre relancé
	if [ -z "$(ps aux | grep "apache2" | grep -v grep)" ]; then
                echo "On relance Apache" | tee -a $report
                systemctl start apache2 | tee -a $report

        fi

### Rajout d'Eric Elter après constatation de l'arrêt des deux services en question après le lancement de ce script

	# teste si samba a besoin d'etre relancé
       if [ -z "$(ps aux | grep "smbd" | grep -v grep)" ]; then
               echo "On relance Samba" | tee -a $report
               systemctl start smbd | tee -a $report

       fi

   	# teste si mysql a besoin d'etre relancé
       if [ -z "$(ps aux | grep "mysqld" | grep -v grep)" ]; then
               echo "On relance MySQL" | tee -a $report
               systemctl start mysql | tee -a $report

       fi

### Fin de rajout

        echo "Upgrade done !" | tee -a $report
else
        echo -e "Attention : Mise à jour système impossible :(\nEspace insuffisant sur la partition /var, il reste moins de 10% d'espace libre." | tee -a $report
fi
echo "</pre>"
MAIL_REPORT

DEBIAN_PRIORITY="high"
DEBIAN_FRONTEND="dialog"
export  DEBIAN_PRIORITY
export  DEBIAN_FRONTEND
# mv $report /var/log/update_system${LADATE2}.log
exit 0
