<?php

/**

* Retourne des informations sur le systeme (nbr de comptes - memoire dispo)
* @Projet SambaEdu

* @auteurs Equipe SambaEdu

* @Licence Distribue selon les termes de la licence GPL

* @note

*/

include("config.inc.php");
require_once 'functions.inc.php';
require_once("ldap.inc.php");
require_once ('/var/www/sambaedu/vendor/autoload.php');

$serveur = "https://stats.sambaedu.org/";
$etab_name = $config['etab_name']  ?? '';
$UAI = $config['UAI'] ?? '';
$users = count(search_ad($config, "*", "user", $config['dn']['people']));
$computers = count(search_ad($config,"*","computers",$config['dn']['computers']));
$ldap_base_dn = $config['ldap_base_dn'];
$se4_key =  $config['se4_key'];
$version = exec("apt-cache policy sambaedu | grep \"Install\" | cut -d\":\" -f2");
$opt = [
    'base_uri' => $serveur,
    'cookies' => true
];
curl_proxy_options($config, $opt);
$client = new GuzzleHttp\Client($opt);
$request = $client->request('POST', 'index.php', [
    'form_params' => [
        'users' => $users,
        'computers' => $computers,
        'ldap_base_dn' => $ldap_base_dn,
        'se4_key' => $se4_key,
        'version' => $version,
        'UAI' => $UAI,
        'etab_name' => $etab_name
    ]
]);




?>