<?php

/**
 * Ajoute une liste d'utilisateurs à une classe ou une équipe
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: add_list_users_group.php
 */
include "entete.inc.php";
include_once "ldap.inc.php";
include "ihm.inc.php";

require_once ("lang.inc.php");
bindtextdomain('sambaedu-core', "/var/www/sambaedu/locale");
textdomain('sambaedu-core');

// Aide
$_SESSION["pageaide"] = "Annuaire";

echo "<h1>" . gettext("Annuaire") . "</h1>";

//$cn = (isset($_POST['cn'])?$_POST['cn']:(isset($_GET['cn']))? $_GET['cn']:""); Ne marche pas !
if (isset($_POST['cn']))
    $cn = $_POST['cn'];
elseif (isset($_GET['cn']))
    $cn = $_GET['cn'];
else
    $cn = '';
$new_cns = $_POST['new_cns'] ?? "";
$add_list_users_group = $_POST['add_list_users_group'] ?? "";
$err="0";

if (have_right($config, "Annu_is_admin")) {

    $filter = "8_" . $cn;
    aff_trailer("$filter");
    if (!$add_list_users_group) {
        echo "<H4>" . gettext("Ajouter des membres au groupe :") . " $cn</H4>\n";
        // cas d'un groupe de type Equipe
        if (preg_match("#Equipe_#", $cn)) {
            // Recherche de la liste des cn  des membres de ce groupe
            $cns_act = search_ad($config, "*", "memberof", $cn);
            // Reherche de la liste des professeurs
            $cns_profs = search_ad($config, "*", "memberof", "Profs");
            // Constitution d'un tableau excluant les membres actuels
            $people_new_members = array();
            foreach ($cns_profs as $key => $value) {
                if (!in_array($value, $cns_act))
                    array_push($people_new_members, $value);
            }
        }
        elseif (preg_match("#Classe_#", $cn)) {
            // Recherche de la liste des Eleves
            $tous_cns_eleves = search_ad($config, "*", "memberof", "Eleves");
            // Recherche de la liste des Eleves appartenant a une classe
            //$list_classes = list_classes($config, "*");
            $classes = search_ad($config, "*", "classe");
            $list_classes = array();
            foreach ($classes as $val) {
                array_push($list_classes, $val["cn"]);
            }
            $cns_eleves = array();
            foreach ($list_classes as $key => $value) {
                $cn_of_classe = search_ad($config, "*", "memberof", $value);
                $cns_eleves = array_merge($cn_of_classe, $cns_eleves);
            }
            // Recherche des Eleves qui ne sont pas affectes a une classe
            $people_new_members = array();
            foreach ($tous_cns_eleves as $key => $value) {
                if (!in_array($value, $cns_eleves))
                    array_push($people_new_members, $value);
            }
            usort($people_new_members, "cmp_nom");
        }

        // Affichage de la liste dans une boite de selection
        if (count($people_new_members) > 15)
            $size = 15;
        else
            $size = count($people_new_members);
        if (count($people_new_members) > 0) {
            $form = "<form action=\"add_list_users_group.php\" method=\"post\">\n";
            $form .= "<p>" . gettext("S&#233;lectionnez les membres &#224; ajouter au groupe :") . "</p>\n";
            $form .= "<p><select size=\"" . $size . "\" name=\"new_cns[]\" multiple=\"multiple\">\n";
            echo $form;
            for ($loop = 0; $loop < count($people_new_members); $loop++) {
                echo "<option value=" . $people_new_members[$loop]["cn"] . ">" . $people_new_members[$loop]["fullname"];
            }
            $form = "</select></p>\n";
            $form .= "<input type=\"hidden\" name=\"cn\" value=\"$cn\">\n";
            $form .= "<input type=\"hidden\" name=\"add_list_users_group\" value=\"true\">\n";
            $form .= "<input type=\"reset\" value=\"" . gettext("R&#233;initialiser la s&#233;lection") . "\">\n";
            $form .= "<input type=\"submit\" value=\"" . gettext("Valider") . "\">\n";
            $form .= "</form>\n";
            echo $form;
        }
        else {
            echo "<font color=\"orange\">" . gettext("Vous ne pouvez pas ajouter d'&#233;l&#232;ves car il n'existe plus d'&#233;l&#232;ves non affect&#233;s &#224; des classes !!") . "</font><BR>";
        }
    }
    else {
        // Ajout des membres au groupe
        echo "<H4>" . gettext("Ajout des membres au groupe :") . " <A href=\"group.php?filter=$cn\">$cn</A></H4>\n";
        for ($loop = 0; $loop < count($new_cns); $loop++) {
            $nomComplet = search_ad($config, $new_cns[$loop], "user");
            echo gettext("Ajout de l'utilisateur") . "&nbsp;" . $nomComplet[0]["fullname"] . "&nbsp;";
            if (groupaddmember($config, $new_cns[$loop], $cn) == 1) {
                echo "<strong>" . gettext("R&#233;ussi") . "</strong><BR>";
            }
            else {
                echo "</strong><font color=\"orange\">" . gettext("Echec") . "</font></strong><BR>";
                $err++;
            }
        }
    }
}
else {
    echo "<div class=error_msg>" . gettext("Cette application, n&#233;cessite les droits d'administrateur du serveur SambaEdu !") . "</div>";
}

include ("pdp.inc.php");
?>