<?php

 /**
 * Ajoute des utilisateurs aux groupes dans l'annuaire
 * @Version 11/2018 - keyser
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: add_user_group.php
 */

  include "entete.inc.php";
  include_once "ldap.inc.php";
  include "ihm.inc.php";

  require_once ("lang.inc.php");
  bindtextdomain('sambaedu-core', "/var/www/sambaedu/locale");
  textdomain('sambaedu-core');


  //Aide
  $_SESSION["pageaide"]="Annuaire";

  echo "<h1>".gettext("Annuaire")."</h1>\n";

  aff_trailer ("3");


if (!have_right($config, "se3_is_admin")) {
    echo ("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction");
    include ("pdp.inc.php");
    die();
}
$cn=isset($_GET['cn']) ? $_GET['cn'] : (isset($_POST['cn']) ? $_POST['cn'] : "");
$filtre=isset($_GET['filtre']) ? $_GET['filtre'] : (isset($_POST['filtre']) ? $_POST['filtre'] : "");

$add_user_group= $_POST['add_user_group'] ?? "";
$categorie= $_POST['categorie'] ?? "";
$new_categorie= $_POST['new_categorie'] ?? "";
$classe_gr= $_POST['classe_gr'] ?? array();
$matiere_gr= $_POST['matiere_gr'] ?? array();
$cours_gr= $_POST['cours_gr'] ?? array();
$autres_gr= $_POST['autres_gr'] ?? array();
$equipe_gr= $_POST['equipe_gr'] ?? array();
$remplacant= $_POST['remplacant'] ?? "";
$err="";

$filter=isset($_POST['filter']) ? $_POST['filter'] : "";

//debug_var();

//echo "\$filtre=$filtre<br />";

if ( !$add_user_group ) {
    // Ajout de groupes
    $user = search_user($config, $cn);
    // Affichage du nom et de la description de l'utilisateur
    echo "<H2>".$user["fullname"]."</H2>\n";
    // Recherche si le user appartient a une categorie principale
    if (is_prof($config,$cn)) $categorie="Profs";
    elseif (is_eleve($config,$cn)) $categorie="Eleves";
    else $categorie="Administratifs";
//var_dump($categorie);

    // Recherche si le user appartient a une categorie principale

    // Affichage boite de reaffectation du groupe principal
    if ( $categorie ) {
        echo "<table>
        <tr>
          <td><u>".gettext("Membre de la cat&#233;gorie")."</u> :&nbsp;</td>
          <td>
            <form action=\"add_user_group.php?cn=$cn\" method=\"post\">
            <select name=\"new_categorie\">
        \n";

        if ($categorie == gettext("Administratifs") ) {
                echo "<option>".gettext("Administratifs")."</option>
                <option>".gettext("Profs")."</option>
                <option>".gettext("Eleves")."</option>\n";
        } elseif ($categorie == gettext("Profs") ) {
                echo "<option>".gettext("Profs")."</option>
                <option>".gettext("Administratifs")."</option>
                <option>".gettext("Eleves")."</option>\n";
        } else {
                echo "<option>".gettext("Eleves")."</option>
                <option>".gettext("Profs")."</option>
                <option>".gettext("Administratifs")."</option>\n";
        }
        echo"        </select>
        </td>
        </tr>
        </table><br>\n";
    } else {
        // Affichage du menu d'affectation de l'utilisateur a une categorie principal
        echo "<table>
        <tr>
          <td><u>".gettext("Affectation de l'utilisateur &#224; une cat&#233;gorie")." </u> :&nbsp;</td>
          <td>
            <form action=\"add_user_group.php?cn=$cn\" method=\"post\">
            <select name=\"new_categorie\">
              <option>".gettext("Eleves")."</option>
              <option>".gettext("Profs")."</option>
              <option>".gettext("Administratifs")."</option>
            </select>
         </td>
        </tr>
        </table><br>\n";
    }

        // Affichage des groupes secondaires
        $user = search_user($config, $cn, true);
        $groups = $user['memberof'] ?? array();

        $list_current_rights = array();
        $list_current_groups = array();
        $rights_branch= $config['dn']['rights'];
        //var_dump($rights_branch);
        if (isset($groups)) {
            foreach ($groups as $line) {
                if (preg_match("/$rights_branch/i", $line)) {
                    $list_current_rights[] = ldap_dn2cn($line);
                } else {
                    $list_current_groups[] = ldap_dn2cn($line);
                }
            }
        }

    if ( count($list_current_groups) > 1  ) {
      //var_dump($list_current_groups);
        echo "<U>".gettext("Membre des groupes secondaires")."</U> :<BR><UL>\n";
        for ($loop=0; $loop < count ($list_current_groups) ; $loop++) {
            if ( ($list_current_groups[$loop] != "Profs") && ($list_current_groups[$loop] != "Eleves") && ($list_current_groups[$loop] != "Administratifs") ) {
                echo "<LI><A href=\"group.php?filter=".$list_current_groups[$loop]."\">".$list_current_groups[$loop]."</A>,<font size=\"-2\"> ";
                //$login=preg_split ("#\,#",ldap_dn2ufn($list_current_groups[$loop]["owner"]),2);
                //if ($login[0] == $cn) echo "<strong><font color=\"#ff8f00\">&nbsp;(".gettext("professeur principal").")</font></strong>";
                echo "</font></LI>\n";
                // constitution d'un filtre pour exclure les groupes d'appartenance
                // de la liste des groupes proposes
                $filter = $filter."(!(cn=".$list_current_groups[$loop]."))";
            }
        }
        echo "</UL>";
    }

    if ( $categorie ) {
            //echo "\$filtre=$filtre<br />";

    // Etablissement des listes des groupes disponibles

        // nouvelle entree
        $cours_gr=$classe_gr=$equipe_gr=$matiere_gr=$autres_gr="";
// Affichage des boites de selection des nouveaux groupes secondaires
      		?>
<!-- Partie 1 du talbeau avec les titres -->
    <h4><?php echo gettext("Ajouter aux groupes secondaires :"); ?></h4>
     <table border="0" cellspacing="10">
      <thead>
        <tr>
          <?php
            if ( $categorie == "Eleves" ) {
                echo "<td>".gettext("Classes")."</td>";
                echo "<td>".gettext("Cours")."</td>";

            } else {
                echo "<td>".gettext("Classes")."</td>";
                echo "<td>".gettext("Cours")."</td>";
                echo "<td>".gettext("Equipes")."</td>";
                echo "<td>".gettext("Matieres")."</td>"; }

            ?>
            <td><?php echo gettext("Autres"); ?></td>
            </tr>
            </thead>
            <tbody>
            <tr>
            <td valign="top">

                <?php
// Partie 2 du tableau avec les éléments


        echo "<select name= \"classe_gr[]\" value=\"$classe_gr\" size=\"10\" multiple=\"multiple\">\n";
        $list_classes_all=search_ad($config, "*", "classe") ;
        # Construction du tableau san les groupes déja attribués
        $list_classes = array();
        foreach ($list_classes_all as $key => $value) {
                if (!in_array($value['cn'], $list_current_groups))
                    array_push($list_classes, $value['cn']);
            }
        asort($list_classes);
        for ($loop=0; $loop < count ($list_classes) ; $loop++) {
            echo "<option value=".$list_classes[$loop].">".$list_classes[$loop];
        }
        echo "</select>";
        echo "</td>";



    // Partie commune

    // Affichage Select groupe cours
    echo "<td>\n";
    echo "<select name= \"cours_gr[]\" value=\"$cours_gr\" size=\"10\" multiple=\"multiple\">\n";
    //$list_cours=search_ad($config, "*", "cours") ;
    $list_cours_all = filter_group($config, "(cn=Cours*)");
    # Construction du tableau san les groupes déja attribués
        $list_cours = array();
        foreach ($list_cours_all as $key => $value) {
                if (!in_array($value['cn'], $list_current_groups))
                    array_push($list_cours, $value['cn']);
            }
        asort($list_cours);
        for ($loop=0; $loop < count ($list_cours) ; $loop++) {
            echo "<option value=".$list_cours[$loop].">".$list_cours[$loop];
        }
    echo "</select>";
    echo "</td>";

    // Partie profs et administratifs
    if ( $categorie == "Profs" || $categorie == "Administratifs" || !$categorie) {
        // Affichage Select groupe equipes
        echo "<td>\n";
        echo "<select name= \"equipe_gr[]\" value=\"$equipe_gr\" size=\"10\" multiple=\"multiple\">\n";
        $list_equipes_all=search_ad($config, "*", "equipe") ;
        # Construction du tableau san les groupes déja attribués
        $list_equipes = array();
        foreach ($list_equipes_all as $key => $value) {
                if (!in_array($value['cn'], $list_current_groups))
                    array_push($list_equipes, $value['cn']);
            }
        asort($list_equipes);
        for ($loop=0; $loop < count ($list_equipes) ; $loop++) {
            echo "<option value=".$list_equipes[$loop].">".$list_equipes[$loop];
        }
        echo "</select>";
        echo "</td>";

        // Affichage Select groupe matieres
        echo "<td>\n";
        echo "<select name=\"matiere_gr[]\" value=\"$matiere_gr\" size=\"10\" multiple=\"multiple\">";
        $list_matieres_all=search_ad($config, "*", "matiere") ;
        # Construction du tableau san les groupes déja attribués
        $list_matieres = array();
        foreach ($list_matieres_all as $key => $value) {
                if (!in_array($value['cn'], $list_current_groups))
                    array_push($list_matieres, $value['cn']);
            }
        asort($list_matieres);
        for ($loop=0; $loop < count ($list_matieres) ; $loop++) {
            echo "<option value=".$list_matieres[$loop].">".$list_matieres[$loop];
        }
        echo "</select>";
        echo "</td>";
    }

    // Partie communue groupes autres
    // Affichage Select groupe principaux, projets et autres
    echo "<td valign=\"top\">
    <select name=\"autres_gr[]\" value=\"$autres_gr\" size=\"10\" multiple=\"multiple\">";
    $list_autres_all=search_ad($config, "*", "projet") ;
    # Construction du tableau san les groupes déja attribués
    $list_autres = array();
    foreach ($list_autres_all as $key => $value) {
            if (!in_array($value['cn'], $list_current_groups))
                array_push($list_autres, $value['cn']);
        }
    asort($list_autres);
    for ($loop=0; $loop < count ($list_autres) ; $loop++) {
        echo "<option value=".$list_autres[$loop].">".$list_autres[$loop];
    }
    $list_autres_all=search_ad($config, "*", "autre") ;
    // Construction du tableau san les groupes déja attribués
    $list_autres = array();
    foreach ($list_autres_all as $key => $value) {
            if (!in_array($value['cn'], $list_current_groups))
                array_push($list_autres, $value['cn']);
        }
    asort($list_autres);
    for ($loop=0; $loop < count ($list_autres) ; $loop++) {
        echo "<option value=".$list_autres[$loop].">".$list_autres[$loop];
    }
    ?>

      </select>
      </td>
    </tr>
    <tr>
      <td>
      <input type="reset" value="<?php echo gettext("R&#233;initialiser la s&#233;lection"); ?>">
      </td>
    <?php } else { ?>
    <table>
    <tr>
    <?php } ?>
    <td >
    <input type="hidden" name="categorie" value="<?php echo $categorie ?>">
    <input type="hidden" name="add_user_group" value="true">
    <input type="submit" value="<?php echo gettext("Lancer la requ&#234;te"); ?>">
    </td>
    </tr>
    </table>
    </form>

    <?php
    echo "</small>";
    //nouvelle entree fin

    // Formulaire
    echo "<FORM action=\"add_user_group.php?cn=$cn\" method=\"post\">\n";
    echo "</P></FORM>\n";

        } else {
            // Reaffectation de l'utilisateur dans une nouvelle categorie
            if ( $categorie && ($categorie !=  $new_categorie) ) {
                    // Suppression de l'utilisateur de la categorie $categorie
                    groupdelmember($config, $cn, $categorie);
                    //exec ("/usr/share/se3/sbin/groupDelUser.pl $cn $categorie",$AllOutPut,$ReturnValue0);
                    // Affectation de l'utilisateur a la categorie $new_categorie
                    //exec("/usr/share/se3/sbin/groupAddUser.pl $cn $new_categorie" ,$AllOutPut,$ReturnValue1);
                    if (groupaddmember($config, $cn, $new_categorie) == 1) {
                            echo gettext("L'utilisateur")." <a href='add_user_group.php?cn=$cn'>$cn</a> ".gettext("a &#233;t&#233; r&#233;affect&#233; de la cat&#233;gorie")." <b>$categorie</b> ".gettext("&#224; la cat&#233;gorie")." <b>$new_categorie</b>.</BR></BR>\n";
                    } else {
                            echo "<br>";
                            echo "<div class=error_msg>".gettext("La r&#233;affectation de cat&#233;gorie ")." $categorie ".gettext("vers")." $new_categorie ".gettext(" de l'utilisateur ");
                            //echo "<font color='#0080ff'>$cn</font> ".gettext(" &#224; &#233;chou&#233;e.<br> veuillez contacter")." <A HREF='mailto:$MelAdminLCS?subject=PB ".gettext("Reaffectation categorie")." $categorie ".gettext("vers")." $new_categorie ".gettext("de")." $cn'>".gettext("l'administrateur du syst&#232;me")."</A></div><BR>\n";
                    }
            } elseif (!$categorie && $new_categorie ) {
                    //exec("/usr/share/se3/sbin/groupAddUser.pl $cn $new_categorie" ,$AllOutPut,$ReturnValue);
                    if (groupaddmember($config, $cn, $new_categorie) == 1) {
                        echo "<strong>" . gettext("R&#233;ussi") . "</strong><BR>";
                    }
                    else {
                        echo "</strong><font color=\"orange\">" . gettext("Echec") . "</font></strong><BR>";
                        $err++;
                    }
            }

            // Ajout des groupes secondaires

            // Classe
            echo "<br>";
            echo gettext("L'utilisateur")." <a href='people.php?cn=$cn'>$cn</a> ";
            if (count($classe_gr) > 0 || count($matiere_gr) > 0 || count($cours_gr) > 0  || count($equipe_gr) > 0 || count($autres_gr) > 0 )
                    echo gettext("a &#233;t&#233; ajout&#233; dans les")." <a href='add_user_group.php?cn=$cn'>".gettext("groupes secondaires")."</a> :<BR>";
            else echo gettext("n'a &#233;t&#233; ajout&#233; dans aucun")." <a href='add_user_group.php?cn=$cn'>".gettext("groupe secondaire")."</a>.<BR>";

            if (count($classe_gr) ) {
                    for ($loop=0; $loop < count ($classe_gr) ; $loop++) {
                            //exec("/usr/share/se3/sbin/groupAddUser.pl $cn $classe_gr[$loop]" ,$AllOutPut,$ReturnValue);
                            echo $classe_gr[$loop]."&nbsp;";
                            if (groupaddmember($config, $cn, $classe_gr[$loop]) == 1) {
                                    echo "<stong><strong>".gettext("R&#233;ussi")."</strong></strong><BR>";
                            } else { echo "<font color=\"orange\">".gettext("Echec")."</font><BR>"; $err++; }
                    }
            }

            // Matiere
            if (count($matiere_gr) ) {
                    for ($loop=0; $loop < count ($matiere_gr) ; $loop++) {
                            //exec("/usr/share/se3/sbin/groupAddUser.pl $cn $matiere_gr[$loop]" ,$AllOutPut,$ReturnValue);
                            echo $matiere_gr[$loop]."&nbsp;";
                            if (groupaddmember($config, $cn, $matiere_gr[$loop]) == 1) {
                                    echo "<strong>".gettext("R&#233;ussi")."</strong><BR>";
                            } else { echo "</strong><font color=\"orange\">".gettext("Echec")."</font></strong><BR>"; $err++; }
                    }
            }

            // Cours
            if (count($cours_gr) ) {
                    for ($loop=0; $loop < count ($cours_gr) ; $loop++) {
                            //exec("/usr/share/se3/sbin/groupAddUser.pl $cn $cours_gr[$loop]" ,$AllOutPut,$ReturnValue);
                            echo $cours_gr[$loop]."&nbsp;";
                            if (groupaddmember($config, $cn, $cours_gr[$loop]) == 1) {
                                    echo "<strong>".gettext("R&#233;ussi")."</strong><BR>";
                            } else { echo "</strong><font color=\"orange\">".gettext("Echec")."</font></strong><BR>"; $err++; }
                    }
            }

            // Equipe
            if (count($equipe_gr) ) {
                    for ($loop=0; $loop < count ($equipe_gr) ; $loop++) {
                            //exec("/usr/share/se3/sbin/groupAddUser.pl $cn $equipe_gr[$loop]" ,$AllOutPut,$ReturnValue);
                            echo $equipe_gr[$loop]."&nbsp;";
                            if (groupaddmember($config, $cn, $equipe_gr[$loop]) == 1) {
                                    echo "<strong>".gettext("R&#233;ussi")."</strong><BR>";
                            } else {
                                echo "</strong><font color=\"orange\">".gettext("Echec")."</font></strong><BR>";
                                $err++;
                                var_dump($cn);
                                var_dump($equipe_gr[$loop]);
                                //var_dump($cn);

                            }
                    }
            }

            // Autres
            if (count($autres_gr) ) {
                    for ($loop=0; $loop < count ($autres_gr) ; $loop++) {
                            //exec("/usr/share/se3/sbin/groupAddUser.pl $cn $autres_gr[$loop]" ,$AllOutPut,$ReturnValue);
                            echo $autres_gr[$loop]."&nbsp;";
                            if (groupaddmember($config, $cn, $autres_gr[$loop]) == 1) {
                                    echo "<strong>".gettext("R&#233;ussi")."</strong><BR>";
                            } else { echo "</strong><font color=\"orange\">".gettext("Echec")."</font></strong><BR>"; $err++; }
                    }
            }



    }


include ("pdp.inc.php");
?>
