<?php
/**
 * Modifie une entree utilisateur
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: mod_entry.php
 */
require_once "config.inc.php";
require "functions.inc.php";
require_once "ldap.inc.php";
require "ihm.inc.php";

require_once ("lang.inc.php");
bindtextdomain('se3-annu', "/var/www/se3/locale");
textdomain('se3-annu');

$login = isauth();
if ($login == "") {
    header("Location:$urlauth");
    exit;
}

// Recuperation des entrees de l'utilisateur a modifier

$people_attr = search_user($config, $login);
$people_attr["tel"] = $people_attr["tel"] ?? '';


if (have_right($config, "Annu_is_admin")) {
    // Redirection vers mod_user_entry.php
    header("Location:mod_user_entry.php?cn=$login");
}
else {
    // header_html();
    include ("entete.inc.php");

    // Aide
    $_SESSION["pageaide"] = "L\'interface_&#233;l&#232;ve#Modifier_mon_compte";

    // Variables
    $nom = isset($_POST['nom']) ? $_POST['nom'] : "";
    $prenom = isset($_POST['prenom']) ? $_POST['prenom'] : "";
    $telephone = isset($_POST['telephone']) ? $_POST['telephone'] : "";
    $mod_entry = isset($_POST['mod_entry']) ? $_POST['mod_entry'] : "";

    echo "<h1>" . gettext("Annuaire") . "</h1>\n";

    aff_trailer("4");

    if (is_eleve($config, $login)) {
        ?>
        <table border="0" width="90%" align="center">
            <tbody>
                <tr>
                    <td width="27%">Login :&nbsp;</td>
                    <td width="73%" colspan="2"><tt><strong><?php echo $people_attr["cn"] ?></strong></tt></td>
        </tr>
        <tr>
            <td width="27%"><?php echo gettext("Pr&#233;nom"); ?> :&nbsp;</td>
            <td width="73%" colspan="2"><?php echo $people_attr["prenom"] ?></td>
        </tr>
        <tr>
            <td><?php echo gettext("Nom"); ?>&nbsp;:&nbsp;</td>
            <td colspan="2"><?php echo $people_attr["nom"] ?></td>
        </tr>
        <tr>
            <td><?php echo gettext("T&#233;l&#233;phone"); ?> :&nbsp;</td>
            <td colspan="2"><?php echo $people_attr["tel"] ?></td>
        </tr>
        </tbody>
        </table>
        <?php
        include ("pdp.inc.php");
        exit();
    }

    //====================================
    // Changement parametres  pour l'utilisateur de �base�
    // Interface pour permettre les modifs
    if ((!$mod_entry) || (!verifTel($telephone) || !verifEntree($nom) || !verifEntree($prenom) )) {
        ?>
        <form action="mod_entry.php" method="post">
            <table border="0" width="90%" align="center">
                <tbody>
                    <tr>
                        <td width="27%">Login :&nbsp;</td>
                        <td width="73%" colspan="2"><tt><strong><?php echo $people_attr["cn"] ?></strong></tt></td>
                </tr>
                <tr>
                    <td width="27%"><?php echo gettext("Pr&#233;nom"); ?> :&nbsp;</td>
                    <td width="73%" colspan="2"><input type="text" name="prenom" value="<?php echo $people_attr["prenom"] ?>" size="20"></td>
                </tr>
                <tr>
                    <td><?php echo gettext("Nom"); ?>&nbsp;:&nbsp;</td>
                    <td colspan="2"><input type="text" name="nom" value="<?php echo $people_attr["nom"] ?>" size="20"></td>
                </tr>
                <tr>
                    <td><?php echo gettext("T&#233;l&#233;phone"); ?> :&nbsp;</td>
                    <td colspan="2"><input type="text" name="telephone" value="<?php echo $people_attr["tel"] ?>" size="10"></td>
                </tr>
                <tr>
                    <td></td>
                    <td >
                        <input type="hidden" name="mod_entry" value="true">
                        <input type="submit" value="<?php echo gettext("Lancer la requ&#234;te"); ?>">
                    </td>
                    <td></td>
                </tr>
                </tbody>
            </table>
        </form>

        <?php
        if ($mod_entry && ((!verifEntree($nom) || !verifEntree($prenom) ) || (!verifTel($telephone) ) )) {
            // verification des saisies
            // nom prenom
            if (!verifEntree($nom) || !verifEntree($prenom)) {
                echo "<div class=\"error_msg\">" . gettext("Les champs nom et prenom, doivent comporter au minimum 4 caract&#232;res alphanum&#233;riques.") . "</div><BR>\n";
            }
            // tel
            if (!verifTel($telephone)) {
                echo "<div class=\"error_msg\">" . gettext("Le num&#233;ro de t&#233;l&#233;phone que vous avez saisi, n'est pas conforme.") . "</div><BR>\n";
            }
        }
        // fin verification des saisies
    }
    else {
        // Positionnement des entrees a modifier
        $entry["sn"] = utf8_encode($nom);
        $entry["givenname"] = utf8_encode($prenom);
        if ($telephone && verifTel($telephone)) {
            $entry["telephonenumber"] = $telephone;
        }

        if (modify_ad($config, $people_attr["cn"], "user", $entry)) {

            echo "<strong>" . gettext("Vos entr&#233;es ont &#233;t&#233; modifi&#233;e avec succ&#232;s.") . "</strong><BR>\n";
        }
        else {
            echo "<strong>" . gettext("Echec de la modification, veuillez contacter") .  gettext("l'administrateur du syst&#232;me") . "</A><BR>\n";
        }

        // Fin modifications
    }
}


include ("pdp.inc.php");
?>
