<?php

/**

 * Affiche une liste d'utilisateurs a partir de l'annuaire
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: peoples_list.php
 */

include "entete.inc.php";
include_once "ldap.inc.php";
include "ihm.inc.php";
require_once ("lang.inc.php");
bindtextdomain('se3-annu', "/var/www/se3/locale");
textdomain('se3-annu');
$filter_people = '';
//tableau de profs
$lesprofs = search_ad($config, "*", "memberof", "Profs");
$list_prof_grp = array();
foreach ($lesprofs as $key => $value) {
    $list_prof_grp[$key] = $value["cn"];
}

if ((have_right($config, "annu_is_admin")) || (have_right($config, "annu_can_read")) || (have_right($config, "sovajon_is_admin"))) {

    $priority_surname = $_POST['priority_surname'] ?? '';
    $fullname = $_POST['fullname'] ?? '';
    $priority_name = $_POST['priority_name'] ?? '';
    $nom = $_POST['nom'] ?? '';
    $priority_classe = $_POST['priority_classe'] ?? '';
    $classe = $_POST['classe'] ?? '';

    // Aide
    $_SESSION["pageaide"] = "Annuaire";

    echo "<h1>" . gettext("Annuaire") . "</h1>\n";

    echo "<div style='float:right; width:16px; '><a href='add_user.php' title='Ajouter un utilisateur'><img src='/elements/images/add.png' width='16px' height='16px'  alt='Ajouter un utilisateur' /></a></div>\n";

    // Convertion en utf_8
    $nom = utf8_encode($nom);
    $fullname = utf8_encode($fullname);

    // Construction du filtre de la branche people
    if ($nom && !$fullname) {
        // Recherche sur sn
        if ($priority_name == "contient") {
            $filter_people = "(sn=*$nom*)";
        }
        elseif ($priority_name == "commence") {
            $filter_people = "(sn=$nom*)";
        }
        else {
            $filter_people = "(sn=*$nom)";
        }
    }
    elseif ($fullname && !$nom) {
        // Recherche sur cn
        if ($priority_surname == "contient") {
            $filter_people = "(displayname=*$fullname*)";
        }
        elseif ($priority_surname == "commence") {
            $filter_people = "(displayname=$fullname*)";
        }
        else {
            $filter_people = "(displayname=*$fullname)";
        }
    }
    elseif ($fullname && $nom) {
        // Recherche sur sn ET cn
        if ($priority_name == "contient") {
            if ($priority_surname == "contient") {
                $filter_people = "(&(sn=*$nom*)(displayname=*$fullname*))";
            }
            elseif ($priority_surname == "commence") {
                $filter_people = "(&(sn=*$nom*)(displayname=$fullname*))";
            }
            else {
                $filter_people = "(&(sn=*$nom*)(displayname=*$fullname))";
            }
        }
        elseif ($priority_name == "commence") {
            if ($priority_surname == "contient") {
                $filter_people = "(&(sn=$nom*)(displayname=*$fullname*))";
            }
            elseif ($priority_surname == "commence") {
                $filter_people = "(&(sn=$nom*)(displayname=$fullname*))";
            }
            else {
                $filter_people = "(&(sn=$nom*)(displayname=*$fullname))";
            }
        }
        else {
            if ($priority_surname == "contient") {
                $filter_people = "(&(sn=*$nom)(displayname=*$fullname*))";
            }
            elseif ($priority_surname == "commence") {
                $filter_people = "(&(sn=*$nom)(displayname=$fullname*))";
            }
            else {
                $filter_people = "(&(sn=*$nom)(displayname=*$fullname))";
            }
        }
    }

    // Remplacement de *** ou ** par *
    $filter_people = preg_replace("/\*\*\*/", "*", $filter_people);
    $filter_people = preg_replace("/\*\*/", "*", $filter_people);
    if ($filter_people && !$classe) {
        $peuple = search_ad($config, $filter_people, "filter", $config['dn']['people']);
        foreach ($peuple as $key => $value) {
            $users[$key] = search_user($config, $value["cn"]);
        }
        @usort($users, "cmp_nom");
        // Affichage menu haut de page
        aff_trailer("3");

        if (is_array($users)) {
            if (count($users) == 1) {
                echo "<p><STRONG>" . count($users) . "</STRONG>" . gettext(" utilisateur r&#233;pond &#224; ces crit&#232;res de recherche") . "</p>\n";
            }
            else {
                echo "<p><STRONG>" . count($users) . "</STRONG>" . gettext(" utilisateurs r&#233;pondent &#224; ces crit&#232;res de recherche") . "</p>\n";
            }
            for ($loop = 0; $loop < count($users); $loop ++) {

                if (in_array($users[$loop]["cn"], $list_prof_grp)) {
                    echo "<img src=\"images/gender_teacher.gif\" width=18 height=18 hspace=1 border=0>\n";
                }
                else {
                    if ($users[$loop]["sexe"] == "F") {
                        echo "<img src=\"images/gender_girl.gif\" width=14 height=14 hspace=3 border=0>\n";
                    }
                    else {
                        echo "<img src=\"images/gender_boy.gif\" width=14 height=14 hspace=3 border=0>\n";
                    }
                }
                echo "<A href=\"people.php?cn=" . $users[$loop]["cn"] . "\">" . $users[$loop]["fullname"] . " (" . $users[$loop]["cn"] . ")</A></br>\n";
            }
        }
        else {
            echo " <STRONG>" . gettext("Pas de r&#233;sultats") . "</STRONG>" . gettext(" correspondant aux crit&#232;res s&#233;lectionn&#233;s.") . "<BR>\n";
        }
    }
    elseif ($classe) {
        aff_trailer("3");
        // Recherche des classes et equipes dans la branche groups de l'annuaire
        if ($priority_classe == "contient") {
            $filter_classe = "(cn=Classe_*$classe*)";
        }
        elseif ($priority_classe == "commence") {
            $filter_classe = "(cn=Classe_$classe*)";
        }
        else {
            $filter_classe = "(cn=Classe_*$classe)";
        }
        // Remplacement de *** ou ** par *
        $filter_classe = preg_replace("/\*\*\*/", "*", $filter_classe);
        $filter_classe = preg_replace("/\*\*/", "*", $filter_classe);
        //recherches des classes
        $groups = filter_group($config, $filter_classe);
        $people = array();
        for ($loop = 0; $loop < count($groups); $loop++) {
            $peuple = search_people_group($config, $groups[$loop]["cn"]);
            foreach ($peuple as $key => $value) {
                $peuple[$key]["group"] = $groups[$loop]["cn"];
            }
            $people = array_merge($peuple, $people);
        }

        if (count($people)) {
            if (count($people) == 1) {
                echo "<p><STRONG>" . count($people) . "</STRONG>" . gettext(" utilisateur r&#233;pond &#224; ces crit&#232;res de recherche.") . "</p>\n";
            }
            else {
                echo "<p><STRONG>" . count($people) . "</STRONG>" . gettext(" utilisateurs r&#233;pondent &#224; ces crit&#232;res de recherche.") . "</p>\n";
            }
            // affichage des resultats
            for ($loop = 0; $loop < count($people); $loop ++) {
                if ($loop == 0 || $people[$loop]["group"] != $people[$loop - 1]["group"]) {
                    echo "<BR><U>Classe</U> : " . $people[$loop]["group"] . "<BR>\n";
                }

                if (in_array($people[$loop]["cn"], $list_prof_grp)) {
                    echo "<img src=\"images/gender_teacher.gif\" width=18 height=18 hspace=1 border=0>\n";
                }
                else {
                    if ($people[$loop]["sexe"] == "F") {
                        echo "<img src=\"images/gender_girl.gif\" width=14 height=14 hspace=3 border=0>\n";
                    }
                    else {
                        echo "<img src=\"images/gender_boy.gif\" width=14 height=14 hspace=3 border=0>\n";
                    }
                }
                echo "<A href=\"people.php?cn=" . $people[$loop]["cn"] . "\">" . $people[$loop]["fullname"] . "</A><BR>\n";
            }
        }
        else {
            echo " <STRONG>" . gettext("Pas de r&#233;sultats") . "</STRONG>" . gettext(" correspondant aux crit&#232;res s&#233;lectionn&#233;s.") . "<BR>
	                  " . gettext("Retour au") . " <A href=\"annu.php\">" . gettext("formulaire de recherche") . "</A>...<BR>\n";
        }
    }
    else {
        // Aucun criteres de recherche
        echo " <STRONG>" . gettext("Pas de r&#233;sultats !") . "</STRONG><BR>
	       	" . gettext("Veuillez compl&#233;ter au moins l'un des trois champs (nom, pr&#233;nom, classe) du") . " <A href=\"annu.php\">" . gettext("formulaire de recherche") . "</A> !<BR>\n";
    }
}

include ("pdp.inc.php");
?>