<?php

/**
* Reinitialisation/Modification des mots de passe
* @Version 02/2020 - keyser
* @Projet SambaEdu
* @Auteurs Equipe Sambaedu
* @Licence Distribue sous la licence GPL
* @Repertoire: /
* file: reinit_mdp.php
*/	

require ("entete.inc.php");
require ("ihm.inc.php");
require ("fonc_outils.inc.php");

bindtextdomain('sambaedu-core', "/var/www/sambaedu/locale");
textdomain('sambaedu-core');

// aide en ligne
$_SESSION["pageaide"]="Annuaire";
//debug_var();
function genere_passwd($config, array $user)
{
    $pwdPolicy=$config['pwdPolicy'];
    switch ($pwdPolicy) {
    case 0: // date de naissance
        $userpwd =  $user['date'];
        echo gettext("Mot de passe de <b>" .$user['cn'] . "</b> réinitialisé à la date de naissance : <b>" . $userpwd . "</b><br>");
        break;
    case 1: // semi-aleatoire
        $userpwd = create_random_password(8, false);
        echo gettext("Mot de passe de <b>" .$user['cn'] . "</b> r&#233;initialis&#233; &#224; : <b>" . $userpwd . "</b><br>");
        break;
    case 2: // aleatoire
        $userpwd = create_random_password(8, true);
        break;
        echo gettext("Mot de passe de <b>" .$user['cn'] . "</b> r&#233;initialis&#233; &#224; : <b>" . $userpwd . "</b><br>");
    }
    usersetpassword($config, $user['cn'], $userpwd, true);
    return($userpwd);
}


if (!have_right($config, "annu_is_admin")) {
	die (gettext("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction")."</BODY></HTML>");
}
echo "<h1>".gettext("R&#233;initialisation/modification de mots de passe")."</h1>\n";
$pwdPolicy=$config['pwdPolicy'];

//==========================================================
// Phase de choix des parametres
if(!isset($_POST['is_posted'])) {
	//echo "<center>\n";
	echo "<form action=\"".$_SERVER['PHP_SELF']."\" enctype='multipart/form-data' method=\"post\">\n";

	echo "<p>Cette page est destin&#233;e &#224; r&#233;initialiser/modifier les mots de passe par lots.</p>\n";
	echo "<p>Vous pouvez&nbsp;:</p>\n";
	echo "<table summary='Choix du mode'>\n";
//	echo "<tr>\n";
//	echo "<td valign='top'><input type='radio' name='reinit_mode' id='reinit_mode_naissance' value='naissance' onchange='teste_radio()' checked /></td><td><label for='reinit_mode_naissance'> r&#233;initialiser les mots de passe &#224; la date de naissance pour un ou des groupes.</label></td>\n";
//	echo "</tr>\n";
	echo "<tr>\n";
	echo "<td valign='top'><input type='radio' name='reinit_mode' id='reinit_mode_alea' checked='checked'";

	switch ($pwdPolicy) {
	    case 0:
	        echo " value='naissance'";
	        break;
	    case 1:
	        echo " value='semi'";
	        break;
	    case 2:
	        echo " value='alea'";
	        break;
	}

	echo "onchange='teste_radio()' /></td><td><label for='reinit_mode_alea'> modifier les mots de passe pour un ou des groupes.</label><br />";
	echo "<span style='color:#FF9900;'>La politique de mot de passe actuelle est : ";

	switch ($pwdPolicy) {
	    case 0:
	        echo "bas&#233;e sur la date de naissance";
	        break;
	    case 1:
	        echo "semi-al&#233;atoire (6 car.)";
	        break;
	    case 2:
	        echo "al&#233;atoire (8 car.)";
	        break;
	}

	echo "</span></td>\n";
	echo "</tr>\n";
//	echo "<tr>\n";
//	echo "<td valign='top'><input type='radio' name='reinit_mode' id='reinit_mode_csv' value='csv' onchange='teste_radio()' /></td><td><label for='reinit_mode_csv'> imposer les mots de passe d'apr&#232;s un fichier CSV au format&nbsp;: <b>LOGIN;MOTDEPASSE;</b></label><br />\n";
//	echo "Le point-virgule en fin de ligne est recommand&#233; pour &#233;viter des blagues avec les fins de lignes DO$/Unix.<br />\n";
//	echo "Fichier CSV&nbsp;: <input type='file' name='fich_csv_reinit' onfocus=\"document.getElementById('reinit_mode_csv').checked=true; teste_radio();\" />\n";
//	echo "</td>\n";
//	echo "</tr>\n";
	echo "</table>\n";


	echo "<div id='div_choix_groupes'>\n";
        affiche_all_groups($config, "left", "user");
        
	echo "<div id=\"attribution\" align='center'>\n";
	echo "<input type=\"hidden\" name=\"is_posted\" value=\"1\">\n";
	echo "<input type=\"submit\" value=\"".gettext("Valider")."\">\n";
	echo "<input type=\"reset\" value=\"".gettext("R&#233;initialiser")."\">\n";
	echo "</div>\n";

	echo "</div>\n";

	echo "<div id=\"div_validation\" align='center'>\n";
	echo "<input type=\"submit\" value=\"".gettext("Valider")."\">\n";
	echo "</div>\n";

	echo "</form>\n";

	echo "<script type='text/javascript'>
	function teste_radio() {
		/*if(document.getElementById('reinit_mode_naissance').checked==true) {
			document.getElementById('div_choix_groupes').style.display='';
			document.getElementById('div_validation').style.display='none';
		}*/

		if(document.getElementById('reinit_mode_alea').checked==true) {
			document.getElementById('div_choix_groupes').style.display='';
			document.getElementById('div_validation').style.display='none';
		}

		if(document.getElementById('reinit_mode_csv').checked==true) {
			document.getElementById('div_choix_groupes').style.display='none';
			document.getElementById('div_validation').style.display='';
		}
	}

	teste_radio();
</script>\n";

	
	include ("pdp.inc.php");
	die();
}
//==========================================================

// Phase de traitement

//echo "<center>\n";

$reinit_mode=isset($_POST['reinit_mode']) ? $_POST['reinit_mode'] : NULL;

if(!isset($reinit_mode)) {
	echo "<p style='color:red'>Le mode de r&#233;initialisation/changement des mots de passe n'a pas &#233;t&#233; choisi.</p>";
	echo "<p><a href='".$_SERVER['PHP_SELF']."'>Retour</a></p>";

	include ("pdp.inc.php");
	die();
}

$tab_reinit_mode=array('naissance','alea','semi','csv');

if(!in_array($reinit_mode, $tab_reinit_mode)) {
	echo "<p style='color:red'>Le mode de r&#233;initialisation/changement des mots de passe choisi est invalide.</p>";
	echo "<p><a href='".$_SERVER['PHP_SELF']."'>Retour</a></p>";

	include ("pdp.inc.php");
	die();
}


if($reinit_mode=='csv') {
	if($_FILES["fich_csv_reinit"]["name"]=="") {
		echo "<p style='color:red;'><b>ERREUR:</b> Aucun fichier n'a &#233;t&#233; fourni!</p>\n";
		echo "<p><a href='".$_SERVER['PHP_SELF']."'>Retour</a>.</p>\n";
		include ("pdp.inc.php");
		exit();
	}

	$tmp_csv_file=$HTTP_POST_FILES['fich_csv_reinit']['tmp_name'];
	$csv_file=$HTTP_POST_FILES['fich_csv_reinit']['name'];
	$size_ecsv_file=$HTTP_POST_FILES['fich_csv_reinit']['size'];

	if(($csv_file!='')&&($tmp_csv_file=='')) {
		echo "<p>L'upload du fichier <span style='color:red;'>$csv_file</span> a semble-t-il &eacute;chou&eacute;.</p>";

		$upload_max_filesize=ini_get('upload_max_filesize');
		$post_max_size=ini_get('post_max_size');

		echo "<p>Il se peut que le fichier fourni ait &eacute;t&eacute; trop volumineux.<br />PHP est actuellement param&eacute;tr&eacute; avec:<br />\n";
		echo "</p>\n";
		echo "<blockquote>\n";
		echo "<span style='color:blue;'>upload_max_filesize</span>=<span style='color:green;'>".$upload_max_filesize."</span><br />\n";
		echo "<span style='color:blue;'>post_max_size</span>=<span style='color:green;'>".$post_max_size."</span><br />\n";
		echo "</blockquote>\n";
		echo "<p>\n";
		echo "Si ces valeurs sont insuffisantes pour vos fichiers XML, il est possible de modifier les valeurs limites dans <span style='color:green;'>/etc/php5/apache2/php.ini</span>\n";
		echo "</p>\n";

		echo "<p><a href='".$_SERVER['PHP_SELF']."'>Retour</a>.</p>\n";
		include ("pdp.inc.php");
		exit();
	}

    $dossier_tmp="/var/lib/se3/import_comptes";
	$dest_file="$dossier_tmp/fichier_csv_reinit_mdp.csv";
	if(file_exists($dest_file)){
		unlink($dest_file);
	}

	if(is_uploaded_file($tmp_csv_file)){
		$source_file=stripslashes("$tmp_csv_file");
		$res_copy=copy("$source_file" , "$dest_file");

		echo "<h4>".gettext("Modification des mots de passe d'apr&#232;s le fichier CSV fourni")."</h4>\n";

		echo "<pre class='listing'>";
		system ("/usr/bin/sudo /usr/share/se3/scripts/se3_reinit_mdp.sh 'csv=$dest_file' 'nettoyage'");
		echo "</pre>\n";
		echo "<hr />\n";

	}
}
else {

       
    // Liste des groupes a traiter
    $classe_gr=isset($_POST['classe_gr']) ? $_POST['classe_gr'] : array();
    $equipe_gr=isset($_POST['equipe_gr']) ? $_POST['equipe_gr'] : array();
    $matiere_gr=isset($_POST['matiere_gr']) ? $_POST['matiere_gr'] : array();
    $autres_gr=isset($_POST['autres_gr']) ? $_POST['autres_gr'] : array();

    // On lance l'operation pour chaque groupe demande !!!

    if (count($classe_gr) ) {
        foreach ($classe_gr as $grp){
            echo "<h4>".gettext("R&#233;initialisation des mots de passe pour les membres du groupe ".$grp."&nbsp;:")."</h4>\n";
            echo "<pre class='listing'>";
            $members=list_members_group($config, $grp);
            foreach ($members as $user) {
                $pass_user=genere_passwd($config, $user);
            }
            echo "</pre>\n";
            echo "<hr />\n";
        }
    }

    if (count($equipe_gr) ) {
        foreach ($equipe_gr as $grp){
            echo "<h4>".gettext("R&#233;initialisation des mots de passe pour les membres du groupe ".$grp."&nbsp;:")."</h4>\n";
            echo "<pre class='listing'>";
            $members=list_members_group($config, $grp);
            foreach ($members as $user) {
                $pass_user=genere_passwd($config, $user);
            }
            echo "</pre>\n";
            echo "<hr />\n";
        }
    }


    if (count($matiere_gr) ) {
        foreach ($matiere_gr as $grp){
            echo "<h4>".gettext("R&#233;initialisation des mots de passe pour les membres du groupe ".$grp."&nbsp;:")."</h4>\n";
            echo "<pre class='listing'>";
            $members=list_members_group($config, $grp);
            foreach ($members as $user) {
                $pass_user=genere_passwd($config, $user);
            }
            echo "</pre>\n";
            echo "<hr />\n";
        }
    }


    if (count($autres_gr) ) {
        foreach ($autres_gr as $grp){
            echo "<h4>".gettext("R&#233;initialisation des mots de passe pour les membres du groupe ".$grp."&nbsp;:")."</h4>\n";
            echo "<pre class='listing'>";
            $members=list_members_group($config, $grp);
            foreach ($members as $user) {
                $pass_user=genere_passwd($config, $user);
            }
            echo "</pre>\n";
            echo "<hr />\n";
        }
    }
    echo "<p><a href='".$_SERVER['PHP_SELF']."'>Retour</a></p>";
}
//echo "</center>\n";

if (file_exists("/tmp/changement_mdp.csv")) {
//  dédoublonner les utilisateurs qui auraient été modifiés plusieurs fois : garder le dernier uniquement

    if ($hdle = fopen("/tmp/changement_mdp.csv", "r")) {

        $listing = array(array());  // une ligne par compte ; le deuxieme parametre est, dans l'ordre nom, prenom, classe (si groupe classe), cn, password
        array_splice($listing, 0, 1);

        while ($data = fgetcsv($hdle, 0, ";")) {
                // nom;prenom;cn;mdp;classe 
        $num = count($data);
        if ($num >= 5) {
                $nouveau = array('nom'=>"$data[0]", 'pre'=>"$data[1]", 'cla' => "$data[4]", 'cn'=>"$data[2]", 'pwd'=>"$data[3]");
                $doublon = false;
                foreach($listing as &$key) {
                        if ($key['cn'] == $nouveau['cn']){  // doublon
                                $doublon = true;
                                $key['pwd'] = $nouveau['pwd'];
                                //mettre à jour la classe si besoin ou la conserver
                                if ($nouveau['cla'] != '') { $key['cla'] = $nouveau['cla'] ;}
                                break;
                        }
                }
                unset($key);

                if (!$doublon) { $listing[] = $nouveau; }
        }

    }        
    fclose($hdle);
}	

// Lien pour la récupération du mailing
    if (count($listing, COUNT_RECURSIVE) > 1) {
        $serial_listing=serialize($listing);

        $lien="<a href=\"#\" onclick=\"document.getElementById('postlisting').submit(); return false;\" target=\"_blank\">T&#233;l&#233;charger le listing des mots de passe modifi&#233;s...</a>";

        echo("<table><tr><td><img src='../elements/images/pdffile.png'></td><td>");
        echo($lien);
        echo("<form id='postlisting' action='../annu/listing.php' method='post''>");
        echo("<input type='hidden' name='hiddeninput' value='$serial_listing' />");
        echo("<input type='checkbox' name='purge_csv_data' value='y' checked='checked' /> Purger le fichier temporaire apr&#232;s t&#233;l&#233;chargement du fichier");
        echo("<br />Il n'est peut-&#234;tre pas tr&#232;s prudent de conserver inutilement ces donn&#233;es sur le serveur");
        echo("</form></td></tr></table>");
    }
}
include ("pdp.inc.php");

?>

