<?php

/**

 * Permet de configurer certains éléments du serveur

 * @Projet SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: /
 * file: conf_params.php
 */
require_once "config.inc.php";
require_once "ldap.inc.php";
require ("entete.inc.php");
require_once ("lang.inc.php");
require_once ("samba.inc.php");
require_once ("partages.inc.php");
bindtextdomain('se4-core', "/var/www/sambaedu/locale");
textdomain('se4-core');
// debug_var();
// aide
$_SESSION["pageaide"] = "L\'interface_web_administrateur#Configuration_g.C3.A9n.C3.A9rale";

if (! have_right($config, "se3_is_admin")) {
    die(gettext("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction") . "</BODY></HTML>");
}

$action = $_GET['action'] ?? "";
$get_varb = $_GET['varb'] ?? "";
$get_valeur = $_GET['valeur'] ?? "";

// Change dans la base
if ($action == "change") {
    if ($get_varb == "UAI") {
        $get_valeur = strtoupper($get_valeur);
        if (! preg_match('/^\d{7}[A-Z]$/', $get_valeur)) {

            $get_valeur = "";
        }
    }
    if ($get_varb == "cnPolicy") {
        if (isset($_GET['activation_code']) && $_GET['activation_code'] != $config['activation_code']) {
            set_param($config, "activation_code", $_GET['activation_code']);
        }

        if (isset($_GET['no_passwd_change']) && $_GET['no_passwd_change'] != $config['no_passwd_change']) {
            set_param($config, "no_passwd_change", $_GET['activation_code']);
        } else {
            set_param($config, "no_passwd_change", "0");
        }
        set_config($get_varb, $get_valeur);
    }
    if ($get_varb == "proxy_type") {
        if ($get_valeur == "aucun") {
            set_param($config, "server_proxy", 0);
        } elseif ($get_valeur == "automatique") {
            if (!empty($config['proxy_address'])){
                $ip_amon =  $config['ip_amon'] ?? $config['proxy_address'] ?? $config['nameserver'];
                $ligne = exec("host " . $ip_amon . " " . $ip_amon);
                $amon_domain = substr(explode(".", explode(" ", $ligne)[4], 2)[1], 0, -1); 
            }
            $urls = [
                $_GET['proxy_url'] ?? "",
                "http://" . $config['proxy_address'] . "/wpad.dat",
                "http://wpad." . $amon_domain . "/wpad.dat",
                "http://wpad." . $config['domain'] . "/wpad.dat",
            ];
            require_once (dirname(__FILE__) . '/vendor/autoload.php');
            $client = new GuzzleHttp\Client();
            foreach ($urls as $url) {
                try {
                    $response = $client->request('GET', $url);
                    if ($response) {
                        break;
                    } else {
                        $url = false;
                    }
                } catch (Exception $e) {
                    $url = false;
                }
            }
            if ($url){
                set_param($config, "proxy_url", $url);
            } else {
                set_param($config, "proxy_url", "");
            }
        }
        if (isset($_GET['proxy_address']) && $_GET['proxy_address'] != $config['proxy_address']) {
            set_param($config, "proxy_address", $_GET['proxy_address']);
        }
        if (isset($_GET['proxy_port']) && $_GET['proxy_port'] != $config['proxy_port']) {
            set_param($config, "proxy_port", $_GET['proxy_port']);
        }

        if (isset($_GET['server_proxy'])) {
            if ($_GET['server_proxy'] != @$config['server_proxy']) {
                set_param($config, "server_proxy", $_GET['server_proxy']);
            }
        } else {
            set_param($config, "server_proxy", 0);
        }
        set_config($get_varb, $get_valeur);
    } else {
        set_config($get_varb, $get_valeur);
    }

/*    if ($get_varb == "ip_amon") {

       if (isset($config['ip_amon'])) {
            dns_wpad($config);
        }

        if (isset($get_valeur) && $get_valeur != "") {
            dns_wpad($config, $get_valeur);
        }
        set_config($get_varb, $get_valeur);
    }
*/
    if ($get_varb == "defaultintlevel") {
        setintlevel($get_valeur);
        set_config($get_varb, $get_valeur);
    }

    if ($get_varb == "autoriser_part_pub") {
        set_config($get_varb, $get_valeur);
        $dossier_pub = "/var/sambaedu/Docs/public";
        system("sudo mkdir -p $dossier_pub");
        system("sudo chown admin:domain\\ admins $dossier_pub");
        if ($get_valeur == "y") {
            $acls = array(
                "user::rwx",
                "user:admin:rwx",
                "group::rwx",
                "group:domain\\040admins:rwx",
                "mask::rwx",
                "other::rwx",
                "default:user::rwx",
                "default:user:admin:rwx",
                "default:group::rwx",
                "default:group:domain\\040admins:rwx",
                "default:mask::rwx",
                "default:other::rwx"
            );
            set_acls("$dossier_pub", $acls);
        } else {
            system("sudo setfacl -b $dossier_pub");
            system("sudo chmod 770 $dossier_pub");
            $acls = array(
                "user::rwx",
                "user:admin:rwx",
                "group::rwx",
                "group:domain\\040admins:rwx",
                "mask::rwx",
                "default:user:admin:rwx",
                "default:group:domain\\040admins:rwx",
                "default:mask::rwx"
            );
            set_acls("$dossier_pub", $acls);
        }
    }
    if ($get_varb == "admin_w") {
        $smbconf = read_smb_conf();
        if ($get_valeur == "y") {
            $smbconf['install']['read only'] = "no";
        } else {
            $smbconf['install']['read only'] = "yes";
        }
        write_smb_conf($smbconf);
    }

    // on recharge la config après modif
    $config = get_config(1);
}

echo "<h1>" . gettext("Param&#233;trage du serveur") . "</H1>\n";

// Affichage du form de mise a jour des paramatres
echo "<br><br>";
echo "<center>";
echo "<TABLE border=\"1\" width=\"80%\">\n";
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo gettext("Param&#233;trage de l'interface SambaEdu");
echo "</TD></TR>\n";

// Niveau d'interface
echo "<TR><TD>" . gettext("Niveau d'interface") . "</TD><TD align=\"center\">";
if ($action == "modif_intlevel") {
    // echo "<form method=\"get\" action=\"chlevel.php\">";

    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"defaultintlevel\">";
    echo "<select name =\"valeur\" ONCHANGE=\"this.form.submit();\">";
    echo "<option";
    if ($config['defaultintlevel'] == "1") {
        echo " selected";
    }
    echo " value=\"1\">" . gettext("D&#233;butant") . "</option>";
    echo "<option";
    if ($config['defaultintlevel'] == "2") {
        echo " selected";
    }
    echo " value=\"2\">" . gettext("Interm&#233;diaire") . "</option>";
    echo "<option";
    if ($config['defaultintlevel'] == "3") {
        echo " selected";
    }
    echo " value=\"3\">" . gettext("Confirm&#233;") . "</option>";
    echo "<option";
    if ($config['defaultintlevel'] == "4") {
        echo " selected";
    }
    echo " value=\"4\">" . gettext("Exp&#233;rimental") . "</option>";
    echo "</select>\n";
    echo "<u onmouseover=\"return escape" . gettext("('Permet de s&#233;lectionner le niveau de l\'interface Se4.')") . "\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"help\"></u>";
    echo "</form>\n";
} else {
    if (! isset($config['defaultintlevel']))
        $config['defaultintlevel'] = "0";
    if ($config['defaultintlevel'] == "1") {
        $intlevel = "D&#233;butant";
    }
    if ($config['defaultintlevel'] == "2") {
        $intlevel = "Interm&#233;diaire";
    }
    if ($config['defaultintlevel'] == "3") {
        $intlevel = "Confirm&#233;";
    }
    if ($config['defaultintlevel'] == "4") {
        $intlevel = "Exp&#233;rimental";
    }
    echo "<u onmouseover=\"return escape" . gettext("('Mode d\'affichage')") . "\">";
    echo "<a href=conf_params.php?action=modif_intlevel>$intlevel</a>";
    echo "</u>";
}
echo "</td></tr>\n";

// Affichage page Etat
if (! isset($config['affiche_etat']))
    set_config("affiche_etat", "0");
echo "<TR><TD>" . gettext("Affiche la page d'&#233;tat") . "</TD><TD align=\"center\">";
if ($config['affiche_etat'] == "0") {
    echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : D&#233;sactiv&#233;</b><br><br>Permet d\'afficher l\'&#233;tat du serveur &#224; chaque d&#233;marrage de l\'interface')") . "\">";
    echo "<a href=conf_params.php?action=change&amp;varb=affiche_etat&amp;valeur=1&amp;cat=6><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
    echo "</u>";
} else {
    echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : Activ&#233;</b><br><br>Permet de ne plus faire afficher l\'interface de l\'&#233;tat du serveur &#224; chaque lancement de l\'interface d\'administration du serveur.')") . "\">";
    echo "<a href=conf_params.php?action=change&amp;varb=affiche_etat&amp;valeur=0&amp;cat=6><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\" ></a>";
    echo "</u>";
}
echo "</td></tr>\n";

// Mode debug
echo "<TR><TD>" . gettext("Mode débuggage") . "</TD><TD align=\"center\">";
if ($config['debug'] == "1") {
    echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : Activ&#233;</b>Le mode debug permet d\'afficher dans le navigateurs les erreurs, afin de remonter un diagnostic précis des problèmes rencontrés.<br> Attention, ceci peut perturber le fonctionnement, et donc ne pas le laisser activer en production,<br> cliquer ici pour l\'activer.<br>')") . "\">";
    echo "<a href=debug.php?debug=0><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\"></a>";
    echo "</u>";
} else {
    // echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : D&#233;sactiv&#233;</b><br><br>Le mode debug permet d\'afficher dans le navigateurs les erreurs .')") . "\">";

    echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : D&#233;sactiv&#233;</b>Le mode debug permet d\'afficher dans le navigateurs les erreurs, afin de remonter un diagnostic précis des problèmes rencontrés.<br> Attention, ceci peut perturber le fonctionnement, et donc ne pas le laisser activer en production,<br> cliquer ici pour l\'activer.<br>')") . "\">";
    echo "<a href=debug.php?debug=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
    echo "</u>";
}
echo "</u>";
echo "</td></tr>\n";

// Cle d'authentification
echo "<TR><TD>" . gettext("Cl&#233; d'authentification") . "</TD><TD align=\"center\">";
echo "<u onmouseover=\"return escape" . gettext("('La cl&#233; d\'authentification correspond &#224; la cl&#233; de cryptage entre le serveur Se4 et le navigateur, pour le cryptage des &#233;changes.<br>Par d&#233;faut, tous les serveurs ont la m&#234;me cl&#233;, cliquer ici pour la modifier.<br>Ne pas oublier de vider votre navigateur pour pouvoir vous reconnecter.')") . "\">";
echo "<a href=setup_keys.php?cat=2><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\"></a>";
echo "</u>";
echo "</td></tr>\n";

// Gestion des comptes utilisateur
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo gettext("Configuration des comptes utilisateurs");
echo "</TD></TR>\n";

// cnPolicy
echo "<TR><TD>" . gettext("Format des logins") . "</TD><TD align=\"center\">";
if ($action == "modif_uidP") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"cnPolicy\">";
    echo "<select name =\"valeur\" ONCHANGE=\"this.form.submit();\">";
    // echo "<option"; if ($cnPolicy=="0") { echo " selected"; } echo " value=\"0\">".gettext("prenom.nom")."</option>";
    echo "<option";
    if ($config['cnPolicy'] == "1") {
        echo " selected";
    }
    echo " value=\"1\">" . gettext("prenom.nom (tronqu&#233; &#224; 19)") . "</option>";
    echo "<option";
    if ($config['cnPolicy'] == "2") {
        echo " selected";
    }
    echo " value=\"2\">" . gettext("pnom (tronqu&#233; &#224; 19)") . "</option>";
    echo "<option";
    if ($config['cnPolicy'] == "3") {
        echo " selected";
    }
    echo " value=\"3\">" . gettext("pnom (tronqu&#233; &#224; 8)") . "</option>";
    echo "<option";
    if ($config['cnPolicy'] == "4") {
        echo " selected";
    }
    echo " value=\"4\">" . gettext("nomp (tronqu&#233; &#224; 8)") . "</option>";
    echo "<option";
    if ($config['cnPolicy'] == "5") {
        echo " selected";
    }
    echo " value=\"5\">" . gettext("nomprenom (tronqu&#233; &#224; 18)") . "</option>";
    echo "</select>\n";
    echo "<u onmouseover=\"return escape" . gettext("('Permet de choisir le type de login.<br> Cette option ne modifie pas les comptes existants, mais les comptes qui seront cr&#233;&#233;s.<br><br>Si vous avez un Slis vous devez choisir nomp (tronqu&#233; &#224; 8)')") . "\">";
    echo "<img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"Help\">";
    echo "</u></form>";
} else {
    if (! isset($config['cnPolicy']))
        $config['cnPolicy'] = "0";
    if ($config['cnPolicy'] == "0") {
        $uidP = gettext("prenom.nom");
    }
    if ($config['cnPolicy'] == "1") {
        $uidP = gettext("prenom.nom (tronqu&#233; &#224; 19)");
    }
    if ($config['cnPolicy'] == "2") {
        $uidP = gettext("pnom (tronqu&#233; &#224; 19)");
    }
    if ($config['cnPolicy'] == "3") {
        $uidP = gettext("pnom (tronqu&#233; &#224; 8)");
    }
    if ($config['cnPolicy'] == "4") {
        $uidP = gettext("nomp (tronqu&#233; &#224; 8)");
    }
    if ($config['cnPolicy'] == "5") {
        $uidP = gettext("nomprenom (tronqu&#233; &#224; 18)");
    }
    echo "<u onmouseover=\"return escape" . gettext("('Permet de modifier le format de login.<br> Ce changement ne modifie pas les comptes d&#233;j&#224; cr&#233;&#233;s.<br><br>Les types disponibles sont :<br>prenom.nom<br>prenom.nom (tronqu&#233; &#224; 19)<br>pnom (tronqu&#233; &#224; 19)<br>pnom (tronqu&#233; &#224; 8)<br>nomp (tronqu&#233; &#224; 8).<br>nomprenom (tronqu&#233; &#224; 18).<br><br>Si vous avez un Slis, vous devez choisir nomp (troqu&#233; &#224; 8). ')") . "\">";
    echo "<a href=conf_params.php?action=modif_uidP>$uidP</a>";
    echo "</u>";
}
echo "</td></tr>\n";

// pwdPolicy
echo "<TR><TD>" . gettext("Mots de passe par d&#233;faut") . "</TD><TD align=\"center\">";
if ($action == "modif_pwdP") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"pwdPolicy\">";
    echo "<select name =\"valeur\" ONCHANGE=\"this.form.submit();\">";
    echo "<option";
    if ($config['pwdPolicy'] == "0") {
        echo " selected";
    }
    echo " value=\"0\">" . gettext("bas&#233; sur la date de naissance") . "</option>";
    echo "<option";
    if ($config['pwdPolicy'] == "1") {
        echo " selected";
    }
    echo " value=\"1\">" . gettext("semi-al&#233;atoire (6 car.)") . "</option>";
    echo "<option";
    if ($config['pwdPolicy'] == "2") {
        echo " selected";
    }
    echo " value=\"2\">" . gettext("al&#233;atoire (8 car.)") . "</option>";
    echo "<option";
    if ($config['pwdPolicy'] == "3") {
        echo " selected";
    }
    echo " value=\"3\">" . gettext("code d'activation") . "</option>";

    echo "</select>\n";
    if ($config['pwdPolicy'] == "0") {
        if (isset($config['no_passwd_change']) && $config['no_passwd_change'] == "1") {
            echo " <br>Changement de mot de passe non demandé <input type=checkbox name=\"no_passwd_change\" value=\"1\" checked  ONCHANGE=\"this.form.submit();\">";
        } else {
            echo " <br>Changement de mot de passe non demandé <input type=checkbox name=\"no_passwd_change\" value=\"1\" ONCHANGE=\"this.form.submit();\">";
        }
    }
    if ($config['pwdPolicy'] == "3") {
        echo " <br><input type=text name=\"activation_code\" value=\"" . $config['activation_code'] . "\" ONCHANGE=\"this.form.submit();\">";
    }

    echo "<u onmouseover=\"return escape" . gettext("('Permet de choisir le format des mots de passe.')") . "\">";
    echo "<img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"Help\">";
    echo "</u></form>";
} else {
    if (! isset($config['pwdPolicy']))
        $config['pwdPolicy'] = "0";
    if ($config['pwdPolicy'] == "0") {
        $pwdP = gettext("bas&#233; sur la date de naissance");
    }
    if ($config['pwdPolicy'] == "1") {
        $pwdP = gettext("semi-al&#233;atoire (6 car.)");
    }
    if ($config['pwdPolicy'] == "2") {
        $pwdP = gettext("al&#233;atoire (8 car.)");
    }
    if ($config['pwdPolicy'] == "3") {
        $pwdP = "code d'activation : [" . $config['activation_code'] . "]";
    }
    echo "<u onmouseover=\"return escape" . gettext("('Permet de choisir le format des mots de passe. ')") . "\">";
    echo "<a href=conf_params.php?action=modif_pwdP>$pwdP</a>";
    echo "</u>";
}
echo "</td></tr>\n";

// Configuration du serveur smtp
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo gettext("Configuration de l'exp&#233;dition des messages syst&#232;me");
echo "</TD></TR>
";
// domaine
echo "<TR><TD>" . gettext("Domaine") . " </TD><TD align=\"center\">";
// if ($config['mail_domain'] == "") {
$config['mail_domain'] = $config['domain'];
// }
if ($action == "modif_domain") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"mail_domain\">";
    echo "<input type=\"text\" name=\"valeur\"  value=\"" . $config['mail_domain'] . "\"><input type=\"submit\" value=\"Ok\"> ";
    echo "<u onmouseover=\"return escape" . gettext("('Indiquer le domaine, qui sera ajout&#233; aux mails. Ce changemant n\'affectera que les nouveaux comptes cr&#233;&#233;s.')") . "\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"Help\"></u>";
    echo "</form>";
} elseif (isset($config['mail_domain'])) {
    echo "<u onmouseover=\"return escape" . gettext("('Nom de domaine utilis&#233; pour les mails.')") . "\">";
    echo $config['mail_domain'];
    echo "</u>";
} else {
    echo "<u onmouseover=\"return escape" . gettext("('Indiquer le domaine, qui sera ajout&#233; aux  mails. Ce changemant n\'affectera que les nouveaux comptes cr&#233;&#233;s.')") . "\">";
    echo "<a href=conf_params.php?action=modif_domain><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
    echo "</u>";
}
echo "</td></tr>\n";

// SMTP
echo "<TR><TD>" . gettext("Exp&#233;dition des messages syst&#232;me") . "</TD><TD align=\"center\">";
if (file_exists("/etc/msmtprc")) {
    echo "<u onmouseover=\"return escape" . gettext("('Permet de configurer l\'exp&#233;dition des mails, en indiquant le serveur smtp de votre provider.')") . "\">";
    echo "<a href=conf_smtp.php><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\"></a>";
    echo "</u>";
    echo "</form>";
} else {
    echo "<u onmouseover=\"return escape" . gettext("('<b>Attention : </b> Ce serveur ne peut pas envoyer de messages, cela permet d\'&#234;tre inform&#233; d\'un disfonctionnement.<br> Il est souhaitable de le configurer.')") . "\">";
    echo "<a href=conf_smtp.php><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
    echo "</u>";
}
echo "</td></tr>\n";

// Configuration des serveurs
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo gettext("Configuration pour les mises &#224; jour et serveurs internes");
echo "</TD></TR>\n";
// Canal de mise à jour
echo "<TR><TD>" . gettext("Canal de mise a jour Sambaedu") . "</TD><TD align=\"center\">";
if ($action == "modif_depot") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"depot_type\">";
    echo "<select name =\"valeur\" ONCHANGE=\"this.form.submit();\">";
    echo "<option";
    if (empty($config['depot_type']) || $config['depot_type'] == "stable") {
        echo " selected";
    }
    echo " value=\"stable\">" . gettext("stable") . "</option>";
    echo "<option";
    if (! empty($config['depot_type']) && $config['depot_type'] == "xp") {
        echo " selected";
    }
    echo " value=\"xp\">" . gettext("expérimental") . "</option>";
    echo "</select>\n";
    echo "</form>";
} else {
    switch (@$config['depot_type']) {
        case "xp":
            echo "<u onmouseover=\"return escape" . gettext("('<b>Dépôt expériemental, mises à jour très fréquentes et derniers développements.</b><br>')") . "\">";
            echo "<a href=conf_params.php?action=modif_depot>expérimental</a>";
            echo "</u>";
            break;
        default:
            echo "<u onmouseover=\"return escape" . gettext("('<b>Dépôt stable, celui à utiliser en production</b><br>')") . "\">";
            echo "<a href=conf_params.php?action=modif_depot>stable</a>";
            echo "</u>";
    }
}
echo "</td></tr>\n";

// Adresse du Proxy
echo "<TR><TD>" . gettext("Type du proxy") . "</TD><TD align=\"center\">";
if ($action == "modif_proxy") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"proxy_type\">";
    echo "<select name =\"valeur\" ONCHANGE=\"this.form.submit();\">";
    echo "<option";
    if (empty($config['proxy_type']) || $config['proxy_type'] == "aucun") {
        echo " selected";
    }
    echo " value=\"aucun\">" . gettext("pas de proxy") . "</option>";
    echo "<option";
    if ($config['proxy_type'] == "manuel") {
        echo " selected";
    }
    echo " value=\"manuel\">" . gettext("proxy manuel pour les clients") . "</option>";
    echo "<option";
    if ($config['proxy_type'] == "automatique") {
        echo " selected";
    }
    echo " value=\"automatique\">" . gettext("autoconfiguration du proxy pour les clients") . "</option>";
    echo "</select>\n";
    if (! empty($config['proxy_type']) && $config['proxy_type'] != "aucun" && $config['proxy_type'] != "automatique") {
        echo "http://<input type=\"text\" name=\"proxy_address\"  value=\"" . $config['proxy_address'] . "\">:";
        echo "<input type=\"text\" name=\"proxy_port\"  value=\"" . $config['proxy_port'] . "\">";
        echo "<input type=\"submit\" value=\"Ok\"><br>";
        if (isset($config['server_proxy']) && $config['server_proxy'] == "1") {
            echo " <br>proxy pour le serveur <input type=checkbox name=\"server_proxy\" value=\"1\" checked >"; // ONCHANGE=\"this.form.submit();\">";
        } else {
            echo " <br>proxy pour le serveur <input type=checkbox name=\"server_proxy\" value=\"1\" >"; // ONCHANGE=\"this.form.submit();\">";
        }
    } elseif (! empty($config['proxy_type']) && $config['proxy_type'] == "automatique") {
        echo "<input type=\"text\" name=\"proxy_url\"  value=\"" . @$config['proxy_url'] . "\">:";
        echo "<input type=\"submit\" value=\"Ok\"><br>";
        if (isset($config['server_proxy']) && $config['server_proxy'] == "1") {
            echo " <br>proxy pour le serveur <input type=checkbox name=\"server_proxy\" value=\"1\" checked >"; // ONCHANGE=\"this.form.submit();\">";
        } else {
            echo " <br>proxy pour le serveur <input type=checkbox name=\"server_proxy\" value=\"1\" >"; // ONCHANGE=\"this.form.submit();\">";
        }
    }
    echo "<u onmouseover=\"return escape" . gettext("('Indiquer, si vous en utilisez un pour vos connexions &#224; internet, le proxy et son port.<br><br>Ex : 172.16.0.1:8080 ')") . "\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"Help\"></u>";
    echo "</form>";
} else {
    switch ($config['proxy_type']) {
        case "manuel":
            echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : Proxy manuel configuré pour les clients</b><br>')") . "\">";
            echo "Manuel : <a href=conf_params.php?action=modif_proxy>http://" . $config['proxy_address'] . ":" . $config['proxy_port'] . " pour les clients";
            if (@$config['server_proxy'])
                echo "<br>et proxy manuel pour le serveur</a>";
            else
                echo "<br>et pas de proxy pour le serveur</a>";
            echo "</u>";
            break;
        case "automatique":
            echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : Proxy automatique configuré pour les clients</b><br>')") . "\">";
            $proxy_url = $config['proxy_url'] ?? "non défini";
            echo "Automatique : <a href=conf_params.php?action=modif_proxy>URI :  " . $proxy_url . " pour les clients";
            if (@$config['server_proxy'])
                echo "<br>et proxy manuel pour le serveur</a>";
            else
                echo "<br>et pas de proxy pour le serveur</a>";
            echo "</u>";
            break;
        default:
            echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : Pas de proxy, connexion directe &#224; internet</b><br><br>Indiquer, si vous en utilisez un pour vos connexions &#224; internet, le proxy et son port.<br><br>Ex : 172.16.0.1:8080 ')") . "\">";
            echo "<a href=conf_params.php?action=modif_proxy><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
            echo "</u>";
            break;
    }
}
echo "</td></tr>\n";

echo "<tr><td>" . gettext("Adresse IP du serveur Amon") . "</td><td align=\"center\">";
if ($action == "ip_amon") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"ip_amon\">";
    echo "<INPUT TYPE=\"text\"  name =\"valeur\"  value=\"$ip_amon\" \">";
    echo "<button>Valider</button>";
    echo "</form>";
} else {
    $ip_amon = $config['ip_amon'] ?? "";
    if (! empty($ip_amon)) {
        echo "<u onmouseover=\"return escape" . gettext("('Adresse IP du serveur Amon si existant')") . "\">";
        echo "<a href=conf_params.php?action=ip_amon&amp;valeur=" . $ip_amon . ">$ip_amon</a>";
    } else {
        echo "<u onmouseover=\"return escape" . gettext("('Indiquer l\'adresse IP du serveur Amon si existant afin qu\'il soit utilisé pour le wpad')") . "\">";
        echo "<a href=conf_params.php?action=ip_amon>Pas de serveur Amon</a>";
    }
}
echo "</td></tr>\n";

// Partages
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo gettext("Partages");
echo "</TD></TR>
";

// echo "<tr><td>" . gettext("Purge journali&#232;re de la ressource public ") . "</td><td align=\"center\">";
//
// if (isset($config['purge_public'])) {
// echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : Activ&#233;</b><br><br>Cliquer ici afin de d&#233;sactiver la purge automatique du partage public. <br>Cela permet de supprimer automatiquement toutes les nuits les fichiers dans la ressource public.')") . "\">";
// echo "<a href=conf_params.php?action=change&amp;varb=purge_public&amp;valeur=0&amp;cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\"></a>";
// } else {
// echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : D&#233;sactiv&#233;</b><br><br>Cliquer ici afin d\'activer une purge automatique de la ressource public.')") . "\">";
// echo "<a href=conf_params.php?action=change&amp;varb=purge_public&amp;valeur=1&amp;cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
// }
//
// echo "</td></tr>\n";

echo "<tr><td>" . gettext("Autoriser l'acc&#232;s &#224; la ressource public ") . "</td><td align=\"center\">";
if (! isset($config['autoriser_part_pub']))
    $config['autoriser_part_pub'] = "n";
if ($config['autoriser_part_pub'] == "y") {
    echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : Activ&#233;</b><br><br>Cliquer ici afin de d\'interdire l\'acc&#232;s au dossier /var/sambaedu/Docs/public')") . "\">";
    echo "<a href=conf_params.php?action=change&amp;varb=autoriser_part_pub&amp;valeur=n&amp;cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\"></a>";
} else {
    echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : D&#233;sactiv&#233;</b><br><br>Cliquer ici afin de d\'autoriser l\'acc&#232;s au dossier /var/sambaedu/Docs/public')") . "\">";
    echo "<a href=conf_params.php?action=change&amp;varb=autoriser_part_pub&amp;valeur=y&amp;cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
}

echo "</td></TR>\n";
echo "<tr><td>" . gettext("Autoriser l'écriture dans install") . "</td><td align=\"center\">";
if (read_smb_conf()['install']['read only'] == "no") {
    echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : Activé</b><br><br>Cliquer ici afin d\'interdire l\'accès  en écriture pour admin au dossier install')") . "\">";
    echo "<a href=conf_params.php?action=change&varb=admin_w&valeur=n&cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/enabled.png\" alt=\"Enabled\"></a>";
} else {
    echo "<u onmouseover=\"return escape" . gettext("('<b>Etat : Désactivé</b><br><br>Cliquer ici afin d\'autoriser l\'écriture pour admin dans le dossier install')") . "\">";
    echo "<a href=conf_params.php?action=change&amp;varb=admin_w&amp;valeur=y&amp;cat=1><IMG style=\"border: 0px solid;\" SRC=\"elements/images/disabled.png\" alt=\"Disabled\"></a>";
}

echo "</td></TR>\n";

// UAI
echo "<TR><TD colspan=\"2\" align=\"center\" class=\"menuheader\">\n";
echo gettext("Informations sur l'établissement");
echo "</TD></TR>\n";
echo "<tr><td>" . gettext("Merci de préciser l'UAI de l'établissement.   
        Cette information nous permet d'envoyer des alertes de sécurité aux établissements. <br />
        Indiquer 0000000X pour un serveur de test ou un établissement sans UAI. <br />") . "</td><td align=\"center\">";
$UAI = $config['UAI'] ?? "";
if ($action == "UAI") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"UAI\">";
    echo "<INPUT TYPE=\"text\"  name =\"valeur\"  value=\"$UAI\" \">";
    echo "<button>Valider</button>";
    echo "</form>";
} else {
    if (! empty($UAI)) {
        echo "<u onmouseover=\"return escape" . gettext("('Merci d\'indiquer l\'UAI de l\'établissement')") . "\">";
        echo "<a href=conf_params.php?action=UAI&amp;valeur=" . $UAI . ">$UAI</a>";
    } else {
        echo "<u onmouseover=\"return escape" . gettext("('Merci d\'indiquer l\'UAI de l\'établissement')") . "\">";
        echo "<a href=conf_params.php?action=UAI>UAI de la forme NNNNNNNX</a>";
    }
}
echo "</td></TR>\n";

echo "<tr><td>" . gettext("Nom de l'établissement. <br />
Dans le cas d'un établissement sans UAI, merci de préciser son nom.") . "</td><td align=\"center\">";
$etab_name = $config['etab_name'] ?? "";
if ($action == "etab_name") {
    echo "<form method=\"get\" action=\"conf_params.php\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"change\">";
    echo "<input type=\"hidden\" name=\"varb\" value=\"etab_name\">";
    echo "<INPUT TYPE=\"text\"  name =\"valeur\"  value=\"$etab_name\" \">";
    echo "<button>Valider</button>";
    echo "</form>";
} else {
    if (! empty($etab_name)) {
        echo "<u onmouseover=\"return escape" . gettext("('Nom de votre établissement')") . "\">";
        echo "<a href=conf_params.php?action=etab_name&amp;valeur=" . $etab_name . ">$etab_name</a>";
    } else {
        echo "<u onmouseover=\"return escape" . gettext("('Merci d\'indiquer le nom de l\'établissement')") . "\">";
        echo "<a href=conf_params.php?action=etab_name>Merci d'indiquer le nom de l'établissement</a>";
    }
}
echo "</td></TR>\n";

echo "</table></center>";

echo "</table></center>";

include ("pdp.inc.php");
?>
