<?php
/*
 * actions à effectuer lors de la modif d'un paametre de config.
 *
 * auteur denis bonnenfant
 *
 * projet SambaEdu
 *
 * licence GPL
 *
 * page appellée par un script curl local exclusivement.
 *
 * N'est exécuté qu'une seule fois en cas de changement d'un parametre de conf. Si on veut
 * enchainer il faut modifier un parametre a chaque execution. Ceci pose problème en cas d'erreur dans un script,
 * il ne sera plus exécuté ensuite.
 *
 */
require_once "entete_script.inc.php";
require_once "samba-tool.inc.php";
require_once "gpo.inc.php";
require_once "printers.inc.php";

$module = $_POST["conf"] ?? "/etc/sambaedu/sambaedu.conf";
$module = preg_replace("|^.*/(.*)\.conf$|", "\\1", $module);
$diff = compare_config($module);
$proxy_gpo = $server_proxy = 0;
foreach ($diff as $param => $valeur) {
    echo "modification pour $param : \"$valeur\"<br>\n";
    switch ($param) {
        case "proxy_url":
            dns_wpad($config);
        case "proxy_address":
        case "proxy_port":
            if (empty($proxy_gpo ++))
                echo set_proxy_gpo($config);
        case "server_proxy":
            if (empty($server_proxy ++))
                exec("sudo dpkg-reconfigure -fnoninteractive -phigh sambaedu-proxy-config");
            break;
        case "proxy_type":
            if (empty($proxy_gpo ++))
                echo set_proxy_gpo($config);
            break;
        case "import_dhcp_se3":
            echo import_dhcp_reservations($config);
            set_param($config, "import_dhcp_se3", "", "dhcp");
            break;
        case "del_reservations":
            echo delete_all_dhcp_reservations($config);
            set_param($config, "del_reservations", "", "dhcp");
            break;
        case "depot_type":
            if ($config['depot_type'] == "stable")
                exec("sudo sed -i 's/se4XP/stable/' /etc/apt/sources.list.d/se4.list");
            else
                exec("sudo sed -i 's/stable/se4XP/' /etc/apt/sources.list.d/se4.list");
            break;
        case "dl_debian_iso":
            if ($valeur == 1) {
                exec("sudo /usr/share/sambaedu/scripts/install-debian-64-iso.sh -s >/dev/null  2>&1 &");
            }
            set_param($config, "dl_debian_iso", "", "clients");
            break;
        case "se4ad_ip":
        case "se4fs_ip":
        case "dhcp_masque":
        case "dhcp_reseau":
        case "dhcp_gateway":
            //  - recopie la conf sur l'ad,
            //  - sed etc ad et fs
            //  - 
            exec("sudo /usr/share/sambaedu/scripts/change_ip.sh");
            
            break;
        case "maj":
            // permet de déclencher des actions liées à une mise à jour du paquet, il faut juste
            // incrémenter maj=xxx dans le postinst.
            // les fonctions ou scripts appelés doivent pouvoir être appelés plusieurs fois sans risque !
            $success = true;
            $success &= migrate_printers($config);
            if (! $success) {
                set_param($config, "maj", ($valeur - 1));
            }
        // default:
        //
    }
}
?>