<?php

/**

 * Gestion des gpo pour clients Windows (mise a jour des gpo)


 * @Projet SambaEdu 

 * @auteurs  denis.bonnenfant

 * @Licence Distribue selon les termes de la licence GPL

 * @note 

 */
/**
 *
 * @Repertoire: registre
 * file: gpo-maj.php
 *
 */
require_once "entete.inc.php";
require_once "config.inc.php";
require_once "ldap.inc.php";
require_once "ihm.inc.php";
require_once "gpo.inc.php";
require_once ("lang.inc.php");
bindtextdomain('se3-registre', "/var/www/se3/locale");
textdomain('se3-registre');

echo "<h1>Importation des GPOs dans l'AD</h1>";
$imports = $_POST['imports'] ?? array();
$imports_etab = $_POST['imports_etab'] ?? array();

// connexion();

if (! have_right($config, "computers_is_admin"))
    die(gettext("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction") . "</BODY></HTML>");

// Aide


if ((count($imports) == 0)&&(count($imports_etab) == 0)) {

    echo "<table cellpadding=\"5em\" align=\"center\" valign=\"top\" ><tr valign=\"top\" ><td align=\"left\">\n";
    echo "<h1>" . gettext("GPO initiales (pour réimport dans l'AD)") . "</h1>";
    /*
     * GPO issues du paquet se4
     * dont le fichier est 
     * préfixé par se4_*.zip
     *
     */
    $gpos = list_gpo_templates();
    $nb = count($gpos);
    if ($nb == 0){
        // on met a jour les templates si besoin
        exec("sudo apt update && sudo apt install -y sambaedu-gpo-templates");
        $gpos = list_gpo_templates();
        $nb = count($gpos);
    }
    if ($nb > 15)
        $nb = 15;
    echo "<FORM method=\"post\" action=\"gpo-maj.php\">\n";
    echo "<SELECT NAME=\"imports[]\" SIZE=\"" . $nb . "\" multiple>";

    foreach ($gpos as $gpo) {
        echo "<option value=\"" . $gpo["displayname"] . "\"";
        echo ">" . $gpo["displayname"] . "\n";
	echo " (" . $gpo["version"] . " ) ";
        echo "</option>";
    }
    echo "</SELECT>\n";
    echo "<p><input type=\"submit\" value=\"" . gettext("Valider") . "\">\n</p>";
    echo "</FORM>\n";

    echo "</td><td align=\"left\">\n";

    /*
     * GPO présentent dans le rep. templates
     * dont le fichier est 
     * préfixé par etab_*.zip
     *
     */
    echo "<h1>" . gettext("Autres GPO disponibles (issues d'exports ...)") . "</h1>";
    $gpos = list_gpo_templates_etab();
    $nb = count($gpos);
    if ($nb != 0){
	    if ($nb > 15)
		$nb = 15;
	    echo "<FORM method=\"post\" action=\"gpo-maj.php\">\n";
	    echo "<SELECT NAME=\"imports_etab[]\" SIZE=\"" . $nb . "\" multiple>";

	    foreach ($gpos as $gpo) {
		echo "<option value=\"" . $gpo["displayname"] . "\"";
		echo ">" . $gpo["displayname"] . "\n";
		echo " (" . $gpo["version"] . " ) ";
		echo "</option>";
	    }
	    echo "</SELECT>\n";
	    echo "<p><input type=\"submit\" value=\"" . gettext("Valider") . "\">\n</p>";
	    echo "</FORM>\n";
     }
     echo"</td></tr></table>";


} elseif (count($imports) != 0) {
	foreach ($imports as $gpo) {
		$res = import_gpo($config, $gpo, "se4_" . $gpo . ".zip");
		echo "GPO " . $gpo . " :<br>\n";
		if ($res)
		    echo "importation OK<br>\n";
		else
		    echo "ERREUR<br>\n";
	}
} elseif (count($imports_etab) != 0) {
	foreach ($imports_etab as $gpo) {
		$res = import_gpo($config, $gpo, "etab_" . $gpo . ".zip");
		echo "GPO " . $gpo . " :<br>\n";
		if ($res)
		    echo "importation OK<br>\n";
		else
		    echo "ERREUR<br>\n";
	}
}




// Liste des GPO déjà présentes sur l'AD
$gpos_in_ad = gpogetlink($config, $config['ldap_base_dn']);
usort($gpos_in_ad, 'compare_list_gpo_by_name');
echo "<h1>" . gettext("GPO actuellement présentes sur le serveur Active Directory") . "</h1>";
echo "<ul>";
foreach ($gpos_in_ad as $gpo) {
	$gpo_infos = search_ad($config, $gpo["displayname"], "gpo");
	$gpo_version = $gpo_infos[0]['versionnumber'];
	echo "<li>" . $gpo["displayname"]."\n" . " (" . "$gpo_version" . ")" . "</li>\n";
}
echo "</ul>\n";



include ("pdp.inc.php");
?>
