<?php

/**

 * Fonctions du serveur DHCP
 * @Version $Id$

 * @Projet LCS / SambaEdu

 * @auteurs GrosQuicK   eric.mercier@crdp.ac-versailles.fr
 * @auteurs Plouf

 * @note Ce fichier de fonction doit etre appele par un include

 */

/**
 *
 * @Repertoire: dhcp
 * file: dhcp.inc.php
 *
 */

/**
 *
 * Affiche la conf du serveur DHCP
 *
 * @Parametres $error : Message d'erreur
 *
 * @return Affichage HTML
 *        
 */
function dhcp_config_form($config, $vlan_actif = 0, $error)
{
    $dhcp = get_network($config);
    $ret = "<table>\n";
    // Menu select pour les vlan
    $ret .= "<form name=\"configuration\" method=\"post\" action=\"config.php\">\n";
    $ret .= "<tr><td>";
    $ret .= "Sous-réseau dhcp (routage inter-Vlans)";
    $ret .= "</td><td>";
    if ($vlan_actif == "nouveau") {
        $ret .= "<input type=\"text\" SIZE=3 name=\"vlan\" maxlength=\"3\" onchange=submit()>";
        $ret .= "<input type='hidden' name='action' value='index'>\n";
        $ret .= "</td><td></td></tr>\n";
        $ret .= "</form>\n";
    } else {
        $ret .= ": <select name=\"vlan\" onchange=submit()>";
        // $ret .= "<option value=\"0\">Défaut</option>";
        if ($vlan_actif != 0)
            $dhcp['reseau'][$vlan_actif] = $dhcp['reseau'][$vlan_actif] ?? "";
        ksort($dhcp['reseau']);
        foreach ($dhcp['reseau'] as $vlan => $valeur) {
            $ret .= "<option ";
            if ($vlan == 0) {
                $txt_vlan = "Sous-réseau par défaut";
            } else {
                $txt_vlan = "Sous-réseau $vlan";
            }
            $ret .= " value=\"" . $vlan . "\" ";
            if ($vlan_actif == $vlan) {
                $ret .= "selected";
            }
            $ret .= ">" . $txt_vlan . "</option>";
        }

        $ret .= "<option value=\"nouveau\">Nouveau...</option>";
        $ret .= "</select>";
        $ret .= "<input type='hidden' name='action' value='index'>\n";
        $ret .= "</td><td></td></tr>\n";
        $ret .= "</form>\n";

        $dhcp_vlan = array();
        foreach ($dhcp as $key => $val) {
            $dhcp_vlan[$key] = $val[$vlan_actif] ?? $val[0] ?? "";
        }
        $dhcp = $dhcp_vlan;
        if ($vlan_actif == 0) {
            $txt_vlan = "sous-réseau par défaut";
        } else {
            $txt_vlan = "sous-réseau $vlan_actif";
        }

        // formulaire
        $ret .= "<form name=\"configuration\" method=\"post\" action=\"config.php\">\n";
        // dhcp_iface : interface d'ecoute du dhcp
        $ret .= "<tr><td>" . gettext("interface") . "</td><td>\n";
        $ret .= ": <input type=\"text\" SIZE=5 name=\"iface\" value=\"" . $dhcp["iface"] . "\" maxlength=\"5\"";
        // if ($vlan_actif > 0) {
        $ret .= " disabled ";
        // }
        $ret .= ">";
        if (isset($error['dhcp_iface'])) {
            $ret .= "<b>" . $error['dhcp_iface'] . "</b>";
        }
        $ret .= "</td></tr>\n";

        // dhcp_domain_name : Nom du domaine
        $ret .= "<tr><td>" . gettext("domain_name") . "</td><td>\n";
        $ret .= ": <input type=\"text\" SIZE=60 name=\"domain_name\" value=\"" . $dhcp["domain_name"] . "\" maxlength=\"55\"";
        // if ($vlan_actif > 0) {
        $ret .= " disabled ";
        // }
        $ret .= ">";
        if (isset($error['dhcp_domain_name'])) {
            $ret .= "<b>" . $error['dhcp_domain_name'] . "</b>";
        }
        $ret .= "</td></tr>\n";

        // dhcp_max_lease : bail maximal
        $ret .= "<tr><td>" . gettext("max_lease") . "</td><td>\n";
        $ret .= ": <input type=\"text\" SIZE=10 name=\"max_lease\" value=\"" . $dhcp["max_lease"] . "\" maxlength=\"10\"";
        if ($vlan_actif > 0) {
            $ret .= " disabled ";
        }
        $ret .= ">";
        if (isset($error['dhcp_max_lease'])) {
            $ret .= "<b>" . $error['dhcp_max_lease'] . "</b>";
        }
        $ret .= "</td></tr>\n";

        // dhcp_default_lease : bail par defaut
        $ret .= "<tr><td>" . gettext("default_lease") . "</td><td>\n";
        $ret .= ": <input type=\"text\" SIZE=10 name=\"default_lease\" value=\"" . $dhcp["default_lease"] . "\" maxlength=\"10\"";
        if ($vlan_actif > 0) {
            $ret .= " disabled ";
        }
        $ret .= ">";
        if (isset($error['dhcp_default_lease'])) {
            $ret .= "<b>" . $error['dhcp_default_lease'] . "</b>";
        }
        $ret .= "</td></tr>\n";
        // dhcp_dns_server_prim : Serveur DNS primaire
        $ret .= "<tr><td>" . gettext("dns_server_prim") . "</td><td>\n";
        $ret .= ": <input type=\"text\" SIZE=15 name=\"dns_server_prim\" value=\"" . $dhcp["dns_server_prim"] . "\"maxlength=\"15\"";
        // if ($vlan_actif > 0) {
        $ret .= " disabled ";
        // }
        $ret .= ">";
        if (isset($error['dhcp_dns_server_prim'])) {
            $ret .= "<b>" . $error['dhcp_dns_server_prim'] . "</b>";
        }
        $ret .= "</td></tr>\n";
        if (isset($dhcp['dns_server_sec'])) {

            // dhcp_dns_server_sec : Serveur DNS secondaire
            $ret .= "<tr><td>" . gettext("dns_server_sec") . "</td><td>\n";
            $ret .= ": <input type=\"text\" SIZE=15 name=\"dns_server_sec\" value=\"" . $dhcp["dns_server_sec"] . "\" maxlength=\"15\"";
            if ($vlan_actif > 0) {
                $ret .= " disabled ";
            }
            $ret .= ">";
            if (isset($error['dhcp_dns_server_sec'])) {
                $ret .= "<b>" . $error['dhcp_dns_server_sec'] . "</b>";
            }
            $ret .= "</td></tr>\n";
        }
        // partie reserve si on a des vlan

        // Adresse du reseau
        $ret .= "<tr><td>" . gettext("Adresse ");
        $ret .= " du " . $txt_vlan;
        $ret .= "</td><td>\n";
        $ret .= ": <input type=\"text\" SIZE=15 name=\"reseau\" value=\"" . $dhcp["reseau"] . "\" maxlength=\"15\"";
        if ($vlan_actif == 0) {
            $ret .= " disabled ";
        }
        $ret .= ">";

        // Masque du reseau
        $ret .= "<tr><td>" . gettext("Masque");
        $ret .= " du " . $txt_vlan;
        $ret .= "</td><td>\n";
        $ret .= ": <input type=\"text\" SIZE=15 name=\"masque\" value=\"" . $dhcp["masque"] . "\" maxlength=\"15\"";
        if ($vlan_actif == 0) {
            $ret .= " disabled ";
        }
        $ret .= ">";
        if (isset($error['dhcp_gateway'])) {
            $ret .= "<b>" . $error['dhcp_gateway'] . "</b>";
        }
        $ret .= "</td></tr>\n";

        // dhcp_gateway : PASSERELLE

        $ret .= "<tr><td>" . gettext("gateway");
        $ret .= " du " . $txt_vlan;
        $ret .= "</td><td>\n";
        $ret .= ": <input type=\"text\" SIZE=15 name=\"gateway\" value=\"" . $dhcp["gateway"] . "\" maxlength=\"15\"";
        if ($vlan_actif == 0) {
            $ret .= " disabled ";
        }
        $ret .= ">";

        if (isset($error['dhcp_gateway'])) {
            $ret .= "<b>" . $error['dhcp_gateway'] . "</b>";
        }
        $ret .= "</td></tr>\n";

        // dhcp_ip_min : Debut de la plage de reservations
        $ret .= "<tr><td>" . gettext("ip_min");
        $ret .= " du " . $txt_vlan;
        $ret .= "</td><td>\n";
        // if ($dhcp["ip_min"]["value"] == "") { $dhcp["$dhcp_ip_min"] =
        $ret .= ": <input type=\"text\" SIZE=15 name=\"ip_min\" value=\"" . $dhcp["ip_min"] . "\" maxlength=\"15\">";

        if (isset($error['dhcp_ip_min'])) {
            $ret .= "<b>" . $error['dhcp_ip_min'] . "</b>";
        }
        $ret .= "</td></tr>\n";

        // dhcp_begin_range : Debut de la plage
        $ret .= "<tr><td>" . gettext("begin_range");
        $ret .= " du " . $txt_vlan;
        $ret .= "</td><td>\n";
        $ret .= ": <input type=\"text\" SIZE=15 name=\"begin_range\" value=\"" . $dhcp["begin_range"] . "\" maxlength=\"15\">";
        if (isset($error['dhcp_begin_range'])) {
            $ret .= "<b>" . $error['dhcp_begin_range'] . "</b>";
        }
        $ret .= "</td></tr>\n";

        // dhcp_end_range : Fin de la plage
        $ret .= "<tr><td>" . gettext("end_range");
        $ret .= " du " . $txt_vlan;
        $ret .= "</td><td>\n";
        $ret .= ": <input type=\"text\" SIZE=15 name=\"end_range\" value=\"" . $dhcp["end_range"] . "\" maxlength=\"15\"";
        if (isset($error['dhcp_end_range'])) {
            $ret .= "<b>" . $error['dhcp_end_range'] . "</b>";
        }
        $ret .= "</td></tr>\n";

        $ret .= "<tr><td></td><td></td></tr>\n";
        // Option autre
        $ret .= "<tr><td>" . gettext("extra_option");
        $ret .= " du " . $txt_vlan;
        $ret .= "</td><td>\n";
        $dhcp["extra_option"] = $dhcp["extra_option"] ?? "";
        $ret .= ": <input type=\"text\" SIZE=30 name=\"extra_option\" value=\"" . $dhcp["extra_option"] . "\" maxlength=\"30\"";
        if (isset($error['dhcp_extra_option'])) {
            $ret .= "<b>" . $error['dhcp_extra_option'] . "</b>";
        }
        $ret .= "</td></tr>\n";

        $ret .= "<tr><td></td><td></td></tr>\n";

        // dhcp_tftp_server : SERVER TFTP
        $ret .= "<tr><td>" . gettext("tftp_server") . "</td><td>\n";
        $ret .= ": <input type=\"text\" SIZE=15 name=\"tftp_server\" value=\"" . $dhcp["tftp_server"] . "\" maxlength=\"15\"";
        if ($vlan_actif > 0) {
            $ret .= " disabled ";
        }
        $ret .= ">";
        if (isset($error['dhcp_tftp_server'])) {
            $ret .= "<b>" . $error['dhcp_tftp_server'] . "</b>";
        }
        $ret .= "</td></tr>\n";
        $ret .= "<tr><td></td><td></td></tr>\n";

        $ret .= "</table>";
        $ret .= "<input type='hidden' name='action' value='newconfig'>\n";
        $ret .= "<input type='hidden' name='vlan' value='" . $vlan_actif . "'>\n";
        $ret .= "<input type=\"submit\" name=\"button\" value=\"" . gettext("Modifier") . "\">\n";
        $ret .= "</form>\n";
        $state = 0;
        $res = array();
        exec("sudo systemctl is-active isc-dhcp-server.service", $res, $state);
        if ($state == 0) {
            $ret .= "<form name=\"stop\" method=\"post\" action=\"config.php\">\n";
            $ret .= "<input type='hidden' name='action' value='stop'>\n";
            $ret .= "</form>";
        } else {
            exec("sudo systemctl status isc-dhcp-server.service", $res, $state);
            $ret .= "<br>" . implode("<br>\n", $res) . "<br>";
            $ret .= "<form name=\"stop\" method=\"post\" action=\"config.php\">\n";
            $ret .= "<input type='hidden' name='action' value='restart'>\n";
            $ret .= "<input type=\"submit\" name=\"button\" value=\"" . gettext("Red&#233;marrer le serveur dhcp") . "\">\n";
            $ret .= "</form>";
        }
    }
    return $ret;
}

/**
 * Mise a jour de la conf du dhcp
 *
 * @Parametres
 *
 * @return Erreur
 *
 */
function dhcp_update_config($config, $vlan_actif)
{
    // insert range in option service table
    $error = "";
    $dhcp = get_network($config);

    if ($vlan_actif > 0) {
        $suffix = "_" . $vlan_actif;
    } else {
        $suffix = "";
    }
    // verif si le champ existe dans la table sinon on le cree

    $dhcp_ip_min = "dhcp_ip_min" . $suffix;
    // dhcp_vlan_champ($dhcp["ip_min"]);
    $dhcp_begin_range = "dhcp_begin_range" . $suffix;
    // dhcp_vlan_champ($dhcp["begin_range"]);
    $dhcp_end_range = "dhcp_end_range" . $suffix;
    // dhcp_vlan_champ($dhcp["end_range"]);
    $dhcp_gateway = "dhcp_gateway" . $suffix;
    // dhcp_vlan_champ($dhcp["gateway"]);
    $dhcp_reseau = "dhcp_reseau" . $suffix;
    // dhcp_vlan_champ($dhcp["reseau"]);
    $dhcp_masque = "dhcp_masque" . $suffix;
    // dhcp_vlan_champ($dhcp["masque"]);
    $dhcp_extra_option = "dhcp_extra_option" . $suffix;
    // dhcp_vlan_champ($dhcp["extra_option"]);

    if ((set_ip_in_lan($_POST["ip_min"])) || ($_POST["ip_min"] == "")) {
        set_param($config, $dhcp_ip_min, $_POST["ip_min"], "dhcp");
    } else {
        $error["$dhcp_ip_min"] = gettext("Cette addresse n'est pas valide : " . $_POST["ip_min"]);
    }

    if ((set_ip_in_lan($_POST["begin_range"])) || ($_POST["begin_range"] == "")) {
        set_param($config, $dhcp_begin_range, $_POST["begin_range"], "dhcp");
    } else {
        $error["$dhcp_begin_range"] = gettext("Cette addresse n'est pas valide : " . $_POST["begin_range"]);
    }

    if ((set_ip_in_lan($_POST["end_range"]) || ($_POST["end_range"]) == "")) {
        set_param($config, $dhcp_end_range, $_POST["end_range"], "dhcp");
    } else {
        $error["$dhcp_end_range"] = gettext("Cette adresse n'est pas valide : " . $_POST["end_range"]);
    }

    if ($vlan_actif > 0) {
        if ((set_ip_in_lan($_POST["reseau"])) || ($_POST["reseau"] == "")) {
            set_param($config, $dhcp_reseau, $_POST["reseau"], "dhcp");
        } else {
            $error["$dhcp_reseau"] = gettext("Cette addresse n'est pas valide : " . $_POST["reseau"]);
        }
        if ((set_ip_in_lan($_POST["gateway"])) || ($_POST["gateway"] == "")) {
            set_param($config, $dhcp_gateway, $_POST["gateway"], "dhcp");
        } else {
            $error["$dhcp_gateway"] = gettext("Cette adresse n'est pas valide : " . $_POST["gateway"]);
        }
        if ((set_ip_in_lan($_POST["masque"])) || ($_POST["masque"] == "")) {
            set_param($config, $dhcp_masque, $_POST["masque"], "dhcp");
        } else {
            $error["$dhcp_masque"] = gettext("Cette addresse n'est pas valide : " . $_POST["masque"]);
        }
    }

    // if (!($_POST["extra_option"]=="")) {
    set_param($config, $dhcp_extra_option, $_POST["extra_option"], "dhcp");
    // }

    // Si on est dans la conf des vlan cette partie n'est pas modifiable

    if ($vlan_actif == 0) {

        if (preg_match("/^[0-9]+$/", $_POST['max_lease'])) {
            set_param($config, "dhcp_max_lease", $_POST['max_lease'], "dhcp");
        } else {
            $error["dhcp_max_lease"] = gettext("Ce n'est pas un nombre valide : " . $_POST['max_lease']);
        }

        if (preg_match("/^[0-9]+$/", $_POST['default_lease'])) {
            set_param($config, "dhcp_default_lease", $_POST['default_lease'], "dhcp");
        } else {
            $error["dhcp_default_lease"] = gettext("Ce n'est pas un nombre valide : " . $_POST['default_lease']);
        }
    }
    return $error;
}

/**
 * Test si l'adresse IP appartient au reseau local
 *
 * @Parametres $ip : Adresse IP a tester
 *
 * @return TRUE si oui - FLASE si non
 *        
 */
function set_ip_in_lan($ip)
{
    if (preg_match("/^(((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]{1}[0-9]|[1-9]).)" . "{1}((25[0-5]|2[0-4][0-9]|[1]{1}[0-9]{2}|[1-9]{1}[0-9]|[0-9]).)" . "{2}((25[0-5]|2[0-4][0-9]|[1]{1}[0-9]{2}|[1-9]{1}[0-9]|[0-9]){1}))$/", $ip)) {
        return TRUE;
    } else {
        return FALSE;
    }
}

/**
 * MAKE a form with lease info get in dhcpd.lease
 *
 * @Parametres $parser : tableau : ip mac hostname
 *
 * @return Affichage HTML d'un form a partir du dhcp.leases
 *        
 */
function form_dhcp_lease($config, $parser)
{
    $content = "<script type='text/javascript'>
function checkAll_baux(){
	champs_input=document.getElementsByTagName('input');
	for(i=0;i<champs_input.length;i++){
		type=champs_input[i].getAttribute('type');
		if(type==\"checkbox\"){
			champs_input[i].checked=true;
		}
	}
}
function UncheckAll_baux(){
	champs_input=document.getElementsByTagName('input');
	for(i=0;i<champs_input.length;i++){
		type=champs_input[i].getAttribute('type');
		if(type==\"checkbox\"){
			champs_input[i].checked=false;
		}
	}
}
</script>\n";

    $content .= "<form name=\"lease_form\" method=post action=\"baux.php\">\n";
    $content .= "<table border=\"1\" width=\"90%\">\n";
    $content .= "<tr class=\"menuheader\"><td align=\"center\"><b>\n" . gettext("Adresse IP");
    $content .= "</b></td><td align=\"center\"><b>\n" . gettext("Adresse MAC");
    $content .= "</b></td><td align=\"center\"><b>\n" . gettext("Nom");
    $content .= "</b></td><td align=\"center\"><b>\n" . gettext("Action");
    $content .= "</b></td></tr>\n";
    $content .= "</b><br />\n";
    $content .= "<a href='javascript: checkAll_baux();'><img src='../elements/images/enabled.gif' width='20' height='20' border='0' alt='Tout cocher' /></a> / <a href='javascript:UncheckAll_baux();'><img src='../elements/images/disabled.gif' width='20' height='20' border='0' alt='Tout d&#233;cocher' /></a>\n";
    $content .= "</td></tr>\n";
    foreach ($parser as $key => $lease) {
        if (($lease['state'] == "active")) { // || ($lease['state'] == "free")) {
            $showid = false;
            $listaction = "";
            if (($lease['name']) == "ipxe") {
                $listaction .= "<OPTION value=\"nommer\">Nommer</OPTION>\n";
                $listaction .= "<OPTION value=\"reserver\">Reserver (ordinateur)</OPTION>\n";
                $listaction .= "<OPTION value=\"imprimante\">Reserver (imprimante)</OPTION>\n";
            } else {
                $listaction .= "<OPTION value=\"reserver\">Reserver (ordinateur)</OPTION>\n";
                $listaction .= "<OPTION value=\"imprimante\">Reserver (imprimante)</OPTION>\n";
            }

            $content .= "<tr><td>\n";
            $content .= "<input type=\"text\" maxlength=\"15\" SIZE=\"15\" value=\"" . $lease["ip"] . "\"  name=\"ip[$key]\" >\n";
            $content .= "</td><td>\n";
            $content .= "<input type=\"text\" maxlength=\"17\" SIZE=\"17\" value=\"" . $lease["mac"] . "\"  name=\"mac[$key]\" >\n";
            $content .= "</td><td>\n";
            $content .= "<input type=\"text\" maxlength=\"20\" SIZE=\"20\" value=\"" . $lease["name"] . "\"  name=\"name[$key]\" >\n";
            $content .= "<input type=\"hidden\" maxlength=\"20\" SIZE=\"20\" value=\"" . $lease["name"] . "\"  oldname=\"oldname[$key]\" >\n";
            $content .= "</td><td align=\"center\">\n";
            $content .= "<SELECT  name=\"action_res[$key]\">";
            $content .= "<OPTION value=\"none\">" . gettext("Action...") . "</OPTION>";
            $content .= $listaction;
            // $content .= "<OPTION value=\"reserver2\">Reserver hors plage de reservation</OPTION>\n";
            $content .= "</SELECT>\n";
            $content .= "</td>\n";
            $content .= "<td align=\"center\">\n";
            if ($showid) {
                $content .= "Admin local : <input type=\"text\" maxlength=\"20\" SIZE=\"15\" value=\"administrateur\"  name=\"localadminname[$key]\" ><br>\n";
                $content .= "Mot de passe : <input type=\"password\" maxlength=\"20\" SIZE=\"8\" value=\"\"  name=\"localadminpasswd[$key]\" ><br>\n";
            }
            $content .= "</td></tr>\n";
        }
    }
    // ligne pour nouvelle reservation
    $listaction = "<OPTION value=\"reserver\">Reserver (ordinateur)</OPTION>\n";
    $listaction .= "<OPTION value=\"imprimante\">Reserver (imprimante)</OPTION>\n";

    $content .= "<tr><td>\n";
    $content .= "<input type=\"text\" maxlength=\"15\" SIZE=\"15\" value=\"nouvelle IP...\"  name=\"ip[]\" >\n";
    $content .= "</td><td>\n";
    $content .= "<input type=\"text\" maxlength=\"17\" SIZE=\"17\" value=\"nouvelle MAC...\"  name=\"mac[]\" >\n";
    $content .= "</td><td>\n";
    $content .= "<input type=\"text\" maxlength=\"20\" SIZE=\"20\" value=\"nouveau nom...\"  name=\"name[]\" >\n";
    // $content .= "<input type=\"hidden\" maxlength=\"20\" SIZE=\"20\" value=\"" . $lease["name"] . "\" oldname=\"oldname[$key]\" >\n";
    $content .= "</td><td align=\"center\">\n";
    $content .= "<SELECT  name=\"action_res[]\">";
    $content .= "<OPTION value=\"none\">" . gettext("Action...") . "</OPTION>";
    $content .= $listaction;
    // $content .= "<OPTION value=\"reserver2\">Reserver hors plage de reservation</OPTION>\n";
    $content .= "</SELECT>\n";
    $content .= "</td>\n";
    $content .= "<td align=\"center\">\n";
    if ($showid) {
        $content .= "Admin local : <input type=\"text\" maxlength=\"20\" SIZE=\"15\" value=\"administrateur\"  name=\"localadminname[]\" ><br>\n";
        $content .= "Mot de passe : <input type=\"password\" maxlength=\"20\" SIZE=\"8\" value=\"\"  name=\"localadminpasswd[]\" ><br>\n";
    }
    $content .= "</td></tr>\n";

    $content .= "</table>\n";
    $content .= "<input type='hidden' name='action' value='valid'>\n";
    // $content .= "<input type=\"submit\" name=\"button\" value=\"".gettext("valider")."\">\n";
    $content .= "<input type=\"submit\" name=\"button\" value=\"" . gettext("Valider les r&#233;servations") . "\">\n";
    $content .= "</form>";
    return $content;
}

// Return select form whith parc where host is not recorded

/**
 * Return select form whith parc where host is not recorded
 *
 * @Parametres $parcs parc dans lequel on veut ajouter -  $keys
 *
 * @return Affichage HTML d'un select avec la liste des parcs
 *        
 */
function form_add_to_parc($config, $parc, $key)
{
    $liste_parcs = search_parcs($config, "*", "salle");
    if (count($liste_parcs) > 0) {
        @$ret = "<SELECT  name=\"parc[$key]\">";
        $ret .= "<OPTION value=\"none\">" . gettext("Ajouter &#224; un parc...") . "</OPTION>";
        foreach ($liste_parcs as $new) {
            if ($new['name'] != $parc) {
                $ret .= "<OPTION value=\"" . $new['name'] . "\">" . $new['name'] . "</OPTION>\n";
            }
        }

        $ret .= "</SELECT>";
        return $ret;
    }
    return "";
}

/**
 * renvoie les caracteristiques du vlan correspondant a l'ip
 *
 * @Parametres $ip : Adresse IP a tester
 *
 * @return tableau associatif $reseau (en mode entier long unsigned pour calcul)
 *        
 */
function get_vlan($config, $ip)
{
    // if ($config["dhcp"] == 0) {
    // return get_network($config);
    // } else {
    $reseau = get_network($config, false);
    $calcul_inetaddr = ip2long($ip);
    foreach ($reseau['reseau'] as $key => $value) {
        if ($calcul_inetaddr == (($calcul_inetaddr | $reseau['reseau'][$key]) & $reseau['broadcast'][$key])) {
            foreach ($reseau as $nom => $vals) {
                $ret[$nom] = @$vals[$key];
            }
            return $ret;
        }
    }
    // }
}

/**
 * renvoie les caracteristiques de tous vlan
 *
 * @Parametre aucun
 *
 * @return $reseau[$vlan] tableau associatif avec les ip sous forme binaire
 *        
 */
function get_network(array $config, $ip = true)
{
    foreach ($config as $key => $param) {
        $m = $val = array();
        if (preg_match("/^dhcp_(.*)$/", $key, $val)) {
            if (preg_match("/^(.*)_([0-9]+)$/", $val[1], $m)) {
                if ($ip)
                    $dhcp[$m[1]][$m[2]] = $param;
                else
                    $dhcp[$m[1]][$m[2]] = ip2long($param);
            } else {
                if ($ip)
                    $dhcp[$val[1]][0] = $param;
                else
                    $dhcp[$val[1]][0] = ip2long($param);
            }
        }
    }
    if (! $ip) {
        foreach ($dhcp['reseau'] as $vlan => $valeur) {
            $dhcp['broadcast'][$vlan] = ip2long(long2ip($dhcp['reseau'][$vlan] | ~ $dhcp['masque'][$vlan]));
            $dhcp['ip_max'][$vlan] = ip2long(long2ip($dhcp['broadcast'][$vlan] - 2));
            $dhcp['ip_min'][$vlan] = ip2long(long2ip($dhcp['ip_min'][$vlan] ?? $dhcp['reseau'][$vlan] + 51));
        }
    }
    return $dhcp;
}

/**
 * Verifie si l'entree est dans la base SQL
 *
 * @Parametres $ip - $mac - $hostname
 *
 * @return True - False
 *        
 */
function is_recorded_in_dhcp_database($config, $ip, $mac, $hostname)
{
    $res = search_ad($config, "(&(cn=$hostname)(iphostnumber=$ip)(networkaddress=$mac))", "filter");
    if (count($res) > 0) {
        return true;
    } else {
        return false;
    }
}

/**
 * Test la presence d'une adresse MAC dans la table se3_dhcp
 *
 * @Parametres  $mac
 *
 * @return True - False
 *        
 */
function registred($config, $mac)
{
    $res = search_ad($config, $mac, "computer");
    if (count($res) > 0) {
        return true;
    } else {
        return false;
    }
}

/**
 * Test la presence d'une adresse ip dans la table se3_dhcp
 *
 * @Parametres  $ip
 *
 * @return True - False
 *        
 */
function reservation($config, $ip)
{
    $res = search_ad($config, $ip, "computer");
    if (count($res) > 0) {
        return true;
    } else {
        return false;
    }
}

// add entry in se3_dhcp mysql table for reservation

/**
 * add entry in se3_dhcp mysql table for reservation
 *
 * @Parametres $ip - $mac - $name - $force
 *
 * @return $ret
 *
 */
function add_reservation($config, $ip, $mac, $name, $force)
{
    $ret = "";
    if (set_ip_in_lan($ip)) {
        $oldip = $ip;
        if ($force == 1)
            $ip = get_free_ip2($config, $ip);
        else
            $ip = get_free_ip($config, $ip);
        if ("$ip" == "") {
            $ret = gettext("<FONT color='red'> Attention : Impossible de r&#233;server une ip dans ce vlan </FONT>");
        } else {
            $error = already_exist($config, $ip, $name, $mac);
            if ($error == "") {
                $reservation['iphostnumber'] = $ip;
                $reservation['networkaddress'] = $mac;
                set_dhcp_reservation($config, $name, $reservation);
                exec("/usr/bin/sudo /usr/share/sambaedu/scripts/sysprep.sh ldap $name $ip $mac 2>&1");
                if ($ip != $oldip) {
                    $ret = gettext("<FONT color='red'> Attention : </FONT>l'adresse choisie pour cette machine est d&#233;j&#224; prise ou elle se situe dans la plage dynamique $name --> $oldip,recherche d'une adresse libre...<br>");
                }
                $ret .= gettext("Mise en place d'une r&#233;servation pour la machine  $name --> $ip<br>");
            }
        }
    } else {
        $ret = gettext("<FONT color='red'> Attention : l'addresse choisie pour cette machine n'est pas valide </FONT>" . "$name --> $ip<br>");
    }
    return $ret;
}

/**
 * Test si une reservation existe deja pour cette machine
 *
 * @Parametres $ip : ip de la machine - $name : nom de la machine - $mac : adresse mac de la machine
 *
 * @return Affichage HTML si la machine existe deja
 *        
 */
function already_exist($config, $ip, $name, $mac)
{
    if (reservation($config, $ip)) {
        $error = "";
    } else {
        $error = gettext("Cette adresse ip est d&#233;j&#224; utilis&#233;e : " . $ip) . "\n<br />";
    }

    if (registered($config, $mac)) {
        $error .= "";
    } else {
        $error .= gettext("Cette adresse mac est d&#233;j&#224; utilis&#233;e : " . $mac) . "\n<br />";
    }

    return $error;
}

/**
 * Supprime une reservation
 *
 * @Parametres $ip : Ip de la machine - $mac : Adresse mac de la machine - $name : Nom de la machine
 *
 * @return Message d'erreur SQL en cas de non suppression
 *        
 */
function suppr_reservation($config, $name)
{
    $error = "Suppression de l'entr&#233;e pour la machine $name --> $ip<br>";
    delete_dhcp_reservation($config, $name);
    return $error;
}

/**
 * Indique l'etat du serveur DHCP
 *
 * @Parametres
 * @return Affichage HTML sur l'etat
 *        
 */
function dhcpd_status()
{
    $res = $ret = array();
    exec("sudo systemctl is-active isc-dhcp-server.service", $res, $ret);
    if ($ret == 0) {
        $content = gettext("Le serveur DHCP est : ") . "<FONT color='green'>" . gettext("actif") . "</FONT>";
    } else {
        exec("sudo systemctl status isc-dhcp-server.service", $res, $ret);
        $content = gettext("Le serveur DHCP est : ") . "<FONT color='red'>" . gettext("inactif") . "</FONT><br>";
        $content .= implode("<br>\n", $res);
    }
    return $content;
}

/**
 * Redemarre le serveur DHCP
 *
 * @Parametres
 *
 * MongoUpdateBatch@Return
 *
 */
function dhcpd_restart()
{
    system("sudo /sh/share/sambaedu/sbin/make_dhcpd_conf.sh");
}

/**
 * Stop le serveur DHCP
 *
 * @Parametres
 * MongoUpdateBatch@Return
 *
 */
function dhcpd_stop()
{
    exec("sudo systemctl stop isc-dhcp-server.service", $ret);
}

/**
 * Valide le nom d'une machine
 *
 * @Parametres  $nom : Nom a valider
 *
 * @return 0 si faux - 1 si Ok
 *        
 */
function valid_name($nom)
{
    $nom = strtoupper($nom);
    $l = strlen($nom);
    if ($l == 0) {
        print gettext("<br><I>le nom doit contenir au moins une lettre</I>");
        return 0;
    }
    if ($l > 63) {
        print gettext("<br><I>le nom $nom ne doit pas d&#233;passer 63 caract&#232;res</I>");
        return 0;
    }
    for ($i = 0; $i < $l; $i ++) {
        $c = substr($nom, $i, 1);
        if (! preg_match("/[a-zA-Z0-9_-]/", $c, $tab_err)) {
            print gettext("<br><I>caract&#232;re $c incorrect dans hostname $nom </I>");
            return 0;
        }
    }
    $prem = substr($nom, 0, 1);
    if (! preg_match("/[a-zA-Z0-9]/", $prem, $tab_err)) {
        print gettext("<br><I>le nom $nom doit commencer par une lettre ou un chiffre</I>");
        return 0;
    }
    $der = substr($nom, $l - 1, 1);
    if (! preg_match("/[a-zA-Z0-9]/", $der, $tab_err)) {
        print gettext("<br><I>le nom $nom doit finir par une lettre ou un chiffre</I>");
        return 0;
    }
    return 1;
}

/**
 * validation adresse MAC
 *
 * @Parametres  $mac adresse MAC a tester
 * @return True si OK - False si adresse MAC pas correcte
 *        
 */
function valid_mac($mac)
{
    $tab_mac = explode(':', $mac); /* transforme adresse mac en tableau de 6 octets */
    if (count($tab_mac) != 6) {
        print gettext("<br><I>Attention : une adresse MAC doit avoir la forme xx:xx:xx:xx:xx:xx</I>");
        return false;
    }
    $mac = strtoupper($mac);
    $l = strlen($mac);
    for ($i = 0; $i < $l; $i ++) {
        $c = substr($mac, $i, 1);
        if (! preg_match("/[A-F0-9:]/", $c, $tab_err)) {
            print gettext("<br><I>caract&#232;re $c incorrect dans adresse mac $mac <I>");
            return false;
        }
    }
    return true;
}

/**
 * Retourne une adresse MAC formatee en completant par des zeros a gauche
 *
 *
 * @Parametres $ch_mac: Adresse MAC a traiter
 * @return Retourne une adresse MAC formatee en completant par des zeros a gauche, sinon retourne chaine vide
 *        
 */
function format_mac($ch_mac)
{
    $ch_mac = strtoupper($ch_mac);
    $mac_retour = "";
    $tab_mac = explode(':', $ch_mac); /* transforme l'adresse mac en tableau de 4 chaines */
    if (count($tab_mac) != 6) {
        $z = count($tab_mac);
        print gettext("<br><I>Attention : une adresse mac doit avoir la forme xx:xx:xx:xx:xx:xx</I>");
        return ("");
    } else {
        for ($i = 0; $i < 6; $i ++) {
            while (strlen($tab_mac[$i]) < 2)
                $tab_mac[$i] = '0' . $tab_mac[$i];
            $mac_retour = $mac_retour . $tab_mac[$i];
            if ($i < 5)
                $mac_retour = $mac_retour . ':'; /* on ajoute un point sauf au dernier */
        }
        /* verification caracteres valides */
        if (! preg_match("/[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2}:[0-9A-F]{2}/", $mac_retour, $tab_err)) {
            print gettext("<br><I>Caract&#232;res interdits dans $mac_retour</I>");
            return ("");
        }
        return ($mac_retour);
    }
}

/**
 * Validation liste hostname
 *
 * @Parametres $liste_name Nom separes par des espaces
 *
 * @return False et message d'erreur - True si Ok
 *        
 * @note la liste doit etre une suite de noms de host separes par un espace
 *
 */
function valid_list_name($liste_name)
{
    $liste_name = trim($liste_name); /* supprime espaces a droite et a gauche */
    if ($liste_name == "")
        return 1;
    $tab_name = explode(' ', $liste_name); /* transforme la liste de noms en tableau de noms */
    $nb_name = count($tab_name);
    for ($i = 0; $i < $nb_name; $i ++) {
        $name = $tab_name[$i];
        if (! valid_name($name)) {
            print gettext("<I>nom $name incorrect</I>");
            return 0;
        }
    }
    return 1;
}

/**
 * Fonctions: Test la presence de dhcp_vlan dans la table params et en retourne la valeur
 *
 * @Parametres $dhcp_vlan_valeur : Contenu de dhcp_vlan
 *
 * @return - 0 si pas de vlan - n nombre de vlan
 *        
 */
function dhcp_vlan_test($config)
{
    // si la variable dhcp_vlan n'est pas definie on cree l'entree dans la base sql
    if ($config["dhcp"] == "") {
        return 0;
    } else {
        return $config['dhcp_vlan'];
    }
}

/**
 * Verifie l'existance des champs dans la table params pour les vlans
 *
 * @Parametres $nom_champ : Nom du champ a tester
 * MongoUpdateBatch@Return
 *
 *
 */
function dhcp_vlan_champ($nom_champ)
{
    if ($$nom_champ == "") {}
}

/**
 * rename domain client
 *
 * @Parametres $ip - $mac - $name
 *
 * @return $ret
 *
 */

?>
