<?php

/**

 * Librairie de fonctions utilisees dans l'interface d'administration parcs
 * @Projet SambaEdu

 * @Auteurs Equipe Sambaedu

 * @Version 

 * @Note: Ce fichier de fonction doit etre appele par un include

 * @Licence Distribue sous la licence GPL

 */

/**
 *
 * @Repertoire: includes/
 * file: fonc_parc.php
 *
 */
require_once ("lang.inc.php");
bindtextdomain('se4-parcs', "/var/www/sambaedu/locale");
textdomain('se4-parcs');

/**
 *
 * test si une machine cliente repond au ping
 *
 * @Parametres $ip adresse a pinguer
 * @return
 */
function fping($ip, $wait = 0.1)
{
    // verifie si une machine est online
    // port 445 pour les win et 22 pour les linux
    // renvoit true si ok
    for ($timeout = 0.1; $timeout <= $wait; $timeout = $timeout * 2) {

        if (smb($ip, $timeout)) {
            return true;
        } elseif (ssh($ip, $timeout)) {
            return true;
        }
    }

    return false;
}

/**
 *
 * teste la connexion smb sur une machine cliente
 *
 * @Parametres $ip adresse a tester
 * @return
 */
function smb($ip, $t)
{
    $fp = @fsockopen($ip, 445, $errno, $errstr, $t);
    if (! $fp) {
        return false;
    } else {
        return true;
    }
}

/**
 *
 * test la connexion ssh sur une machine cliente
 *
 * @Parametres $ip adresse a tester
 * @return
 */
function ssh($ip, $t)
{
    $fp = @fsockopen($ip, 22, $errno, $errstr, $t);
    if (! $fp) {
        return false;
    } else {
        return true;
    }
}

/**
 *
 * test si une machine cliente repond sur le port 3389
 *
 * @Parametres $ip adresse a tester
 * @return construit un fichier ts dans /tmp pour cette machine si c'est le cas
 */
function ts($ip, $t)
{
    for ($timeout = 0.1; $timeout <= $t; $timeout = $timeout * 2) {

        $fp = @fsockopen($ip, 3389, $errno, $errstr, $timeout);

        if ($fp) {
            return true;
        }
    }
    return false;
}

/**
 *
 * test si une machine cliente repond sur le port 5900 vnc
 *
 * @Parametres $ip adresse a tester
 * @return construit un fichier vnc dans /tmp pour cette machine si c'est le cas
 */
function vnc($ip, $t)
{
    for ($timeout = 0.1; $timeout <= $t; $timeout = $timeout * 2) {

        $fp = @fsockopen($ip, 5900, $errno, $errstr, $timeout);

        if ($fp) {
            return true;
        }
    }
    return false;
}

/**
 *
 * pour l'affichage des heures dans le menu planification des allumage/extinction postes
 *
 * @Parametres
 */
function heure_deroulante($config, $parcf, $jourf, $type_actionf)
{
    $authlink = db_connect($config);
    if ($parcf) {
        $resultf = mysqli_query($authlink, "select heure from actions where action='$type_actionf' and parc='$parcf' and jour='$jourf';") or die("Impossible d'effectuer la requete");

        if ($resultf) {
            $rowf = mysqli_fetch_row($resultf);
            $heuref = $rowf[0];
        }
    }
    $heuref = $heuref ?? "00:00";
    $timef = explode(":", $heuref);
    // $heure_act=date("H");
    // $minute_act=date("m");
    for ($if = 0; $if < 24; $if ++) {
        $selectedf = "";
        for ($jf = 0; $jf < 4; $jf ++) {
            $mf = $jf * 15;
            $selectedf = "";
            if (($if == $timef[0]) and ($mf == $timef[1])) {
                $selectedf = "SELECTED";
            } // elseif ($heure_act==$i-1) { $selected="SELECTED"; }
            if ($mf < 10) {
                echo "<option $selectedf >$if:0$mf</option>\n";
            } else {
                echo "<option $selectedf>$if:$mf</option>\n";
            }
            $selectedf = "";
        }
    }
    mysqli_close($authlink);
}

// test si une action d'allumage extinction est prevu sur un parc donne
// un jour donne ( retourne checked pour un select)
function jour_check($config, $parcf, $jourf, $type_actionf)
{
    $authlink = db_connect($config);
    if ($parcf) {
        $resultf = mysqli_query($authlink, "select heure from actions where parc='$parcf' and jour='$jourf' and action='$type_actionf';") or die("Impossible d'effectuer la requete");
        if ($resultf) {
            if (mysqli_num_rows($resultf) > 0) {
                return "checked";
            }
        }
    }
}

/**
 *
 * affiche le tableau detaillant l'allumage des machines et la prise de controle
 *
 * @Parametres
 * @return
 */
function detail_parc($config, $parc)
{
    require_once ("printers.inc.php");

    global $smbversion;
    echo "\n<br>\n<CENTER>\n";
    echo "<TABLE border=1 width=\"60%\">\n<tr class=menuheader style=\"height: 30\">\n";
    echo "<td align=\"center\"></td>\n";
    echo "<td align=\"center\">STATIONS CONCERNEES</td>\n";
    echo "<td align=\"center\">ETAT</td>\n";
    echo "<td align=\"center\">CONNEXIONS</td>\n";
    echo "<td align=\"center\">CONTROLE</td></tr>\n";

    $mp_all = list_members_parc($config, $parc);

    // Filtrage selon critere
    if ("$filtrecomp" == "")
        $mp = $mp_all;
    else {
        $lmloop = 0;
        $mpcount = count($mp_all);
        for ($loop = 0; $loop < count($mp_all); $loop ++) {
            $mach = $mp_all[$loop];
            if (preg_match("/$filtrecomp/", $mach))
                $mp[$lmloop ++] = $mach;
        }
    }

    if (count($mp) > 0) {
        sort($mp);
        for ($loop = 0; $loop < count($mp); $loop ++) {
            $mpenc = urlencode($mp[$loop]);
            $mp_en_cours = urldecode($mpenc);
            $mp_curr = search_machine($config, $mp_en_cours);
            if (isset($mp_curr[0]["ipHostNumber"])) {
                $iphost = $mp_curr[0]["ipHostNumber"];
            }
            // Test si on a une imprimante ou une machine
            $resultat = search_imprimantes("printer-name=$mp_en_cours", "printers");
            $suisje_printer = "0";
            for ($loopp = 0; $loopp < count($resultat); $loopp ++) {
                if ($mp_en_cours == $resultat[$loopp]['printer-name']) {
                    $suisje_printer = "1";
                    continue;
                }
            }

            // On teste si la machine a des connexions actives
            // en fonction de la version de samba
            // On ne rentre dedans que si on est pas une imprimante

            if ($suisje_printer != "1") {
                $smb_sess = get_smbsess($mp_en_cours);
                $etat_session = $smb_sess['html'];

                if (isset($mp_curr[0]["ipHostNumber"])) {
                    $iphost = $mp_curr[0]["ipHostNumber"];
                    $ping = fping($iphost);

                    // On teste si la machine est en marche ou pas
                    if ($ping) {
                        $etat = aide(gettext("La machine est actuellement allum&#233e, cliquez pour l eteindre"), "<a href=\"action_machine.php?machine=$mp_en_cours&action=shutdown&parc=$parc&retour=action_parc\"  onclick=\"if (window.confirm('Etes-vous sur de vouloir &#233;teindre la machine $mp_en_cours ?'))
                                	   	{return true;}
                				else {return false;}\"/><img type=\"image\" border=\"0\" src=\"../elements/images/enabled.png\"></a>\n");
                    } else {
                        $etat = aide(gettext("La machine est actuellement &#233;teinte, cliquez pour l allumer"), "<a href=\"action_machine.php?machine=$mp_en_cours&action=wol&parc=$parc&retour=action_parc\"><img type=\"image\" border=\"0\" src=\"../elements/images/disabled.png\"></a>\n");
                    }

                    echo "<td align=center ><a href=show_histo.php?selectionne=2&amp;mpenc=$mp_en_cours>$mp_en_cours</A></td>\n<td align=center >$etat</td>\n<td align=center>$etat_session </td>\n";
                    echo "<td align=\"center\">";
                    if ($ping) {
                        $ts = ts($iphost, 0.1);
                        $vnc = vnc($iphost);
                        if ($ts) {
                            echo $ts;
                        }
                        if ($vnc) {
                            echo $vnc;
                        }
                        if ((! $ts) and (! $vnc)) {
                            echo "<img type=\"image\" border=\"0\" src=\"../elements/images/disabled.png\">\n";
                        }
                    } else {
                        echo "<img type=\"image\" border=\"0\" src=\"../elements/images/disabled.png\">\n";
                    }
                    echo "</td></tr>\n";
                }
            }
        }
    }
    echo "</table>\n";
    echo "</center>\n";
}

/**
 *
 * Affiche un tableau des imprimantes dans un parc
 *
 * @Parametres $parc le nom du parc a  tester
 * @return
 */
function detail_parc_printer($config, $parc)
{
    // include "printers.inc.php";
    $mp_all = list_members_parc($config, $arc);

    // Filtrage selon critere
    if ("$filtrecomp" == "")
        $mp = $mp_all;
    else {
        $lmloop = 0;
        $mpcount = count($mp_all);
        for ($loop = 0; $loop < count($mp_all); $loop ++) {
            $mach = $mp_all[$loop];
            if (preg_match("/$filtrecomp/", $mach))
                $mp[$lmloop ++] = $mach;
        }
    }

    if (count($mp) > 0) {
        sort($mp);

        $tableau_printer = "\n<br>\n<CENTER>\n";
        $tableau_printer .= "<TABLE border=1 width=\"60%\">\n<tr class=menuheader style=\"height: 30\">\n";
        $tableau_printer .= "<td align=\"center\"></td>\n";
        $tableau_printer .= "<td align=\"center\">Imprimantes</td>\n";
        $tableau_printer .= "<td align=\"center\">Etat</td>\n";

        $tableau_printer .= "<td align=\"center\">Travaux d'impression</td>\n";
        $tableau_printer .= "</tr>\n";

        $suisje_printer = "0";
        for ($loop = 0; $loop < count($mp); $loop ++) {
            $mpenc = urlencode($mp[$loop]);
            $mp_en_cours = urldecode($mpenc);
            $mp_curr = search_machine($config, $mp_en_cours);

            // Test si on a une imprimante ou une machine
            $resultat = search_imprimantes("printer-name=$mp_en_cours", "printers");
            for ($loopp = 0; $loopp < count($resultat); $loopp ++) {
                if ($mp_en_cours == $resultat[$loopp]['printer-name']) {
                    $suisje_printer = "1";
                    $tableau_printer .= "<tr>";
                    $tableau_printer .= "<td align=\"center\"><img style=\"border: 0px solid ;\" src=\"../elements/images/printer.png\" title=\"Imprimante\" alt=\"Imprimante\"></TD>";

                    $tableau_printer .= "<TD align=\"center\"><A href='../printers/view_printers.php?one_printer=$mp_en_cours'>$mp_en_cours</A></TD>\n";

                    $printer = $mp_en_cours;
                    $sys = exec("/usr/bin/lpstat -p $printer | grep enabled");
                    $sys2 = exec("/usr/bin/lpstat -a $printer | grep not");

                    if (($sys != "") and ($sys2 == "")) {
                        $tableau_printer .= "<TD align=\"center\"><u onmouseover=\"this.T_SHADOWWIDTH=5;this.T_STICKY=1;return escape('$printer est actuellement active.')\"><img type=\"image\" border=\"0\" src=\"../elements/images/enabled.png\"></u>\n";
                    } else {
                        if ($sys2 == "") {
                            $tableau_printer .= "<TD align=\"center\"><u onmouseover=\"this.T_SHADOWWIDTH=5;this.T_STICKY=1;return escape('$printer est actuellement inactive. Les documents sont stock&#233;s dans la file d impression.')\"><img type=\"image\" border=\"0\" src=\"../elements/images/disabled.png\"></u>\n";
                        } else {
                            $tableau_printer .= "<TD align=\"center\"><u onmouseover=\"this.T_SHADOWWIDTH=5;this.T_STICKY=1;return escape('$printer rejette actuellement tout travail d impression.')\"><img type=\"image\" border=\"0\" src=\"../elements/images/disabled.png\"></u>\n";
                        }
                    }
                    $tableau_printer .= "</TD>\n";

                    // Travaux d'impression
                    $sys = exec("/usr/bin/lpstat -o $printer");
                    if ($sys != "") {
                        $tableau_printer .= "<TD align=\"center\"><img type=\"image\" border=\"0\" src=\"../elements/images/enabled.png\">\n";
                    } else {
                        $tableau_printer .= "<TD align=\"center\"><img type=\"image\" border=\"0\" src=\"../elements/images/disabled.png\">\n";
                    }

                    $tableau_printer .= "</tr>\n";
                    continue;
                }
            }
        }
        $tableau_printer .= "</table></center>";
        if ($suisje_printer == "1") {
            echo $tableau_printer;
            echo "<br>";
        }
    }
}

/**
 *
 * Cette machine a-t-elle ete validee pour la liaison ssh?
 *
 * @Parametres $mpenc le nom de la machine a tester
 * @return
 */
function deja_valid($mpenc)
{
    $fichier_valid = "/var/se3/unattended/install/computers/$mpenc.tmp";

    if (! (file_exists($fichier_valid) and (filesize($fichier_valid) > 2))) {
        return aide(gettext("Cette machine n a jamais &eacute;t&eacute; valid&eacute;e compl&egrave;tement"), "<img src=\"../elements/images/serviceevent.gif\" alt=\"" . gettext("Machine jamais valid&eacute;e") . "\"  width=\"20\" height=\"20\" border=\"0\" />");
    } else {
        return aide(gettext("Pour supprimer ce poste de la liste des clients valid&eacute;s, n&eacute;c&eacute;ssaire si <ul><li>un poste est r&eacute;install&eacute; </li><li>apr&egrave;s un clonage</li><li>apr&egrave;s une r&eacute;instalation du client ssh</li></ul>"), "<a href=\"install_locale.php?action=trash&mpenc=$mpenc\"><img src=\"../elements/images/edittrash.png\" alt=\"Supprimer un client\" title=\"Supprimer $mpenc\" width=\"16\" height=\"16\" border=\"0\" /></a>");
    }
}

/**
 *
 * Supprime l'anti slash
 *
 * @Parametres $string la chaine a traiter
 * @return
 */
function enleveantislash($string)
{
    $temp = rawurlencode($string);
    $temp1 = preg_replace("/%5C%27/", "%27", $temp);
    $temp2 = preg_replace("/%5C%22/", "%22", $temp1);
    $final = rawurldecode($temp2);
    return $final;
}

/**
 *
 * Supprime la double barre
 *
 * @Parametres $string la chaine a traiter
 * @return
 */
function enlevedoublebarre($string)
{
    $temp = rawurlencode($string);
    $temp1 = preg_replace("/%5C%5C/", "%5C", $temp);
    $final = rawurldecode($temp1);
    return $final;
}

/**
 *
 * Test reponse d'une url
 *
 * @Parametres $string la chaine a traiter
 * @return
 */
function filemtime_remote($uri)
{
    $uri = parse_url($uri);
    $handle = @fsockopen($uri['host'], 80);
    if (! $handle)
        return 0;

    fputs($handle, "GET $uri[path] HTTP/1.1\r\nHost: $uri[host]\r\n\r\n");
    $result = 0;
    while (! feof($handle)) {
        $line = fgets($handle, 1024);
        if (! trim($line))
            break;

        $col = strpos($line, ':');
        if ($col !== false) {
            $header = trim(substr($line, 0, $col));
            $value = trim(substr($line, $col + 1));
            if (strtolower($header) == 'last-modified') {
                $result = strtotime($value);
                break;
            }
        }
    }
    fclose($handle);
    return $result;
}

/*
 * fonction generant un tableau global a partir de smbstatus
 * on cache le resultat avec apc 1 minutes afin de reduire la charge de la recherche des machines
 *
 * c'est nul, et super lent... a refaire autrement
 *
 * @Parametres : aucun
 * @ smbstatus["machine"]["login"=>]
 * ["ip"=>]
 */
function smbstatus(array $config)
{
/*    while (apcu_fetch('smb_lock')) {
        sleep(1);
    }
*/    $status = apcu_fetch('smb_login', $success);
    if (! $success) {
//        apcu_add('smb_lock', 1, 300);
        $status = array();
        $filename = "/tmp/smbstatus";
        $h = fopen($filename, "r");
        $leases = import_dhcp_leases($config);
        if ($h) {
            while (! feof($h)) {
                $fields = explode(" ", fgets($h));
                if (count($fields) == 2) {
                    $ip = rtrim($fields[1]);
                    $host = $ip; // gethostbyaddr($ip);
                    if ($host == $ip) {
                        if ($lease = get_dhcp_lease($config, $leases, $ip)) {
                            $host = $lease['name'];
                        }
                    }
                    $machine = search_machine($config, $host, false);
                    if (count($machine) == 0) {
                        $machine = search_machine($config, $fields[0], false);
                    }
                    if (count($machine) > 0) {
                        if (strcasecmp($machine['samaccountname'] ?? "", $fields[0])) {
                            $user = $fields[0];
                        } else {
                            $user = "wpkg";
                        }
                        $host = $machine['cn'];
                    } else {
                        $user = $fields[0];
                        $host = $ip;
                    }
                    $status[] = array(
                        'login' => $user,
                        'ip' => $ip,
                        'machine' => $host
                    );
                }
            }
            fclose($h);
        }
        apcu_add('smb_login', $status, 300);
//        apcu_delete('smb_lock');
    }
    return ($status);
}

function machine_smbstatus(array $config, $machine)
{
    $user = "";
    $computer = search_machine($config, $machine, false);
    if (! empty($computer['iphostnumber'])) {
        $filename = "/tmp/smbstatus";
        $h = fopen($filename, "r");
        if ($h) {
            while (! feof($h)) {
                $line = fgets($h);
                if (preg_match("/" . $computer['iphostnumber'] . "/", $line)) {
                    $fields = explode(" ", $line);
                    if (count($fields) == 2) {
                        $u = rtrim($fields[0]);
                        if (! preg_match("/^.*$$/", $u) && $u != "root" && $u != "Debian-gdm") {
                            $user = $u;
                            break;
                        } else {
                            $user = "wpkg";
                        }
                    }
                }
            }
            fclose($h);
        }
    }
    return $user;
}

/*
 * fonction destinee a determiner si on a une machine ou une imprimante
 * @Parametres $device : Nom de l'unite a verifier
 */
// function is_printer($device) {
function is_printer($config, $device)
{
    // require_once "config.inc.php";
    // require_once ("ihm.inc.php");
    // require_once("ldap.inc.php");
    /*
     * require_once ("printers.inc.php");
     * $resultat = search_imprimantes("printer-name=$device", "printers");
     * $suisje_printer = "0";
     * for ($loopp = 0; $loopp < count($resultat); $loopp ++) {
     * if ($device == $resultat[$loopp]['printer-name']) {
     * $suisje_printer = "1";
     * return true;
     * break;
     * }
     * }
     */
    return false;
}

/*
 * fonction destinee a connaitre l'etat de la session samba d'une machine
 * @Parametres $device : Nom de la machine
 * obsolete
 */
function get_smbsess(array $config, string $machine)
{
    if ($machine) {
        $message = "messages/" . $config['lang'] . "/action_parc_messages.php";
        require ($message);

        $status = get_machine_status($config, $machine);
        $login = false;
        $etat_session = "";
        if (empty($status['user'][0]['name'])) {
            $etat_session = "<img type=\"image\" src=\"../elements/images/disabled.png\">\n";
        } elseif ($status['user'][0]['name'] == $config['se4install_name']) {
            $texte = $status['user'][0]['name'] . $action_parc['msgUserLogged'];
            $etat_session .= "<img onmouseout=\"UnTip();\" onmouseover=\"Tip('" . $texte . "',WIDTH,250,SHADOW,true,DURATION,5000);\" src=\"../elements/images/travaux2.png\" border=\"0\" />";
        } else {
            $texte = $status['user'][0]['name'] . $action_parc['msgUserLogged'];
            $etat_session .= "<img onmouseout=\"UnTip();\" onmouseover=\"Tip('" . $texte . "',WIDTH,250,SHADOW,true,DURATION,5000);\" src=\"../elements/images/enabled.png\" border=\"0\" />";
        }
        return array(
            'login' => $status['user'][0]['name'],
            'html' => $etat_session
        );
    } else {
        return false;
    }
}

/*
 * fonction destinee a connaitre l'etat de la session samba d'une machine
 * @Parametres $user : Nom de l'utilisateur
 *
 * obsolete
 *
 * @Return : array machines
 */
function get_smbmachine(array $config, string $user)
{
    $status = smbstatus($config);
    $machines = array();
    foreach ($status as $session) {
        if (strcasecmp($session['login'], $user) == 0) {
            $machines[] = $session['machine'];
        }
    }
    return $machines;
}

/*
 * fonction destinee rebooter une machine
 * @Parametres $ip : adresse ip
 * $nom : nom machnie
 * $wake : action
 * $shutdownreboot
 */
function wake_shutdown_or_reboot($config, $ip, $nom, $wake, $shutdown_reboot)
{
    $message = "messages/" . $config['lang'] . "/action_parc_messages.php";
    require ($message);

    global $restriction_parcs, $tab_delegated_parcs;
    if ($restriction_parcs == 'y') {
        $temoin_erreur = "y";
        for ($loop = 0; $loop < count($tab_delegated_parcs); $loop ++) {
            // La machine est-elle dans un des parcs délégués?
            if (is_machine_in_parc($config, $nom, $tab_delegated_parcs[$loop])) {
                $temoin_erreur = 'n';
                break;
            }
        }
        if ($temoin_erreur == "y") {
            echo "<p style='color:red'>La machine $nom n'est pas dans un de vos parcs delegues.</p>\n";
            die();
        }
    }

    if (fping($ip)) {
        $smb_login = smbstatus($config);
        if ($shutdown_reboot == "wait1") {
            echo $action_parc['msgNoSignal'];
        } elseif ($shutdown_reboot == "wait2") {
            $login = $smb_login[$nom]['login'];
            if (! ($login)) {
                @start_poste($config, "shutdown", $nom);
                echo $action_parc['cmdSendReboot'];
            } else {
                echo $login . $action_parc['msgUserIsLogged'];
            }
        } elseif ($shutdown_reboot == "reboot") {
            @start_poste($config, "reboot", $nom);
            echo $action_parc['msgSendReboot'];
        }
    } else {
        if ("$wake" == "y") {
            @start_poste($config, "wol", $nom);
            echo $action_parc['msgSendWakeup'];
        }
    }
}

?>
