<?php

/**
 * Librairie de fonctions utilisees dans l'interface d'administration

 * @Projet  SambaEdu

 * @Note: Ce fichier de fonction doit etre appele par un include

 * @Licence Distribue sous la licence GPL
 */

/**
 *
 * file: functions.inc.php
 *
 * @Repertoire: includes/
 */

// =================================================

/**
 * Verification du couple login / mot de passe d'un utilisateur
 *
 * @Parametres
 * @return true si le mot de passe est valide, false dans les autres cas
 * @Modif pour AD SMB4
 */
function user_valid_passwd($config, $login, $password)
{
    // return true;
    $url = "ldaps://se4ad." . $config['domain'];
    $ret = false;
    $user = search_user($config, $login);
    if (count($user) > 0) {
        $login_dn = $user['dn'];
        $ds = @ldap_connect($url, $config['ldap_port']);
        if ($ds) {
            $r = @ldap_bind($ds, $login_dn, $password);
            if ($r) {
                $ret = true;
            } else {
                $ret = false;
                // print gettext("Echec de l'Authentification de $login_dn.");
            }
            @ldap_unbind($ds);
            @ldap_close($ds);
        } else {
            $ret = false;
            // print $ret = gettext("Erreur de connection au serveur AD");
        }
    }
    return $ret;
    // return true;
}

function open_session($config, $login, $passwd, $al)
{
    global $MsgError, $logpath;
    $crypto_passwd = $passwd;
    $res = false;
    // Initialisation
    $auth_ldap = 0;
    session_destroy();
    /*
     * if (($al != 1) && ($config['autologon'] == "1")) {
     * $logintstsecu = exec("sudo smbstatus -p | grep \"" . $_SERVER['REMOTE_ADDR'] . "\" | grep -v root | grep -v nobody | grep -v adminse3 | grep -v unattend | wc -l");
     * if ("$logintstsecu" == "1") {
     * $loginauto = exec("sudo smbstatus -p |gawk '{if ($5==\"(" . $_SERVER['REMOTE_ADDR'] . ")\") if ( ! index(\" root nobody unattend adminse3 \", \" \" $2 \" \")) {print $2;exit}}'");
     * }
     *
     * // echo $loginauto . " __ smbstatus | grep $REMOTE_ADDR | grep home\ | head -n 1 | gawk -F' ' '{print $2}'";
     * // $loginauto=exec("smbstatus | grep \"".$REMOTE_ADDR ."\" | head -n 1 | gawk -F' ' '{print $2}'");
     * if ("$loginauto" != "") {
     * $auth_ldap = 1;
     * $login = $loginauto;
     * }
     * // echo "-->";
     * }
     */
    // if ($auth_ldap != 1) {
    // decryptage du mot de passe
    list ($passwd, $error, $ip_src, $timetotal) = decode_pass($passwd);
    // echo $passwd;///exit;
    // Si le decodage ne comporte pas d'erreur
    if (! $error) {
        $auth_ldap = user_valid_passwd($config, $login, $passwd);
        if (! $auth_ldap)
            $error = 4;
    }
    if ($error) {
        // Log en cas d'echec
        $fp = fopen($logpath . "auth.log", "a");
        if ($fp) {
            fputs($fp, "[" . $MsgError[$error] . "] " . date("Y-m-d H:i:s") . "|ip requete : " . $ip_src . "|remote ip : " . remote_ip() . "|Login : " . $login . "|TimeStamp srv : " . time() . "|TimeTotal : " . $timetotal . "\n");
            fclose($fp);
        }
    }
    // }
    if ($auth_ldap) {
        session_name("Sambaedu");
        session_start();
        $_SESSION['login'] = $login;
        $_SESSION['passwd'] = $crypto_passwd;
        $res = true;
    }

    return $res;
}

// =================================================

/**
 * Ferme la session en cours
 *
 * @Parametres
 * @return
 */
function close_session()
{
    // Destruction session php Sambaedu
    // session_name("Sambaedu");
    @session_start();
    // On detruit toutes les variables de session
    unset($_SESSION);
    // On detruit la session sur le serveur.
    session_destroy();
    // Destruction du cookie de session
    setcookie("Sambaedu", "", time() - 3600, "/", "", 0);
}

function menuprint($config, $login)
{
    global $liens, $menu;
    $rights = apcu_fetch("rights");
    if (! isset($rights[$login])) {
        $ldapright = array(
            'se3_is_admin' => have_right($config, "se3_is_admin"),
            'sambaedu_is_admin' => have_right($config, "sambaedu_is_admin"),
            'system_is_admin' => have_right($config, "system_is_admin"),
            'annu_can_read' => have_right($config, "annu_can_read"),
            'annu_is_admin' => have_right($config, "annu_is_admin"),
            'computers_is_admin' => have_right($config, "computers_is_admin"),
            'parc_can_manage' => have_right($config, "parc_can_manage"),
            'parc_can_view' => have_right($config, "parc_can_view"),
            'sovajon_is_admin' => have_right($config, "sovajon_is_admin")
        );
        $rights[$login] = $ldapright;
        apcu_store("rights", $rights);
    } else {
        $ldapright = $rights[$login];
    }
    $getintlevel = getintlevel();

    for ($idmenu = 0; $idmenu < count($liens); $idmenu ++) {
        echo "<div id=\"menu$idmenu\" style=\"position:absolute; left:10px; top:12px; width:200px; z-index:" . $idmenu . " ";
        if ($idmenu != $menu) {
            echo "; visibility: hidden";
        }
        echo "\">\n";

        echo "
        <table width=\"200\" border=\"0\" cellspacing=\"3\" cellpadding=\"6\">\n";
        $ldapright["se3_is_admin"];
        for ($menunbr = 1; $menunbr < count($liens); $menunbr ++) {
            // Test des droits pour affichage
            // if ($menunbr==1) $menutarget="_top";
            // else $menutarget="main";
            $menutarget = "main";
            $afftest = $ldapright["se3_is_admin"];
            $rightname = $liens[$menunbr][1];
            $level = $liens[$menunbr][2];
            if (($rightname == "") or ($afftest))
                $afftest = true;
            else {
                $afftest = false;
                foreach (explode("|", $rightname) as $right) {
                    $afftest = $afftest or $ldapright[$right];
                }
            }
            if ($level > $getintlevel)
                $afftest = false;
            if ($afftest)
                if (($idmenu == $menunbr) && ($idmenu != 0)) {
                    echo "
                <tr>
                    <td class=\"menuheader\">
                        <p style='margin:2px; padding-top:2px; padding-bottom:2px'><a href=\"javascript:;\" onClick=\"P7_autoLayers('menu0');return false\"><img src=\"elements/images/arrow-up.png\" width=\"20\" height=\"12\" border=\"0\" alt=\"Up\"></a>
                        <a href=\"javascript:;\" onClick=\"P7_autoLayers('menu" . $menunbr . "');return false\">" . $liens[$menunbr][0] . "</a></p>
                    </td>
                    </tr>
                    <tr>
                    <td class=\"menucell\">";
                    for ($i = 3; $i < count($liens[$menunbr]); $i += 4) {
                        // Test des droits pour affichage
                        $afftest = $ldapright["se3_is_admin"];
                        $rightname = $liens[$menunbr][$i + 2];
                        $level = $liens[$menunbr][$i + 3];
                        if (($rightname == "") or ($afftest))
                            $afftest = true;
                        else {
                            $afftest = false;
                            foreach (explode("|", $rightname) as $right) {
                                $afftest = $afftest or $ldapright[$right];
                            }
                        }
                        if ($level > $getintlevel)
                            $afftest = false;
                        if ($afftest) {
                            echo "<img src=\"elements/images/typebullet.png\" width=\"30\" height=\"11\" alt=\"\">";
                            echo "<a href=\"" . $liens[$menunbr][$i + 1] . "\" TARGET='$menutarget'>" . $liens[$menunbr][$i] . "</a><br>\n";
                        }
                    } // for i : bouche d'affichage des entrees de sous-menu
                    echo "
                    </td></tr>\n";
                } else {
                    echo "
                <tr>
                    <td class=\"menuheader\">
                    <p style='margin:2px; padding-top:2px; padding-bottom:2px'><a href=\"javascript:;\" onClick=\"P7_autoLayers('menu" . $menunbr . "');return false\">
                    <img src=\"elements/images/arrow-down.png\" width=\"20\" height=\"12\" border=\"0\" alt=\"Down\">" . $liens[$menunbr][0] . "</a></p>
                    </td></tr>\n";
                }
        } // for menunbr : boucle d'affichage des entrees de menu principales

        echo "
        </table>
</div>\n";
    } // for idmenu : boucle d'affichage des differents calques
}

// function menuprint

/**
 * Retourne le niveau de l'interface
 *
 * @Parametres
 * @return
 */
function getintlevel()
{
    /* Lis le niveau d'interface dans la table session */
    // session_name("Sambaedu");
    @session_start();
    $ret = (isset($_SESSION['level']) ? $_SESSION['level'] : 4);
    return $ret;
}

// =================================================

/**
 * Change le niveau d'interface dans la table session
 *
 * @Parametres
 * @return
 */
function setintlevel($new_level)
{
    session_name("Sambaedu");
    @session_start();
    $_SESSION['level'] = $new_level;
}

function mktable($title, $content)
{
    echo "<H3>$title</H3>";
    echo $content;
}
/**
 * Fonction de crob destinee a afficher les variables transmises d'une page a l'autre: GET, POST et SESSION
 *
 * Usage : debug_var(); en début du script à debugguer
 *
 * @Parametres
 * @return
 */
$debug_var_count = array();

function debug_var()
{
    global $debug_var_count;

    $debug_var_count['POST'] = 0;
    $debug_var_count['GET'] = 0;

    $debug_var_count['COOKIE'] = 0;

    // Fonction destinée à afficher les variables transmises d'une page à l'autre: GET, POST et SESSION
    echo "<div style='border: 1px solid black; background-color: white; color: black;'>\n";

    $cpt_debug = 0;

    echo "<p><strong>Variables transmises en POST, GET, SESSION,...</strong> (<a href='#' onclick=\"tab_etat_debug_var[$cpt_debug]=tab_etat_debug_var[$cpt_debug]*(-1);affiche_debug_var('container_debug_var_$cpt_debug',tab_etat_debug_var[$cpt_debug]);return false;\">*</a>)</p>\n";

    echo "<div id='container_debug_var_$cpt_debug'>\n";
    $cpt_debug ++;

    echo "<p>Variables envoyées en POST: ";
    if (count($_POST) == 0) {
        echo "aucune";
    } else {
        echo "(<a href='#' onclick=\"tab_etat_debug_var[$cpt_debug]=tab_etat_debug_var[$cpt_debug]*(-1);affiche_debug_var('container_debug_var_$cpt_debug',tab_etat_debug_var[$cpt_debug]);return false;\">*</a>)";
    }
    echo "</p>\n";
    echo "<blockquote>\n";
    echo "<div id='container_debug_var_$cpt_debug'>\n";
    $cpt_debug ++;

    echo "<script type='text/javascript'>
	tab_etat_debug_var=new Array();

	function affiche_debug_var(id,mode) {
		if(document.getElementById(id)) {
			if(mode==1) {
				document.getElementById(id).style.display='';
			}
			else {
				document.getElementById(id).style.display='none';
			}
		}
	}
</script>\n";

    /*
     * echo "<table summary=\"Tableau de debug\">\n";
     * foreach($_POST as $post => $val){
     * //echo "\$_POST['".$post."']=".$val."<br />\n";
     * //echo "<tr><td>\$_POST['".$post."']=</td><td>".$val."</td></tr>\n";
     * echo "<tr><td valign='top'>\$_POST['".$post."']=</td><td>".$val;
     *
     * if(is_array($_POST[$post])) {
     * echo " (<a href='#' onclick=\"tab_etat_debug_var[$cpt_debug]=tab_etat_debug_var[$cpt_debug]*(-1);affiche_debug_var('container_debug_var_$cpt_debug',tab_etat_debug_var[$cpt_debug]);return false;\">*</a>)";
     * echo "<table id='container_debug_var_$cpt_debug' summary=\"Tableau de debug\">\n";
     * foreach($_POST[$post] as $key => $value) {
     * echo "<tr><td>\$_POST['$post'][$key]=</td><td>$value</td></tr>\n";
     * }
     * echo "</table>\n";
     * //echo "<script type='text/javascript'>affiche_debug_var('debug_var_$post',tab_etat_debug_var[$cpt_debug]);</script>\n";
     * $cpt_debug++;
     * }
     *
     * echo "</td></tr>\n";
     * }
     * echo "</table>\n";
     */
    function tab_debug_var($chaine_tab_niv1, $tableau, $pref_chaine, $cpt_debug)
    {
        // global $cpt_debug;
        global $debug_var_count;

        echo " (<a href='#' onclick=\"tab_etat_debug_var[$cpt_debug]=tab_etat_debug_var[$cpt_debug]*(-1);affiche_debug_var('container_debug_var_$cpt_debug',tab_etat_debug_var[$cpt_debug]);return false;\">*</a>)\n";

        echo "<table id='container_debug_var_$cpt_debug' summary=\"Tableau de debug\">\n";
        foreach ($tableau as $post => $val) {
            echo "<tr><td valign='top'>" . $pref_chaine . "['" . $post . "']=</td><td>" . $val;

            if (is_array($tableau[$post])) {

                tab_debug_var($chaine_tab_niv1, $tableau[$post], $pref_chaine . '[' . $post . ']', $cpt_debug);

                $cpt_debug ++;
            } elseif (isset($debug_var_count[$chaine_tab_niv1])) {
                $debug_var_count[$chaine_tab_niv1] ++;
            }

            echo "</td></tr>\n";
        }
        echo "</table>\n";
    }

    echo "<table summary=\"Tableau de debug\">\n";
    foreach ($_POST as $post => $val) {
        echo "<tr><td valign='top'>\$_POST['" . $post . "']=</td><td>";
        if (is_array($val)) {
            echo "Array";
        } else {
            echo $val;
        }

        if (is_array($_POST[$post])) {
            tab_debug_var('POST', $_POST[$post], '$_POST[' . $post . ']', $cpt_debug);

            $cpt_debug ++;
        } else {
            $debug_var_count['POST'] ++;
        }

        echo "</td></tr>\n";
    }
    echo "</table>\n";

    echo "<p>Nombre de valeurs en POST: <b>" . $debug_var_count['POST'] . "</b></p>\n";
    echo "</div>\n";
    echo "</blockquote>\n";

    echo "<p>Variables envoyées en GET: ";
    if (count($_GET) == 0) {
        echo "aucune";
    } else {
        echo "(<a href='#' onclick=\"tab_etat_debug_var[$cpt_debug]=tab_etat_debug_var[$cpt_debug]*(-1);affiche_debug_var('container_debug_var_$cpt_debug',tab_etat_debug_var[$cpt_debug]);return false;\">*</a>)";
    }
    echo "</p>\n";
    echo "<blockquote>\n";
    echo "<div id='container_debug_var_$cpt_debug'>\n";
    $cpt_debug ++;
    echo "<table summary=\"Tableau de debug sur GET\">";
    foreach ($_GET as $get => $val) {
        // echo "\$_GET['".$get."']=".$val."<br />\n";
        // echo "<tr><td>\$_GET['".$get."']=</td><td>".$val."</td></tr>\n";

        echo "<tr><td valign='top'>\$_GET['" . $get . "']=</td><td>";
        if (is_array($val)) {
            echo "Array";
        } else {
            echo $val;
        }

        if (is_array($_GET[$get])) {
            tab_debug_var('GET', $_GET[$get], '$_GET[' . $get . ']', $cpt_debug);

            $cpt_debug ++;
        } else {
            $debug_var_count['GET'] ++;
        }

        echo "</td></tr>\n";
    }
    echo "</table>\n";
    echo "</div>\n";
    echo "</blockquote>\n";

    echo "<p>Variables envoyées en SESSION: ";
    if (count($_SESSION) == 0) {
        echo "aucune";
    } else {
        echo "(<a href='#' onclick=\"tab_etat_debug_var[$cpt_debug]=tab_etat_debug_var[$cpt_debug]*(-1);affiche_debug_var('container_debug_var_$cpt_debug',tab_etat_debug_var[$cpt_debug]);return false;\">*</a>)";
    }
    echo "</p>\n";
    echo "<blockquote>\n";
    echo "<div id='container_debug_var_$cpt_debug'>\n";
    $cpt_debug ++;
    echo "<table summary=\"Tableau de debug sur SESSION\">";
    foreach ($_SESSION as $variable => $val) {
        // echo "\$_SESSION['".$variable."']=".$val."<br />\n";
        echo "<tr><td>\$_SESSION['" . $variable . "']=</td><td>" . $val . "</td></tr>\n";
    }
    echo "</table>\n";
    echo "</div>\n";
    echo "</blockquote>\n";

    echo "<p>Variables envoyées en SERVER: ";
    if (count($_SERVER) == 0) {
        echo "aucune";
    } else {
        echo "(<a href='#' onclick=\"tab_etat_debug_var[$cpt_debug]=tab_etat_debug_var[$cpt_debug]*(-1);affiche_debug_var('container_debug_var_$cpt_debug',tab_etat_debug_var[$cpt_debug]);return false;\">*</a>)";
    }
    echo "</p>\n";
    echo "<blockquote>\n";
    echo "<div id='container_debug_var_$cpt_debug'>\n";
    $cpt_debug ++;
    echo "<table summary=\"Tableau de debug sur SERVER\">";
    foreach ($_SERVER as $variable => $valeur) {
        // echo "\$_SERVER['".$variable."']=".$valeur."<br />\n";
        echo "<tr><td>\$_SERVER['" . $variable . "']=</td><td>" . $valeur . "</td></tr>\n";
    }
    echo "</table>\n";
    echo "</div>\n";
    echo "</blockquote>\n";

    echo "<p>Variables envoyées en FILES: ";
    if (count($_FILES) == 0) {
        echo "aucune";
    } else {
        echo "(<a href='#' onclick=\"tab_etat_debug_var[$cpt_debug]=tab_etat_debug_var[$cpt_debug]*(-1);affiche_debug_var('container_debug_var_$cpt_debug',tab_etat_debug_var[$cpt_debug]);return false;\">*</a>)";
    }
    echo "</p>\n";
    echo "<blockquote>\n";
    echo "<div id='container_debug_var_$cpt_debug'>\n";
    $cpt_debug ++;

    echo "<table summary=\"Tableau de debug\">\n";
    foreach ($_FILES as $key => $val) {
        echo "<tr><td valign='top'>\$_FILES['" . $key . "']=</td><td>";

        if (is_array($val)) {
            echo "Array";
        } else {
            echo $val;
        }

        if (is_array($_FILES[$key])) {
            tab_debug_var('FILES', $_FILES[$key], '$_FILES[' . $key . ']', $cpt_debug);

            $cpt_debug ++;
        }

        echo "</td></tr>\n";
    }
    echo "</table>\n";

    echo "</div>\n";
    echo "</blockquote>\n";

    echo "<p>Variables COOKIES: ";
    if (count($_COOKIE) == 0) {
        echo "aucune";
    } else {
        echo "(<a href='#' onclick=\"tab_etat_debug_var[$cpt_debug]=tab_etat_debug_var[$cpt_debug]*(-1);affiche_debug_var('container_debug_var_$cpt_debug',tab_etat_debug_var[$cpt_debug]);return false;\">*</a>)";
    }
    echo "</p>\n";
    echo "<blockquote>\n";
    echo "<div id='container_debug_var_$cpt_debug'>\n";
    $cpt_debug ++;
    echo "<table summary=\"Tableau de debug sur COOKIE\">";
    foreach ($_COOKIE as $get => $val) {

        echo "<tr><td valign='top'>\$_COOKIE['" . $get . "']=</td><td>" . $val;

        if (is_array($_COOKIE[$get])) {
            tab_debug_var('COOKIE', $_COOKIE[$get], '$_COOKIE[' . $get . ']', $cpt_debug);

            $cpt_debug ++;
        } else {
            $debug_var_count['COOKIE'] ++;
        }

        echo "</td></tr>\n";
    }
    echo "</table>\n";
    echo "</div>\n";
    echo "</blockquote>\n";

    echo "<script type='text/javascript'>
	// On masque le cadre de debug au chargement:
	//affiche_debug_var('container_debug_var',var_debug_var_etat);

	//for(i=0;i<tab_etat_debug_var.length;i++) {
	for(i=0;i<$cpt_debug;i++) {
		if(document.getElementById('container_debug_var_'+i)) {
			affiche_debug_var('container_debug_var_'+i,-1);
		}
		// Variable destinée à alterner affichage/masquage
		tab_etat_debug_var[i]=-1;
	}
</script>\n";

    echo "</div>\n";
    echo "</div>\n";
}
?>
