<?php

function change_gsuite_password($config, $user, $password)
{
    require_once (dirname(__FILE__) . '/../vendor/autoload.php');

    putenv('GOOGLE_APPLICATION_CREDENTIALS=/etc/sambaedu/google-api.json');
    try {
        $client = new Google_Client();
        $client->useApplicationDefaultCredentials();
        $client->setSubject("reseau@diderot.org");
        $client->setScopes(Google_Service_Directory::ADMIN_DIRECTORY_USER);
        $service = new Google_Service_Directory($client);
        $email = $user . "@" . $config['domain'];
        $userObj = new Google_Service_Directory_User(array(
            'password' => sha1($password),
            'hashFunction' => 'SHA-1',
            'changePasswordAtNextLogin' => false
        ));

        $results = $service->users->update($email, $userObj);
        return $results->getPrimaryEmail();
    } catch (Error $ex) {
        print_r($ex->getMessage());
        return false;
    }
    
}
