<?php

function apply_partages($config, $action)
{
    $html = apcu_fetch("html_partages_" . session_id());
    $classes = apcu_fetch("folders_classes_" . session_id());
    if (count($classes) > 0) {
        $classe = array_shift($classes);
        $niveau = urldecode($classe);
        switch ($action) {
            case "create":
                $html .= "<b>Création de la classe : " . $niveau . "</b><br />\n";
            case "refresh":
                // Rafraichissement de la classe:
                $html .= "<b>rafraichissement de la classe : " . $niveau . "</b><br />\n";
                $html .= update_classes($config, $niveau);
                break;
            case "clean":
                $html .= "<b>Nettoyage de la classe : $niveau</b><br />\n";
                $reps_eleves = array();
                $reps_eleves = scandir("/var/sambaedu/Classes/Classe_" . $niveau);
                $exclusion = [
                    ".",
                    "..",
                    "_travail",
                    "_profs",
                    "_echange"
                ];
                foreach ($reps_eleves as $rep_eleve) {
                    if (! in_array($rep_eleve, $exclusion) && ! preg_match("/^\..*$/", $rep_eleve)) {
                        $rep_archive = "/var/sambaedu/Classes/Classe_" . $niveau . "/" . $rep_eleve ."/Archives";
                        if (is_dir("$rep_archive")) {
                                //echo "Suppression de $rep_archive !<br>";
                                system("/usr/bin/sudo rm -rf '" . $rep_archive . "'");
                            }
                    }
                }                
                break;
            case "delete":
                $html .= "<b>Suppression de la classe : $niveau</b>\n";
                $niveau = "/var/sambaedu/Classes/Classe_" . $niveau;
                system("/usr/bin/sudo rm -rf '" . $niveau . "'");
                if (! is_dir("$niveau")) {
                    $html .= " OK <br>\n";
                } else {
                    $html .= " Echec<br>\n";
                }
                break;
        }
        apcu_store("folders_classes_" . session_id(), $classes, 500);
        $html .= "<form action=\"rep_classes.php#end\" method=\"post\" name=\"partages\">\n";
        $html .= "<input type=\"hidden\" name=\"action\" value=\"" . $action . "\">\n";
        echo "</form>";
        if (count($classes) == 0) {
            $end = true;
        } else {
            $end = false;
        }
    } else {
        $end = true;
    }
    apcu_store("html_partages_" . session_id(), $html, 500);
    return $end;
}

function form_partages($config, $action, $select_folders_classes)
{
    $html = "<br />\n";
    // on crée le dossier si il n'existe pas
    $dirClasses = "/var/sambaedu/Classes";
    exec("sudo mkdir -p " . $dirClasses);
    // Recherche de la liste des classes dans l'annuaire
    $list_classes = list_classes($config, "*");
    $indice = 0;
    foreach (scandir($dirClasses) as $dirClasse) {
        if ((preg_match("/^Classe_/", $dirClasse)) && (! preg_match("/^Classe_grp/", $dirClasse))) {
            $dirClasse = preg_replace("/^Classe_/", "", $dirClasse);
            $dossiers_classes[] = $dirClasse;
        }
    }
    if (isset($dossiers_classes)) {
        array_multisort($dossiers_classes, SORT_STRING);
    } else
        $dossiers_classes = array();
    $new_classes = array();
    // Creation d'un tableau des nouvelles ressources a cr&#233;er par
    // elimination des ressources deja existantes
    $k = 0;
    for ($i = 0; $i < count($list_classes); $i ++) {
        // $html .= "\$list_classes[$i]=".$list_classes[$i]."<br />";
        $exist = false;
        for ($j = 0; $j < count($dossiers_classes); $j ++) {
            // $html .= "\$dossiers_classes[$j]=".$dossiers_classes[$j]."<br />";
            if ($list_classes[$i] == $dossiers_classes[$j]) {
                $exist = true;
                break;
            } else {
                $exist = false;
            }
        }

        if (! $exist) {
            $new_classes[$k]['cn'] = $list_classes[$i];
            $k ++;
        }
    }
    $old_classes = [];
    foreach ($dossiers_classes as $dossier_classe) {
        if (! in_array($dossier_classe, $list_classes)) {
            $old_classes[] = $dossier_classe;
        }
    }
    // Affichage de la table
    $html .= "<H3>Gestion des ressources classes</H3>\n";
    $html .= "<br />\n";
    $html .= "<table BORDER=1 CELLPADDING=3 CELLSPACING=1 RULES=COLS>\n";
    $html .= "<tr class=\"menuheader\" height=\"30\">\n";
    $html .= "<td align=\"center\">Classes &#224; cr&#233;er ";
    $html .= "<u onmouseover=\"return escape" . gettext("('Classes disponibles dans l\'annuaire, mais dont le r&#233;pertoire n\'a pas encore &#233;t&#233; cr&#233;&#233; sur le serveur.<br /><b>Remarque :</b> Un r&#233;pertoire peut &#234;tre cr&#233;&#233;, que si il existe une &#233;quipe correspondante.')") . "\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u></td>\n";
    $html .= "<td align=\"center\">Partages classes existants </td>";
    $html .= "<td align=\"center\">Partages classes obsolètes ";
    $html .= "</td></tr>\n";
    $html .= "<tr><td align=\"center\">\n";
    $right = have_right($config, "annu_is_admin|sovajon_is_admin");
    $admin = have_right($config, "se3_is_admin");
    // Affichage menu de s&#233;lection des sous-dossiers classes a cr&#233;er
    if (count($new_classes) > 15)
        $size = 15;
    else
        $size = count($new_classes);
    if (count($new_classes) > 0) {
        $html .= "<form action=\"rep_classes.php\" method=\"post\">\n";
        $html .= "<select size=\"" . $size . "\" name=\"folders_classes[]\" multiple=\"multiple\">\n";
        foreach ($new_classes as $new_classe) {
            if ($admin || ($right && in_array($new_classe["cn"], list_classes($config, $config['login']))))
                $html .= "<option value=" . urlencode($new_classe["cn"]) . ">" . $new_classe["cn"] . "\n";
        }
        $html .= "</select><br />\n";
        $html .= "<input type=\"hidden\" name=\"action\" value=\"create\">\n";
        $html .= "<input type=\"submit\" value=\"" . gettext("Créer") . "\">\n";
        $html .= "</form>\n";

        // V&#233;rification selection d'au moins une classe
        if ($action == "create" && empty($select_folders_classes)) {
            $html .= "<div class='error_msg'>" . gettext("Vous devez s&#233lectionner au moins une classe !") . "</div>\n";
        }
    } else {
        $html .= "<div class='error_msg'>" . gettext("Pas de nouvelles classes !") . "</div>\n";
    }

    $html .= "</td><td align=\"center\">\n";
    if (count($dossiers_classes) > 15)
        $size = 15;
    else
        $size = count($dossiers_classes);
    if (count($dossiers_classes) > 0) {
        $html .= "<form action=\"rep_classes.php\" method=\"post\">\n";
        $html .= "<select size=\"" . $size . "\" name=\"folders_classes[]\" multiple=\"multiple\">\n";
        foreach ($dossiers_classes as $dossier_classe) {
            if ($admin || ($right && in_array($dossier_classe, list_classes($config, $config['login']))))
                $html .= "<option value=" . urlencode($dossier_classe) . ">" . $dossier_classe . "\n";
        }
        $html .= "</select><br />\n";
        // $html .= "<input type=\"hidden\" name=\"refresh_classes\" value=\"true\">\n";
        $html .= "<input type=\"radio\" name=\"action\" value=\"refresh\" id = \"refresh\" checked>\n";
        $html .= "<label for=\"refresh\">Rafraîchir</label>";
        $html .= "<u onmouseover=\"return escape" . gettext("('Choisir les classes que l\'on souhaite rafra&#238;chir,<br />par exemple suite &#224; l\'ajout de nouveaux &#233;l&#232;ves.<br /> En Cas de migration d\'une ann&#233;e &#224; une autre, les dossiers de l\ann&#233;e pr&#233;c&#233;dente des &#233;l&#232;ves seront copi&#233;s dans un sous-dossier Archive dans le dossier de la nouvelle ann&#233;e.<br /> Si l\'&#233;l&#232;ve n\'est plus dans l\'&#233;tablissement, son dossier est cach&#233;.<br />')") . "\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u>\n";
        $html .= "<input type=\"radio\" name=\"action\" value=\"clean\" id = \"clean\">\n";
        $html .= "<label for=\"clean\">Nettoyer</label>";
        $html .= "<u onmouseover=\"return escape" . gettext("('Choisir les classes sur lesquels on souhaite nettoyer les dossiers archives.<br /> En Cas de migration d\'une ann&#233;e &#224; une autre, les dossiers de l\ann&#233;e pr&#233;c&#233;dente des &#233;l&#232;ves seront copi&#233;s dans un sous-dossier Archive dans le dossier de la nouvelle ann&#233;e.<br />')") . "\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u>\n";
        // $html .= "<input type=\"hidden\" name=\"delete_folders_classes\" value=\"true\">\n";
        $html .= "<input type=\"radio\" name=\"action\" value=\"delete\" id = \"delete\" onClick=\"return areyousure()\">\n";
        $html .= "<label for=\"delete\">Supprimer</label>";

        $html .= "<u onmouseover=\"return escape" . gettext("('<br /><b>Attention, la suppression entrainera la perte des donn&#233;es de la classe.</b>')") . "\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u>\n";
        $html .= "<br><input type=\"submit\" value=\"Valider\">\n";
        $html .= "</form>\n";
        // V&#233;rification selection d'au moins une classe
        if ($action == "delete" || $action == "refresh" || $action == "clean" && empty($select_folders_classes)) {
            $html .= "<div class='error_msg'>Vous devez sélectionner au moins une classe !</div>\n";
        }
    }
    $html .= "</td><td align=\"center\">\n";
    if (count($old_classes) > 15)
        $size = 15;
    else
        $size = count($old_classes);
    if (count($old_classes) > 0) {
        $html .= "<form action=\"rep_classes.php\" method=\"post\">\n";
        $html .= "<select size=\"" . $size . "\" name=\"folders_classes[]\" multiple=\"multiple\">\n";
        foreach ($old_classes as $old_classe) {
            if ($admin || ($right && in_array($old_classe, list_classes($config, $config['login']))))
                $html .= "<option value=" . urlencode($old_classe) . ">" . $old_classe . "\n";
        }
        $html .= "</select><br />\n";
        $html .= "<input type=\"hidden\" name=\"action\" value=\"delete\">\n";
        $html .= "<input type=\"submit\" value=\"supprimer\" onClick=\"return areyousure()\">\n";
        $html .= "<u onmouseover=\"return escape" . gettext("('<br /><b>Attention, la suppression entrainera la perte des donn&#233;es de la classe.</b>')") . "\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u>\n";
        $html .= "</form>\n";

        // V&#233;rification selection d'au moins une classe
        if ($action == "delete" && empty($select_folders_classes)) {
            $html .= "<div class='error_msg'>" . gettext("Vous devez s&#233lectionner au moins une classe !") . "</div>\n";
        }
    } else {
        $html .= "<div class='error_msg'>" . gettext("Pas d'ancienes classes") . "</div>\n";
    }
    $html .= "</td></tr>\n";
    $html .= "</table>\n";
    $html .= "<br />\n";
    $html .= "<H3>Rafraichir les r&#233;pertoires classes existants</H3>\n";
    $html .= "<form action=\"rep_classes.php\" method=\"post\">\n";
    $html .= "<br /><br />\n";
    $html .= "<input type=\"hidden\" name=\"action\" value=\"refresh_all\">\n";
    $html .= "<input type=\"submit\" onClick=\"alert('Cette op&#233;ration peut &#234;tre tr&#232;s longue !')\"  value=\"" . gettext("Rafraichir toutes les classes") . "\">\n";
    $html .= "<u onmouseover=\"return escape" . gettext("('Permet de reforcer les droits (ACL) sur les classes existantes.<br /><b>Attention : Cette op&#233;ration peut &#234;tre longue.</b>')") . "\"><IMG style=\"border: 0px solid ;\" SRC=\"../elements/images/system-help.png\"></u>\n";
    $html .= "</form>\n";
    return $html;
}