<?php

/**
 * Fonctions Cups

 * @Projet SambaEdu

 * @Auteurs Equipe Sambaedu, denis bonnenfant

 * 
 * @Note: Ce fichier de fonction doit etre appele par un include

 * @Licence Distribue sous la licence GPL
 */
function guid_old()
{
    $charid = strtoupper(md5(uniqid(rand(), true)));
    $hyphen = chr(45); // "-"
    $uuid = chr(123) . // "{"
    substr($charid, 0, 8) . $hyphen . substr($charid, 8, 4) . $hyphen . substr($charid, 12, 4) . $hyphen . substr($charid, 16, 4) . $hyphen . substr($charid, 20, 12) . chr(125); // "}"
    return $uuid;
}

function parse_printer_uri_old($uri, &$printer = array())
{
    if (preg_match("%^((.*):)*(.*)://((.*):(.*)@)*(.*)[:/](.*)$%", $uri, $u) == 1) {
        $printer['filtre'] = $u[2];
        $printer['protocole'] = $u[3];
        $printer['user'] = $u[4];
        $printer['password'] = $u[5];
        $printer['adresse'] = $u[7];
        $printer['port'] = $u[8];
        $printer['queue'] = $u[9] ?? "";
        return true;
    } else
        return false;
}

function list_printers_old($config, $name = "", $fast = false)
{
    $printers = $p = $s = $res = $rep = $u = array();
    exec("lpstat -s", $res);
    foreach ($res as $ligne) {
        $p = $u = $rep = $printer = array();
        if (preg_match("/^device for (.*): (.*)$/", $ligne, $p) == 1) {
            if (empty($name) || (strcasecmp($name, $p[1]) == 0)) {
                $printer['name'] = $p[1];
                $printer['url'] = $p[2];
                if (! $fast) {
                    parse_printer_uri_old($p[2], $printer);
                    exec("lpstat -l -p " . $p[1], $rep);
                    foreach ($rep as $stat) {
                        $s = $t = array();
                        $regex = "/^printer " . $p[1] . " ((is|now) (printing|idle)((.*)).  )*(.*) since (.*[0-9])( -)*$/";
                        if (preg_match($regex, $stat, $s) == 1) {
                            $printer['statut'] = $s[6];
                            $printer['etat'] = $s[3];
                            $printer['date'] = $s[7];
                        } elseif (preg_match("/^\s*(.*):[ ]?(.*)$/", $stat, $t) == 1) {
                            $printer[strtolower($t[1])] = $t[2] ?? "";
                        } else {
                            $printer['message'] = trim($stat);
                        }
                    }
                    get_smb_printer_old($config, $printer);
                    // $printer['links'] = list_printer_groups($config, $printer['name']);
                }
                $printers[] = $printer;
            }
        }
    }
    return $printers;
}

/**
 * crée une reservation ip pour l'imprimante
 * à faire avant de créer l'imprimante, on en aura besoin pour l'url de celle-ci.
 * Il faut connaitre l'adresse mac
 *
 * @param unknown $config
 * @param unknown $nom
 * @param unknown $mac
 * @param string $ip
 * @return boolean
 */
function add_printer_reservation_old($config, $nom, $mac, $ip = "")
{
    if (count(search_machine($config, $nom)) == 0) {
        // on crée une machine avec un enregistrement mac, mais on ne définit pas d'ip réservée à ce stade.
        if (create_machine($config, $nom, $config['equipements_rdn'], "reservation imprimante")) {
            if (set_dhcp_reservation($config, $nom, $ip)) {
                $printer = search_machine($config, $nom);
                if (isset($printer['iphostnumber']))
                    return $printer['iphostnumber'];
            }
        }
    }
    return false;
}

/**
 * crée ou modifie une imprimante
 *
 * @param unknown $config
 * @param string $nom
 * @param array $params
 * @return boolean
 */
function add_printer_old($config, string $nom, string $url = "", string $description = "", string $lieu = "", string $driver = "")
{
    /*
     * if (! empty($params['filtre']))
     * $url = $params['filtre'] . ":";
     * $url .= $params['protocole'] . "://";
     * $url .= $params['addresse'];
     * if (! empty($params['port']) && ($params['protocole'] == "socket"))
     * $url .= ":" . $params['port'];
     * if (! empty($params['queue']))
     * $url .= ":" . $params['queue'];
     */
    $options = " -E ";
    if (! empty($url))
        $options .= " -v " . escapeshellarg($url);
    if (! empty($description))
        $options .= " -D " . escapeshellarg($description);
    if (! empty($lieu))
        $options .= " -L " . escapeshellarg($lieu);

    $message = array();
    $ret = 1;
    exec("sudo lpadmin -p " . escapeshellarg($nom) . $options, $message, $ret);

    if ($ret == 0) {
        if (! empty($driver))
            set_smb_driver_old($config, $nom, $driver);
        return true;
    } else {
        return false;
    }
}

/**
 * supprime une imprimante
 * fait le ménage dans les gpo si besoin
 *
 * @param unknown $nom
 * @return boolean
 */
function delete_printer_old($config, $nom)
{
    $groups = list_printer_groups_old($config, $nom);
    foreach ($groups as $group) {
        foreach ($group['links'] as $g) {
            remove_printer_group_old($config, $nom, ldap_dn2cn($g));
        }
    }
    $machine = search_machine($config, $nom);
    if (isset($machine['cn'])) {
        delete_ad($config, $nom, "computer");
    }
    $message = array();
    $ret = 1;
    exec("sudo lpadmin -x " . escapeshellarg($nom), $message, $ret);
    if ($ret == 0) {
        return true;
    } else {
        return false;
    }
}

/**
 * assigne un driver à l'imprimante windows
 *
 * @param unknown $config
 * @return boolean
 */
function set_smb_driver_old($config, $printer, $driver)
{
    $message = array();
    $ret = 1;
    exec("rpcclient " . $config['se4fs_name'] . " -k -c 'setdriver \"" . $printer . "\" \"" . $driver . "\"'", $message, $ret);
    if ($ret == 0) {

        return true;
    } else {
        return false;
    }
}

/**
 * assigne un driver à l'imprimante cups
 *
 * @param unknown $config
 * @return mixed[drivers]|boolean
 */
function set_cups_driver_old($config, $printer, $driver = "everywhere")
{
    $message = array();
    $ret = 1;
    exec("sudo lpadmin -p " . escapeshellarg($printer) . " -m " . escapeshellarg($driver), $message, $ret);
    if ($ret == 0) {
        return true;
    } else {
        return false;
    }
}

/**
 * liste les drivers windows disponibles sur le serveur
 *
 * @param unknown $config
 * @return mixed[drivers]|boolean
 */
function list_smb_drivers_old($config)
{
    $message = array();
    $ret = 1;
    exec("rpcclient " . $config['se4fs_name'] . " -k -c enumdrivers", $message, $ret);
    if ($ret == 0) {
        $drivers = array();
        foreach ($message as $ligne) {
            $m = array();
            if (preg_match("/^.*Driver Name: \[(.*)\]$/", $ligne, $m) == 1) {
                $drivers[] = $m[1];
            }
        }
        return $drivers;
    } else {
        return false;
    }
}

/**
 * liste les drivers cups disponibles sur le serveur
 * obsolete, inutile depuis 2009...
 *
 * @param unknown $config
 * @return mixed[drivers]|boolean
 */
function list_cups_drivers_old($config)
{
    $message = array();
    $ret = 1;
    exec("lpinfo -m", $message, $ret);
    if ($ret == 0) {
        $drivers = $message;
        return $drivers;
    } else {
        return false;
    }
}

/**
 * liste les imprimantes windows disponibles sur le serveur
 *
 * @param unknown $config
 * @return mixed[drivers]|boolean
 */
function get_smb_printer_old($config, &$printer)
{
    $message = array();
    $ret = 1;
    $command = "rpcclient " . $config['se4fs_name'] . " -k -c 'getprinter \"" . $printer['name'] . "\"'";
    exec($command, $message, $ret);
    if ($ret == 0) {
        foreach ($message as $ligne) {
            $m = array();
            if (preg_match("/^\sdescription:\[(.*),(.*),(.*)\]$/", $ligne, $m) == 1) {
                $printer['smb_name'] = $m[1];
                $printer['smb_driver'] = $m[2];
                $printer['smb_comment'] = $m[3];
            }
        }
        return true;
    } else {
        return false;
    }
}

/**
 * liste les groupes d'une imprimante
 *
 * @param unknown $config
 * @param unknown $printer
 * @return string[][]|unknown[][]
 */
function list_printer_groups_old($config, $printer)
{
    $res = search_ad($config, $printer, "printer");
    $list = array();
    if (count($res) > 0) {
        foreach ($res as $link) {
            $type = ldap_dn2cn(ldap_dn2oudn(ldap_dn2oudn($link['dn'])));
            $gpo = ldap_dn2cn(ldap_dn2oudn(ldap_dn2oudn(ldap_dn2oudn($link['dn']))));
            $ous = gpolistcontainers($config, $gpo);
            foreach ($ous as $key => $ou_dn) {
                $ou = search_ad($config, ldap_dn2cn($ou_dn), "ou");
                if (count($ou) > 0) {
                    $type_ou = "user";
                } else {
                    $type_ou = "machine";
                }
                if (strcasecmp($type, $type_ou) != 0) {
                    unset($ous[$key]);
                }
            }
            $list[] = array(
                'gpo' => $gpo,
                'type' => strtolower($type),
                'links' => $ous
            );
        }
    }
    return $list;
}

/**
 * liste toutes les imprimantes d'un groupe, avec tous les details des gpo
 *
 * @param unknown $config
 * @param unknown $group
 * @return array|array[]
 */
function list_group_printers_old($config, $group, $fast = true)
{
    $printers = array();
    $ou = search_parcs($config, $group, "salle");
    $type = "machine";
    if (count($ou) == 0) {
        $ou = search_ad($config, $group, "ou");
        $type = "user";
    }
    if (count($ou) > 0) {
        $gpos = gpogetlink($config, $ou[0]['dn']);
        foreach ($gpos as $key => $gpo) {
            // $type_link = strtolower(ldap_dn2cn(ldap_dn2oudn(ldap_dn2oudn($gpo['dn']))));
            // if ($type == $type_link) {
            $printers = array_merge(search_ad($config, "*", "printer", "cn=" . $gpo['uuid']), $printers);
            // }
        }
        foreach ($printers as $key => $printer) {
            if (isset($printers[$key])) {
                $type_ou = strtolower(ldap_dn2cn(ldap_dn2oudn(ldap_dn2oudn($printer['dn']))));
                if ($type_ou != $type) {
                    unset($printers[$key]);
                } else {
                    $printers[$key]['type'] = $type_ou;
                    $printers[$key]['gpo'] = ldap_dn2cn(ldap_dn2oudn(ldap_dn2oudn(ldap_dn2oudn($printer['dn']))));
                    $printers[$key] = array_merge(list_printers($config, $printer['printername'], $fast)[0], $printers[$key]);
                }
            }
        }
    }
    return $printers;
}

/**
 * crée l'imprimante dans une gpo
 *
 * @param unknown $config
 * @param unknown $printer
 *            nom 
 * @param unknown $gpo
 *            guid
 * @param unknown $type
 *            user|machine
 * @return string|boolean
 */
function add_printer_policy_old($config, $printer, $gpo, $type)
{
    $parent = "CN=PushedPrinterConnections,CN=" . ucfirst($type) . ",CN=" . $gpo . ",CN=Policies,CN=System," . $config['ldap_base_dn'];
    $exist = search_ad($config, "PushedPrinterConnections", "container", "cn=" . $type . ",cn=" . $gpo);
    $guid = guid_old();
    $attrs = array(
        // 'objectClass' => array(
        // "top",
        'objectclass' => "msPrint-ConnectionPolicy",
        // ),
        'cn' => $guid,
        'name' => $guid,
        'objectCategory' => "CN=ms-Print-ConnectionPolicy,CN=Schema,CN=Configuration," . $config['ldap_base_dn'],
        // 'uNCName' => "\\\\" . $config['se4fs_name'] . "." . $config['domain'] . "\\" . $printer,
        // 'servername' => "\\\\" . $config['se4fs_name'] . "." . $config['domain'],
        'uNCName' => "\\\\" . $config['se4fs_name'] . "\\" . $printer,
        'servername' => "\\\\" . $config['se4fs_name'],
        'printerName' => $printer,
        'printAttributes' => 0
    );
    $dn = "cn=" . $guid . "," . $parent;
    $ds = bind_ad_gssapi($config);
    if (! $exist) {
        $container = array(
            'cn' => ucfirst($type),
            'objectclass' => "container"
        );
        $newdn = "CN=" .ucfirst($type).",CN=" . $gpo . ",CN=Policies,CN=System," . $config['ldap_base_dn'];
        ldap_add($ds, $newdn, $container);
        $err = ldap_error($ds);
        $container = array(
            'cn' => "PushedPrinterConnections",
            'objectclass' => "container"
        );
        $newdn = "CN=PushedPrinterConnections,CN=" . ucfirst($type) . ",CN=" . $gpo . ",CN=Policies,CN=System," . $config['ldap_base_dn'];
        ldap_add($ds, $newdn, $container);
        $err .= ldap_error($ds);
        
    }
    $ret = ldap_add($ds, $dn, $attrs);
    ldap_close($ds);
    if ($ret) {
        // ajout extension 180... correspond a la console gpo et CC13... a la console imprimante
        if ($type == "user") {
            $attrs2['gpcuserextensionnames'] = "[{8A28E2C5-8D06-49A4-A08C-632DAA493E17}{180F39F3-CF17-4C68-8410-94B71452A22D}{CC13E3F3-D6D7-4A7C-A806-085502AA8281}]]";
        } else {
            $attrs2['gpcmachineextensionnames'] = "[{8A28E2C5-8D06-49A4-A08C-632DAA493E17}{180F39F3-CF17-4C68-8410-94B71452A22D}]";
        }
        @modify_ad($config, $gpo, "gpo", $attrs2, "add");
        increment_gpo($config, $gpo);
        return true;
    } else {
        return false;
    }
}

/**
 * liste les imprimantes dans une gpo et calcule le nombre de liens
 *
 * @param unknown $config
 * @param unknown $gpo
 * @return number[][]|unknown[][]|array[][]
 */
function list_printer_policies_old($config, $gpo)
{
    $res = search_ad($config, "*", "printer", "cn=" . $gpo);
    $list = array();
    $match = false;
    if (count($res) > 0) {
        $ous = gpolistcontainers($config, $gpo);
        $count_userou = $count_machineou = 0;
        foreach ($ous as $key => $ou_dn) {
            $ou = search_ad($config, ldap_dn2cn($ou_dn), "ou");
            if (count($ou) > 0) {
                $count_userou ++;
            } else {
                $count_machineou ++;
            }
        }
        foreach ($res as $link) {
            $type = strtolower(ldap_dn2cn(ldap_dn2oudn(ldap_dn2oudn($link['dn']))));
            if ($type == "user") {
                $count = $count_userou;
            } else {
                $count = $count_machineou;
            }
            $list[$type][] = array(
                'printername' => $link['printername'],
                'count' => $count,
                'dn' => $link['dn']
            );
        }
    }
    return $list;
}

/**
 * supprime l'imprimante dans une gpo.
 * Ne supprime pas la gpo ni ses liens
 *
 * @param unknown $config
 * @param unknown $printer
 *            nom
 * @param unknown $gpo
 *            guid
 * @param unknown $type
 *            user|machine
 * @return boolean
 */
function del_printer_policy_old($config, $printer, $gpo, $type)
{
    $p = search_ad($config, $printer, "printer", "cn=" . $type . ",cn=" . $gpo);
    if (count($p) > 0) {
        $dn = $p[0]['dn'];
        $ds = bind_ad_gssapi($config);
        $ret = ldap_delete($ds, $dn);
        ldap_close($ds);
        increment_gpo($config, $gpo);
        return $ret;
    }
    return true;
}

/**
 * assigne une imprimante à un groupe (salle ou eleves|profs|administratifs) en créant une gpo si besoin, en la liant au groupe
 *
 * @param unknown $config
 * @param unknown $printer
 * @param unknown $group
 * @return boolean|unknown
 */
function add_printer_group_old($config, $printer, $group)
{
    $attrs = array();
    // si parc, gpo machine, si ou people, user
    $ou = search_parcs($config, $group, "salle");
    if (count($ou) > 0) {
        $type = "machine";
    } else {
        $ou = search_ad($config, $group, "ou");
        if (count($ou) > 0) {
            $type = "user";
        }
    }
    // ad
    // on ajoute au groupe ad correspondant, potentiellement pour les droits et les vlans
    groupaddmember($config, $printer, $group);
    // existe-t-il déjà des gpo utilisables dans ce groupe ? on utilise le premier dispo
    $gpos = list_group_printers_old($config, $group);
    if (count($gpos) > 0) {
        foreach ($gpos as $key => $gpo) {
            if ($gpo['printername'] == $printer) {
                // déjà en place
                return true;
            } else {
                $list = list_printer_policies_old($config, $gpo['gpo']);
                $p = $list[$type] ?? array();
                $nb_printers = count($p);

                if (($nb_printers > 0) && ($p[0]['count'] == 1)) {
                    // on peut ajouter
                    return add_printer_policy_old($config, $printer, $gpos[$key]['gpo'], $type);
                }
            }
        }
    } else {
        // existe-t-il des stratégies utilisables déjà configurées pour d'autres groupes ?
        $gpos = list_printer_groups_old($config, $printer);
        if (count($gpos) > 0) {
            foreach ($gpos as $key => $gpo) {
                $list = list_printer_policies_old($config, $gpo['gpo']);
                $p = $list[$type] ?? array();
                $nb_printers = count($p);

                if ($nb_printers == 0) {
                    // on peut ajouter
                    add_printer_policy_old($config, $printer, $gpos[$key]['gpo'], $type);
                    return gposetlink($config, $ou[0]['dn'], $gpos[$key]['gpo']);
                } elseif ($nb_printers == 1) {

                    return gposetlink($config, $ou[0]['dn'], $gpos[$key]['gpo']);
                }
            }
        }
        // nouvelle gpo
        $gpo = gpocreate($config, "se4_printers_" . $group . "_" . $printer);
        if ($gpo) {
            // ajout extension 180... correspond a la console gpo et CC13... a la console imprimante
            if ($type == "user") {
                $attrs['gpcuserextensionnames'] = "[{8A28E2C5-8D06-49A4-A08C-632DAA493E17}{180F39F3-CF17-4C68-8410-94B71452A22D}{CC13E3F3-D6D7-4A7C-A806-085502AA8281}]]";
            } else {
                $attrs['gpcmachineextensionnames'] = "[{8A28E2C5-8D06-49A4-A08C-632DAA493E17}{180F39F3-CF17-4C68-8410-94B71452A22D}]";
            }
            modify_ad($config, $gpo, "gpo", $attrs);
            add_printer_policy_old($config, $printer, $gpo, $type);
            return gposetlink($config, $ou[0]['dn'], $gpo);
        }
        return false;
    }
}

/**
 * supprime une imprimante d'un groupe (salle ou eleves|profs|administratifs) :
 * - la gpo contient plusieurs imprimantes, et est liée a un seul groupe : on enlève l'imprimante de la gpo
 * - la gpo contient plusieurs imprimantes, et et liée à plusieurs groupes : on supprime le lien et on recrée une gpo pour ce groupe avec les imprimantes restantes
 * - la gpo contient une seule imprimante et est liée a un seul groupe : on supprime la gpo
 * - la gpo contient une seule imprimante et est liée plusieurs groupe : on supprime le lien
 *
 * @param unknown $config
 * @param unknown $printer
 * @param unknown $group
 * @return boolean|unknown
 */
function remove_printer_group_old($config, $printer, $group)
{
    // si parc, gpo machine, si ou people, user
    $ou = search_parcs($config, $group, "salle");
    if (count($ou) > 0) {
        $type = "machine";
        $autre_type = "user";
    } else {
        $ou = search_ad($config, $group, "ou");
        if (count($ou) > 0) {
            $type = "user";
            $autre_type = "machine";
        }
    }
    groupdelmember($config, $printer, $group);
    $gpos = list_group_printers_old($config, $group);
    if (count($gpos) > 0) {
        foreach ($gpos as $gpo) {
            $list = list_printer_policies_old($config, $gpo['gpo']);
            $p = $list[$type];
            $ap = $list[$autre_type] ?? array();
            $nb_printers = count($p);
            if ($nb_printers == 1) {
                if ($p[0]['count'] == 1) {
                    if ((count($ap) == 0) || ($ap[0]['count'] == 0)) {
                        // aucun autre lien, on enleve la gpo
                        gpodellink($config, $ou[0]['dn'], $gpo['gpo']);
                        return gpodel($config, $gpo['gpo']);
                    } else {
                        // des liens dans d'autres types, on efface et on enleve le lien
                        del_printer_policy_old($config, $printer, $gpo['gpo'], $type);
                        return gpodellink($config, $ou[0]['dn'], $gpo['gpo']);
                    }
                } else {
                    // plusieurs liens
                    return gpodellink($config, $ou[0]['dn'], $gpo['gpo']);
                }
            } else {
                if ($p[0]['count'] == 1) {
                    // pas d'autre liens, on peut supprimer
                    return del_printer_policy_old($config, $printer, $gpo['gpo'], $type);
                } else {
                    // cela se complique, on enleve le lien pour ce groupe
                    gpodellink($config, $ou[0]['dn'], $gpo['gpo']);
                    // on recree une gpo avec les imprimantes restantes
                    $ret = false;
                    foreach ($list as $np) {
                        if ($np['printername'] != $printer) {
                            $ret = add_printer_group_old($config, $np['printername'], $group);
                        }
                    }
                    return $ret;
                }
            }
        }
    }
    return true;
}
?>
