<?php

function test_remote($machine, $type = "")
{
    if (empty($type) && ts($machine, .5) && vnc($machine, .5)) {
        return "all";
    } elseif ($type == "rdp" && ts($machine, .5)) {
        return "rdp";
    } elseif ($type == "vnc" && vnc($machine, .5)) {
        return "vnc";
    } else {
        return false;
    }
}

function add_unique($nom, &$liste, $first = true)
{
    $ret = array();
    if ($first)
        $ret[0] = $nom;
    foreach ($liste as $poste) {
        if ($nom['cn'] != $poste['cn'])
            $ret[] = $poste;
        elseif (! $first)
            $ret[] = $nom;
    }
    $liste = $ret;
}

function remove_unique($nom, &$liste)
{
    $ret = array();
    foreach ($liste as $poste) {
        if ($nom['cn'] != $poste['cn'])
            $ret[] = $poste;
    }
    $liste = $ret;
}

// la possibilité de faire du rdp est conditionnée à la délégation du droit "rdp"
function remote_status($config, $login, $poste, &$liste, $type = "", $force = false)
{
    $status = get_machine_status($config, $poste['cn']);

    // @TODO hack de contournement d'un pb de wol non pris en compte immédaitement
    if ($poste['status'] == "wol" && $status['state'] == "off") {
        $status['state'] == "wol";
    }
    $poste['status'] = $status['state'];
    $poste['score'] = $status['score'];

    if ($status['state'] == "windows" || $status['state'] == "wol" || $status['state'] == "ipxe") {
        // pourquoi l'ip et pas le cn ?
        if ($type = test_remote($poste['iphostnumber'], $type)) {
            $poste['type'] = $type;
            // poste allumé et opérationnel
            if (@count($status['user']) > 0) {
                foreach ($status['user'] as $user) {
                    if ($user['name'] == $login) {
                        add_unique($poste, $liste['login']);
                        return true;
                    } elseif ($user['name'] != "wpkg") {
                        return false;
                    }
                }
            } else {
                // on met ce poste en tête de liste car c'est celui demandé !
                if ($force) {
                    unset($liste['login']);
                }
                $poste['remote'] = list_remote_connexion($config, $poste['cn'], $login);
                add_unique($poste, $liste['on']);
                remove_unique($poste, $liste['wait']);
                return true;
            }
        } else {

            if (! isset($liste['wait'][0]['cn']) || ($liste['wait'][0]['cn'] != $poste['cn'])) {

                return false;
            } else {
                // le poste ne repond pas, bien qu'il soit allumé, on l'élimine
                remove_unique($poste, $liste['off']);
                remove_unique($poste, $liste['on']);
                remove_unique($poste, $liste['wait']);
                return true;
            }
        }
    } else {
        add_unique($poste, $liste['off']);
        return true;
    }
}

/**
 * Recherche une machine libre dans les parcs pour lesquels l'utilisateur a le droit de faire du rdp
 * - 1 renvoie la machine à laquelle l'utilisateur est connecté
 * - 2 renvoie une machine allumée du parc
 * - 3 essaie d'allumer une machine
 *
 * attend 2 minutes avant de passer à la machine suivante.
 * fonction pouvant être appelée en boucle pour le rafraichissement, les données sont cachées en mémoire
 *
 * @param unknown $config
 * @param unknown $login
 * @param unknown $parc
 * @return unknown
 */
function find_remote($config, $login, $machine = "", $del = false, $type = 'rdp')
{
    $liste = [
        'login' => [],
        'on' => [],
        'wait' => [],
        'off' => []
    ];
    $force = false;
    // $remote = $liste;
    if ($del) {
        // log_connexion($config, $login, $machine, 'rdp', 'blacklist');
        // start_poste($config, "shutdown", $machine);
        $machine = "";
    } else {
        $remote = apcu_fetch($type);
    }
    if (isset($remote[$login])) {
        $liste = $remote[$login];
    }
    foreach (get_user_status($config, $login) as $m) {
        $poste = search_machine($config, $m['machine']);
        remote_status($config, $login, $poste, $liste, $type);
    }

    if (empty($machine)) {
        if ($del || ! isset($remote[$login]) || (count($remote[$login]['wait']) == 0 && count($remote[$login]['off']) == 0)) {
            $parcs = list_delegations($config, $login, true, $type);
            foreach ($parcs as $parc) {
                $postes = list_members_parc($config, $parc['cn'], true, true);
                foreach ($postes as $poste) {
                    remote_status($config, $login, $poste, $liste, $type);
                }
            }
        } // else {
        foreach ($liste as $postes) {
            foreach ($postes as $poste) {
                remote_status($config, $login, $poste, $liste, $type);
            }
        }
        // }
    } else {
        $force = true;
        $poste = search_machine($config, $machine);
        if (! remote_status($config, $login, $poste, $liste, $type, true)) {
            $ret = [
                false,
                "poste indisponible : " . $poste['cn'],
                $poste['cn']
            ];
            return $ret;
        }
    }
    $wait = $liste['wait'] ?? array();
    $off = $liste['off'] ?? array();
    $on = $liste['on'] ?? array();
    if (! $force) {
        array_multisort(array_column($on, 'score'), SORT_DESC, $on);
        array_multisort(array_column($off, 'score'), SORT_DESC, $off);
    }
    if ($del) {
        array_shift($on);
        array_shift($wait);
    }
    if ((@count($liste['login']) > 0 && ! $force) || (@$liste['login'][0]['cn'] == $machine && $force)) { // && (empty($machine) || $machine == $liste['login'][0]['cn'])) {
        $poste = $liste['login'][0];
        $ret = [
            true,
            "rejoindre la session déjà ouverte sur le poste   " . $poste['cn'],
            $poste['cn']
        ];
    } elseif ((@count($on) > 0 && ! $force) || ($on[0]['cn'] == $machine && $force)) {
        $poste = $on[0];
        $ret = [
            true,
            " le poste " . $poste['cn'] . " est libre",
            $poste['cn']
        ];
        // array_shift($on);
    } elseif ((count($wait) > 0 && ! $force) || ($wait[0]['cn'] == $machine && $force)) {
        $poste = $wait[0];
        $diff = $wait[0]['timer'] + 120 - time();
        if ($diff < 0) {
            array_shift($wait);
            // array_shift($off);
            if (count($off) > 0) {
                $poste = array_shift($off);
                start_poste($config, "wol", $poste['cn']);
                $poste['timer'] = time();
                add_unique($poste, $wait);
                $ret = [
                    false,
                    "allumage impossible, on essaie " . $poste['cn'] . "...",
                    $poste['cn'],
                    true
                ];
            } else {
                $ret = [
                    false,
                    "allumage impossible.",
                    ""
                ];
            }
        } else {
            $ret = [
                false,
                "tentative d'allumage de " . $poste['cn'] . " depuis " . (120 - $diff) . " s. Patientez...",
                $poste['cn'],
                true
            ];
        }
    } elseif (count($off) > 0) {
        $poste = array_shift($off);
        start_poste($config, "wol", $poste['cn']);
        $poste['timer'] = time();

        add_unique($poste, $wait);
        $ret = [
            false,
            "tentative d'allumage de " . $poste['cn'] . ". Patientez... ",
            $poste['cn'],
            true
        ];
    } else {
        $ret = [
            false,
            "non disponible, essayez plus tard
<pre>" . print_r($liste, true) . "</pre>",
            ""
        ];
    }
    $liste['off'] = $off;
    $liste['wait'] = $wait;
    $liste['on'] = $on;

    $remote[$login] = $liste;
    apcu_store($type, $remote, 600);
    return $ret;
}

/**
 * Recherche une machine libre dans les parcs pour lesquels l'utilisateur a le droit de faire du rdp
 * - 1 renvoie la machine à laquelle l'utilisateur est connecté
 * - 2 renvoie une machine allumée du parc
 * - 3 liste les machines éteintes
 *
 *
 *
 * @param unknown $config
 * @param unknown $login
 * @return unknown
 */
function find_remote_list($config, $login, $force = false, $machine = "")
{
    $liste = [
        'login' => [],
        'on' => [],
        'wait' => [],
        'off' => []
    ];
    $remote = apcu_fetch('remote');
    if (isset($remote[$login])) { // && ! $force) {
        $liste = $remote[$login];
    }
    foreach (get_user_status($config, $login) as $m) {
        $poste = search_machine($config, $m['machine']);
        remote_status($config, $login, $poste, $liste);
    }
    // if (! isset($remote[$login]) || (count($liste['wait']) == 0 && count($liste['off']) == 0)) {
    if ($force || ! isset($remote[$login]) || (count($liste['wait']) == 0 && count($liste['off']) == 0)) {
        $parcs = list_delegations($config, $login, true, "rdp");
        $parcs = array_merge($parcs, list_delegations($config, $login, true, "vnc"));
        foreach ($parcs as $parc) {
            $postes = list_members_parc($config, $parc['cn'], true, true);
            foreach ($postes as $poste) {
                remote_status($config, $login, $poste, $liste);
            }
        }
    } else {
        foreach ($liste as $postes) {
            foreach ($postes as $poste) {
                remote_status($config, $login, $poste, $liste);
            }
        }
    }
    array_multisort(array_column($liste['wait'], 'score'), SORT_DESC, $liste['wait']);
    array_multisort(array_column($liste['on'], 'score'), SORT_DESC, $liste['on']);
    array_multisort(array_column($liste['off'], 'score'), SORT_DESC, $liste['off']);
    array_multisort(array_column($liste['login'], 'score'), SORT_DESC, $liste['login']);
    if (! empty($machine)) {
        $poste = search_machine($config, $machine);
        remote_status($config, $login, $poste, $liste, true);
    }

    $remote[$login] = $liste;
    apcu_store('remote', $remote, 600);
    return $liste;
}

function list_remote_connexion($config, $machine, $name)
{
    $type = "";
    if (! empty($config['guacamole_url'])) {
        $user = search_user($config, $name);
        $remote = search_ad($config, $machine, "remote");
        if (count($remote) > 0) {
            if (in_array($user['dn'], $remote[0]['member'])) {
                $type = $remote[0]['guacconfigprotocol'];
            }
        }
    }
    return $type;
}

/**
 * crée une connexion rdp ou vnc pour l'utilisateur sur la machine.
 * pour le moment les 2 sont exclusifs, on
 * supprime le profil existant pour créer le nouveau.
 *
 * @param unknown $config
 * @param unknown $machine
 * @param unknown $name
 * @param string $type
 * @return boolean
 */
function create_remote_connexion($config, $machine, $name, $type = "rdp")
{
    $ret = ouadd($config, "ou=rdp," . $config['ldap_base_dn'], "", "dn");
    dsacl_set($config, "ou=rdp," . $config['ldap_base_dn'], "(A;CI;RPLCRC;;;AU)");
    if (! empty($config['guacamole_url'])) {
        $user = search_user($config, $name);
        $remote = search_ad($config, $machine, "remote");
        if (count($remote) > 0) {
            if ($type != $remote[0]['guacconfigprotocol'] && in_array($user['dn'], $remote[0]['member'])) {
                delete_remote_connexion($config, $machine);
            }
            /*
             * if (! in_array($user['dn'], $remote[0]['member'])) {
             * // $ret = groupaddmember($config, $user['cn'], $remote[0]['cn']);
             * $attrs = [
             * 'member' => $user['dn']
             * ];
             * modify_ad($config, $remote[0]['cn'], $type, $attrs, "add");
             * } else {
             * $ret = true;
             * }
             * } else {
             */
        }
        $dn = "cn=remote_" . $machine . ",ou=rdp," . $config['ldap_base_dn'];
        if ($type == "rdp") {
            $attrs = array(
                'objectclass' => array(
                    'top',
                    'group',
                    'guacConfigGroup'
                ),
                'cn' => "remote_" . $machine,
                'samAccountName' => "remote_" . $machine,
                'guacConfigParameter' => array(
                    "hostname=" . $machine,
                    "port=3389",
                    "password=\${GUAC_PASSWORD}",
                    "username=\${GUAC_USERNAME}",
                    "domain=" . $config['samba_domain'],
                    "server-layout=fr-fr-azerty",
                    "ignore-cert=true",
                    "resize-method=display-update"
                ),
                'guacConfigProtocol' => "rdp",
                'member' => $user['dn']
            );
        } else {
            $attrs = array(
                'objectclass' => array(
                    'top',
                    'group',
                    'guacConfigGroup'
                ),
                'cn' => "remote_" . $machine,
                'samAccountName' => "remote_" . $machine,
                'guacConfigParameter' => array(
                    "hostname=" . $machine,
                    "port=5900",
                    "password=" . $config['vnc_password']
                ),
                'guacConfigProtocol' => "vnc",
                'member' => $user['dn']
            );
        }
        $ds = bind_ad_gssapi($config);
        $ret = ldap_add($ds, $dn, $attrs);
        ldap_close($ds);
        // }
    } else {
        // $ret = "<input type=\"hidden\" name=\"refresh\" value=\"1\">";
        $ret = true;
    }
    return $ret;
}

function delete_remote_connexion($config, $machine)
{
    if (! empty($config['guacamole_url'])) {
        return groupdel($config, "remote_" . $machine);
    } else {
        return true;
    }
}

function display_remote_list($config, $login)
{
    $html = $message = $script = "";
    $force = $refresh = false;
    $machine = $_POST['machine'] ?? $_GET['machine'] ?? "";
    $post_type = $_POST['type'] ?? "rdp";
    $action = $_POST['action'] ?? "";
    if ($action == "Actualiser") {
        $force = true;
    }
    $force = true;
    $found = false;
    $liste = find_remote_list($config, $login, $force, $machine);
    if (! empty($machine)) {
        foreach ($liste as $categorie => $postes) {
            foreach ($postes as $p => $poste) {
                if ($poste['cn'] == $machine) {
                    $found = true;
                    break;
                }
            }
            if ($found) {
                break;
            }
        }
        // $html .= "<div> connexion " . $poste['cn'] . " en $categorie index $p : </div>";
        switch ($categorie) {
            case 'login':
                $login_type = list_remote_connexion($config, $machine, $login);
            case 'on':
                if ($login_type == $post_type) {
                    $res = true;
                } else {
                    $res = create_remote_connexion($config, $machine, $login, $post_type);
                }
                if ($res) {
                    $url = $config['guacamole_url'];
                    $script = "<script type=\"text/javascript\">
        window.open('" . $url . "', 'guacamole', 'resizable=yes,height=1080,width=1920');
        </script>";
                }
                break;
            case "wait":
                $diff = $poste['timer'] + 120 - time();
                if ($diff < 0) {
                    unset($liste['wait'][$p]);
                    sleep(5);
                    $refresh = true;
                    break;
                }
                $message = (time() - $poste['timer']) . "s";
                $refresh = true;
                break;
            case "off":
                $html .= start_poste($config, "wol", $poste['cn']);
                sleep(5);
                unset($liste['off'][$p]);
                $poste['timer'] = time();
                $poste['status'] = "wol";
                add_unique($poste, $liste['wait']);
                $refresh = true;
                break;
        }
        $remote = apcu_fetch('remote');
        $remote[$login] = $liste;
        apcu_store('remote', $remote, 600);
    }
    $categories = [
        'wait' => "attente d'allumage depuis " . $message,
        'login' => "rejoindre la session déjà ouverte",
        'on' => "se connecter sur la machine",
        'off' => "allumer et se connecter à la machine"
    ];
    $html .= "<FORM action=\"\" id=\"rdp\" method=\"post\" name=\"rdp\">\n";
    $html .= "<label Choisir le poste pour la connexion à distance>";
    $html .= "<select name=\"machine\" size=6>";
    $i = 0;
    foreach ($categories as $categorie => $message) {
        if (count($liste[$categorie])) {
            $html .= "<optgroup label=\"" . $message . "\">";
            foreach ($liste[$categorie] as $poste) {
                $remote_msg = "";
                $html .= "<option value=\"" . $poste['cn'] . "\"";
                if ($i ++ == 0) { // && (empty($machine) || $machine == $poste['cn'])) {
                    $html .= " selected";
                    $type = $poste['type'] ?? $post_type;
                }
                if (($categorie == "on" || $categorie == "login") && ! empty($poste['remote'])) {
                    $remote_msg = " en attente de " . $poste['remote'];
                }
                $html .= ">" . $poste['cn'] . $remote_msg . "</option>";
            }
            $html .= "</optgroup>";
        }
    }
    $html .= "</select>";
    $html .= "</label>";
    if ($type == "all") {
        $html .= "<div>
        <input type=\"radio\" id=\"rdp\" name=\type\" value=\"rdp\"";
        if ($post_type == "rdp") {
            $html .= " checked ";
        }
        $html .= ">";
        $html .= "<label for=\"rdp\">Connexion RDP</label>
            <input type=\"radio\" id=\"vnc\" name=\type\" value=\"vnc\"";
        if ($post_type == "vnc") {
            $html .= " checked ";
        }
        $html .= ">";
        $html .= "<label for=\"vnc\">Connexion VNC</label>
            </div>";
    } else {
        $html .= "<input type=\"hidden\" name=\"type\" value=\"" . $type . "\">";
    }
    $html .= "<div>";
    $html .= "<input type=\"submit\" name=\"action\" value=\"Valider\">";
    $html .= "</form>";
    $html .= "<FORM action=\"\" id=\"actualiser\" method=\"post\" name=\"actualiser\">\n";
    $html .= "<input type=\"hidden\" name=\"machine\" value=\"\">";
    $html .= "<input type=\"hidden\" name=\"type\" value=\"" . $post_type . "\">";
    $html .= "<input type=\"submit\" name=\"action\" value=\"Actualiser\">";
    $html .= "</form>";
    $html .= "</div>";
    if ($refresh) {
        $html .= "<script type=\"text/javascript\">
    setTimeout(function(){}, 5000);
    var wait = setTimeout(document.rdp.submit(), 10000)
</script>";
    }
    $html .= $script;

    return $html;
}

