<?php

/*
 * fonction pour lire des fichiers smb.conf
 */
function read_smb_conf()
{
    $contents = file_get_contents("/etc/samba/smb.conf");
    $contents = explode("\n", $contents);
    $pos = 0;
    $data = array();
    $m = array();
    $record = false;
    foreach ($contents as $line) {
        if (preg_match("!^\s*\[(.*)\]!", $line, $m)) {
            $section = $m[1];
            // $pos = $m[1];
        } elseif (preg_match("!^\s*[;#](.*)$!", $line, $m)) {
            // commentaires
            // $data[$section]['commentaire'][$pos] = $m[1];
        } elseif (preg_match("!^\s*(.*)\s+=\s*(.*)$!", $line, $m)) {
            $data[$section][$m[1]] = $m[2];
            // $pos =$m[1];
        }
    }
    return $data;
}

/*
 * fonction pour ecrire un fichier smb.conf, avec verification et rechargeemnt du service
 */
function write_smb_conf($conf)
{
    $lignes = array();
    foreach ($conf as $section => $data) {
        $lignes[] = "[" . $section . "]";
        foreach ($data as $key => $value) {
            $lignes[] = "    " . $key . " = " . $value;
        }
    }
    $lignes[] = null;

    // open file pointer, init flock options
    $file = "/etc/samba/smb.conf";
    $tmp = sys_get_temp_dir() . "/smb.conf";
    $lock = "/var/lock/smb.conf.lock";
    $fp = fopen($lock, 'w');
    $retries = 0;
    $max_retries = 100;

    if (! $fp) {
        return false;
    }

    // loop until get lock, or reach max retries
    do {
        if ($retries > 0) {
            usleep(rand(1, 5000));
        }
        $retries += 1;
    } while (! flock($fp, LOCK_EX) && $retries <= $max_retries);

    // couldn't get the lock
    if ($retries == $max_retries) {
        return false;
    }

    // got lock, write data
    file_put_contents($tmp, implode(PHP_EOL, $lignes) . PHP_EOL);
    system("testparm -s $tmp 2>&1 | grep -q OK", $test);
    if ($test == 0) {
        exec("sudo  mv " . $tmp . " " . $file);
        exec("smbcontrol all reload-config");
        // release lock
        flock($fp, LOCK_UN);
        fclose($fp);

        return true;
    } else {
        unlink($tmp);
        flock($fp, LOCK_UN);
        fclose($fp);

        return false;
    }
}

/*
 * fonction pour lister les partages :
 *
 */
function list_shares($samba)
{
    $shares = array();
    foreach ($samba as $section => $val) {
        if (isset($val['path'])) {
            $shares[$section] = $val;
        }
    }
    return $shares;
}

function set_samba_param($section, $param, $value = "")
{
    $smb_conf = read_smb_conf();
    if (empty($value)) {
        unset($smb_conf[$section][$param]);
        write_smb_conf($smb_conf);
    } else {
        if (@$smb_conf[$section][$param] != $value) {
            $smb_conf[$section][$param] = $value;
            write_smb_conf($smb_conf);
        }
    }
}
?>
