<?php

/**
 *  
 */
function html_user_interface($config)
{
    $login = isauth();
    $page = $_POST['page'] ?? $_GET['page'] ?? "";
    $user = search_user($config, $login, true);
    $fullName = $user['fullname'];
    $sexe = $user['sexe'] ?? "M";
    $html_top = user_interface_entete($config, $user, $fullName, $page);
    $html_foot = user_interface_footer();
    $html = '<article  >' . welcome_message($fullName, $page) . '</article>';
    switch ($page) {
        case "dx":
            disconnect();
            if (! empty($_SESSION['oauth2state'])) {
                return header("Location: " . $config['openent_uri']);
            } else {
                return (header("Location: ../index.html"));
            }
            $html = html_login_form();
            $html_top = "";
            $html_foot = "";
            break;
        case "param":
        default:
            $html .= '
            <article><h1>Vos informations</H1>' . user_infos($config, $user) . '</article>
            <article>' . change_pwd($config, $login) . '</article>
            <article>' . cloud_access($config, $login) . '</article>
            ';
            break;
        case "visio":
            $html .= '
            <article>' . visio_to_join($config, $login) . ' </article>';
            if (! is_eleve($config, $login)) {
                $html .= '
                <article> ' . form_create_bbb($config, $fullName, $sexe) . '</article>';
            }
            $html .= '
            <article>' . list_records($config, $login) . '</article>
            ';
            break;
        case "connect":
            $html .= '
            <article>' . connect_pc($config, $login) . '</article>
            ';
            break;
        case "echanges":
            $html .= '
            <article>' . echanges($config, $user) . '</article>
            ';
            break;
        case "links" :
            $html .= '
            <article>' . links($config, $user) . '</article>
            ';
            break;
    }
    return $html_top . $html . $html_foot;
}

/*
 * Formulaire pour permettre aux profs
 * d'activer/désactiver le répertoire échange
 * pour leur classe
 */
function echanges($config, $user)
{
    $html = "    ";
    $html .= " <h1>Pour chacune de vos classes vous pouvez activer ou désactiver le répertoire d'échanges.</h1>";
    /*
     * Action
     */
    $classe = $_POST['classe'] ?? "";
    $action = $_POST['action'] ?? "";
    if (! empty($classe) && ! empty($action)) {
        if ($action == "Activer") {
            $html .= update_classes($config, $classe, true, true);
        } else {
            $html .= update_classes($config, $classe, true, false);
        }
        batch_write();
        system("sudo /tmp/partages.sh");
    }
    /*
     * formulaire
     */
    $listClasses = list_classes($config, $user['cn']);
    $html .= "<ul>";

    foreach ($listClasses as $classe) {
        $html .= '<form name="echanges" action="" method="post">';
        $ClasseNomRep = "Classe_" . "$classe";
        $ClasseNomMin = strtolower($ClasseNomRep);
        $echangeDir = "/var/sambaedu/Classes/" . "$ClasseNomRep" . "/_echange";

        $check = get_facl("$echangeDir");
        if ($check["$ClasseNomMin"]['mode'] == "rwx") {
            $html .= "<li>Répertoire échange de la " . "$classe" . "  actuellement <b class='green'>activé</b>.";
            $html .= '<input type="submit" name="action" value="Désactiver">';
        } else {
            $html .= "<li>Répertoire échange de la " . "$classe" . "  actuellement <b class='red'>désactivé</b>.";
            $html .= '<input type="submit" name="action" value="Activer">';
        }
        $html .= '<input type="hidden" name="classe" value="' . $classe . '">';
        $html .= "";
        $html .= "</li>";
        $html .= "</form>";
    }
    $html .= "</ul>";
    return $html;
}

function user_infos($config, $user)
{
    $html = "";
    $list_current_groups = array();
    if (isset($user['memberof'])) {
        foreach ($user['memberof'] as $line) {
            if (preg_match("/Classe|Equipe|Profs|Eleves/i", $line)) {
                $list_current_groups[] = ldap_dn2cn($line);
            }
        }
    }
    if (rsort($list_current_groups)) {
        $html .= "<p> Vous êtes membre des groupes :\n</p>";
        foreach ($list_current_groups as $group) {
            $html .= "<LI>";
            $html .= $group;
            $html .= "</LI>\n";
        }
    }

    return $html;
}

function disconnect()
{
    return session_destroy();
}

function welcome_message($login, $page)
{
    $html = "";
    switch ($page) {
        case "dx":
            break;
        case "visio":
            $html .= "<H1>Tous les services de visioconférence</H1>";
            $html .= "<p>Si votre établissement dispose d'un serveur de visioconférence associé au serveur SambaÉdu, 
                        vous pouvez ici rejoindre un salon de visioconférence ouvert ou retrouver et 
                        lire l'enregistrement d'une conférence.</p>
                      <p>Si vous en avez les droits, vous pouvez aussi démarrer un salon.
                         Si vous quittez inopinément le salon que vous avez créé 
                        (suite à un problème de connexion par exemple) 
                        vous pouvez le retrouver ici, en rafraîchissant la page, afin de le rejoindre.</p>";
            break;
        case "connect":
            $html .= "<H1>Connectez vous à un ordinateur de l'établissement</H1>";
            $html .= "<p>Si votre établissement l'a configuré, vous pouvez utiliser ce service afin de vous connecter 
                à distance à un ordinateur du réseau.
                Vous avez la possibilité d'ouvrir une session sur un ordinateur de l'établissement.</p>
                      <p>Vous pouvez demander l'ouverture de ce droit à votre administrateur.</p>";
            break;
        case "links" :
            $html="";
            break;
        case "param":
        default:
            $html .= "<H1>Vos services</H1>";
            break;
    }
    return $html;
}

function visio_to_join($config, $login)
{
    $html = "";
    $bbb_url = explode(',', $config['bbb_server_base_url']) ?? '';
    $bbb_secret = explode(",", $config['bbb_secret']) ?? '';
    if ((! empty($bbb_url)) && (! empty($bbb_secret))) {
        require_once ("bbb.inc.php");
        $hash = md5($config['ldap_base_dn']);
        $html .= liste_meetings2join_bbb($config, $login, $bbb_url, $bbb_secret, $hash);
    }
    return $html;
}

function list_records($config, $login)
{
    $html = "";
    $suppr_html = "";
    $bbb_url = explode(',', $config['bbb_server_base_url']) ?? '';
    if (! empty($bbb_url)) {
        require_once ("bbb.inc.php");
        $bbb_secret = explode(",", $config['bbb_secret']) ?? '';
        $hash = md5($config['ldap_base_dn']);
        if (! is_eleve($config, $login)) {
            $suppr = $_POST['supprimer'] ?? "";
            if (! empty($suppr)) {
                $recordID = $_POST['recordID'] ?? "";
                $bbbServer = $_POST['bbbServer'] ?? "";
                $suppr_html .= remove_record_bbb($bbb_url, $bbb_secret, $recordID, $bbbServer);
            }
        }
        $html .= html_liste_records_bbb($config, $login, $bbb_url, $bbb_secret, $hash);
    }
    return $html . $suppr_html;
}

function connect_pc($config, $login)
{
    require_once ("remote.inc.php");
    require_once ("logs.inc.php");
    require_once ("fonc_parc.inc.php");
    require_once ("fonc_outils.inc.php");
    require_once ("dhcpd.inc.php");
    $html = "<H1>Se connecter à un ordinateur de l'établissement</H1>";
    $html .= "<center>";
    $html .= display_remote_list($config, $login);
    $html .= "</center>";
    $html .= "<p class=\"machine\">Vous pouvez vous connecter sur le poste dans la nouvelle fenêtre qui va s'ouvrir.
Pensez à bien vous déconnecter à la fin  de votre travail<br>
Si vous voulez changer de mode de connexion, ou de machine vous devez vous déconnecter, soit en fermant la session, soit en fermant guacamole (CTL + ALT + MAJ dans le navigateur, et cliquer en haut à droite sur votre nom, puis déconnecter)</p>";
    return $html;
}

function cloud_access($config, $login)
{
    $html = "<H1>Accéder aux partages  de l'établissement</H1>";
    if (isset($config['cloud_type'])) {
        $html .= "<a href='" . $config['cloud_url'] . "' title='Accéder aux partages  de l'établissement'>";
        $html .= "Par mesure de sécurité l'accès aux partages  nécessite une nouvelle authentification";
        $html .= '</a>';
    }
    return $html;
}


function links($config, $login)
{
    $html = "<H1>Les liens vers les services de l'établissement</H1>";
    if (isset($config['cloud_type'])) {
        $html .= "<li><a href='" . $config['cloud_url'] . "' title='Accéder aux partages'>";
        $html .= "Accéder à vos documents ";
        $html .= '</a> sur le cloud.</li>';
    }
    

    
    if (isset($config['link_url'])) {
        $link_url_array = explode(",", $config['link_url']);
        $link_text_array = explode(",", $config['link_text']);        
        foreach ($link_url_array as $key => $value)
        {
            $html .= "<li><a href='" . $value . "' title=' '>";
            $html .= "$link_text_array[$key]";
            $html .= '</a></li>';
        }
    }
    return $html;
}




function change_pwd($config, $login)
{

    /*
     * Changement du mot de passe
     */
    $old_password = $_POST['old_password'] ?? "";
    $dummy = $_POST['dummy'] ?? "";
    $dummy1 = $_POST['dummy1'] ?? "";
    // $activate_gsuite = $_POST['activate_gsuite'] ?? "";
    $ret = [];
    $html = "";
    $ent = ((isset($_SESSION['auth']) && $_SESSION['auth'] == "ent") || (! empty($config['ent_auth']) && $config['ent_auth'] == 1));
    if (! $ent) {
        $html .= "<H1>Modifier mon mot de passe</H1>";
        if (! empty($old_password) && ! empty($dummy) && ! empty($dummy1)) {
            $test_old = user_valid_passwd($config, $login, $old_password);
            if (! $test_old) {
                $ret[] .= "Votre mot de passe actuel est érroné";
            }
            if ($dummy != $dummy1) {
                $ret[] .= "Les mots de passe ne coïncident pas";
            }
            if (! verifPwd($dummy)) {
                $ret[] .= "La complexité de votre mot de passe est insuffisante. 
                            Vous devez proposer un mot de passe d'une longueur comprise entre 4 et 8 caract&#232;res alphanum&#233;riques
                            avec obligatoirement un caract&#232;re sp&#233;cial";
            }
            if ((count($ret) < 1) && (usersetpassword($config, $login, $dummy))) {
                $ret[] .= gettext("Votre mot de passe est modifi&#233.");
            } else {
                $ret[] .= "Votre mot de passe n'a pas &#233t&#233 modifi&#233.";
            }
        }

        foreach ($ret as $message) {
            $html .= '<p class="error">' . $message . '</p>';
        }

        $html .= '<form name="chpwd" action="" method="post">
    			<label>Mot de passe actuel :</label>
                <input type="password" name="old_password" size="20">
                <label>Nouveau mot de passe :</label>
    			<input type="password" value="" name="dummy" size="20" maxlength="20">
                <label>Ressaisir nouveau mot de passe</label>
    			<input type="password" value="" name="dummy1" size="20"	maxlength="20">
                <label>Valider la modification :</label>
                <input type="submit" value="Valider">
                </form>';
    } else {
        $html .= "<H1>Identifiants ENT et SambaÉdu</H1>";
        $ent_password = $_POST['ent_password'] ?? "";
        $password2sync = $_POST['password2sync'] ?? "";
        $html_form = "";
        /*
         * on vérifie rien en dessous en fait, ce sont toujours les mêmes valeurs
         * je laisse pour debug, en replaçant $login par $_SESSION['login_ent'] dans le test
         * ça peut donner des infos
         */
        if ($login == $_SESSION['login']) {
            $html_form .= "<p>Votre identifiant ENT et SambaÉdu : <b>" . $_SESSION['login'] . "</b></p>";
        } else {
            $html_form .= "<p>Votre identifiant ENT : <b>" . $_SESSION['login_ent'] . "</b></p>";
            $html_form .= "<p>Votre identifiant SambaÉdu : <b>" . $_SESSION['login'] . "</b></p>";
        }
        $html_form .= "Vérifiez votre mot de passe afin de le synchroniser : ";
        $html_form .= '<center>
                <form name="synchropwd" action="" method="post">
    			<label>Votre mot de passe ENT :</label>
                <input type="password" name="ent_password" size="20">';
        if (! empty($config['gsuite_sync'])) {
            $html_form .= '<input type="submit" value="Valider et activer votre compte Gsuite">';
        } else {
            $html_form .= '<input type="submit" value="Valider">';
        }
        $html .= '</form>';
        $html .= '</center>';
        if (! empty($ent_password)) {
            /*
             * check du password ENT avec le ... login ENT qui n'est pas toujours le même que $login
             */
            if (! check_ent_passwd($config, $_SESSION['login_ent'], $ent_password)) {
                $html .= "<p class='error'>Votre mot de passe ENT est erroné. Recommencez ou suivez le lien de régénération de mot de passe sur l'ENT.<p>";
                $html .= $html_form;
            } elseif (user_valid_passwd($config, $login, $ent_password)) {
                if (! empty($config['gsuite_sync'])) {
                    require_once "gsuite.inc.php";
                    $email = change_gsuite_password($config, $login, $ent_password);
                    $html .= "<p class='error'>Votre compte mail est : <p>
                 <pre> $email </pre>";
                }
                $html .= "<p class='error'>Vos mots de passe sont correctement synchronisés.<p>";
            } else {
                $html .= "<p class='error'>Synchronisez le mot de passe SambaÉdu avec celui de l'ENT.</p><p class='error'> Cliquez ci-dessous.<p>";
                $html .= '<center>
                    <form name="chgpsswd" action="" method="post">
                    <input type="hidden" name="password2sync" value="' . $ent_password . '">
                    <input type="submit" value="Synchroniser">
                    </form>
                    </center>';
            }
        } elseif (! empty($password2sync)) {
            if (usersetpassword($config, $login, $password2sync)) {
                $html .= "<p class='error'>Votre mot de passe a été synchronisé sur SambaÉdu. C'est à présent le mot de passe à utiliser pour ouvrir des sessions sur les ordinateurs de l'établissement.</p>";
                if (! empty($config['gsuite_sync'])) {
                    require_once "gsuite.inc.php";
                    $email = change_gsuite_password($config, $login, $ent_password);
                    $html .= "<p> et également pour votre compte mail <pre> $email </pre><p>";
                }
            }
        } else {
            $html .= $html_form;
        }
    }
    return $html;
}

/**
 * Cracheur de html
 *
 * @param string $login
 * @return string
 */
function user_interface_entete($config, $user, $login, $page)
{
    $selected_visio = $selected_connect = $selected_links = $selected_echanges = "";
    switch ($page) {
        case "visio":
            $selected_visio = 'class="selected"';
            break;
        case "connect":
            $selected_connect = 'class="selected"';
            break;
        case "links":
            $selected_links = 'class="selected"';
            break;
        case "echanges":
            $selected_echanges = 'class="selected"';
            break;
    }
    /*
     * Pour les profs, un lien vers la gestion des partages
     */
    $html_profs = "";
    // print_r($user);
    if (is_prof($config, $user['cn'])) {
        $html_profs .= '<li '.$selected_echanges.'>
        <a href="?page=echanges">
        <svg>
        <use xlink:href="#echanges"></use>
        </svg>
        <span>Répertoires «&nbsp;échanges&nbsp;»</span>
        </a>
        </li>';
    }

    /*
     * Pour les se3_is_admin un lien vers l'interface d'admin
     */
    $html_admin = "";
    if (have_right($config, "se3_is_admin")) {
        $html_admin .= '<li>
        <a href="../admin/">
        <svg>
        <use xlink:href="#admin"></use>
        </svg>
        <span>Administration du serveur</span>
        </a>
        </li>';
    }

    $html = '
<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8" />
        <link rel="stylesheet" href="user.interface.css" />
        <title>SambaÉdu</title>
    </head>
    <body onload="collapsed()">

<svg style="display:none;">
    <symbol id="echanges" viewBox="0 0 20 20">
    <rect x="4.16" y="1.75" width="1" height="7.97"/><polygon points="7.15 8.99 4.66 13.31 2.16 8.99 7.15 8.99"/><rect x="12.84" y="11.03" width="1" height="4.97"/><polygon points="11.85 11.47 13.34 8.88 14.84 11.47 11.85 11.47"/>
    </path>
    </symbol>
    <symbol id="admin" viewBox="0 0 20 20">
    <path d="M17.498,11.697c-0.453-0.453-0.704-1.055-0.704-1.697c0-0.642,0.251-1.244,0.704-1.697c0.069-0.071,0.15-0.141,0.257-0.22c0.127-0.097,0.181-0.262,0.137-0.417c-0.164-0.558-0.388-1.093-0.662-1.597c-0.075-0.141-0.231-0.22-0.391-0.199c-0.13,0.02-0.238,0.027-0.336,0.027c-1.325,0-2.401-1.076-2.401-2.4c0-0.099,0.008-0.207,0.027-0.336c0.021-0.158-0.059-0.316-0.199-0.391c-0.503-0.274-1.039-0.498-1.597-0.662c-0.154-0.044-0.32,0.01-0.416,0.137c-0.079,0.106-0.148,0.188-0.22,0.257C11.244,2.956,10.643,3.207,10,3.207c-0.642,0-1.244-0.25-1.697-0.704c-0.071-0.069-0.141-0.15-0.22-0.257C7.987,2.119,7.821,2.065,7.667,2.109C7.109,2.275,6.571,2.497,6.07,2.771C5.929,2.846,5.85,3.004,5.871,3.162c0.02,0.129,0.027,0.237,0.027,0.336c0,1.325-1.076,2.4-2.401,2.4c-0.098,0-0.206-0.007-0.335-0.027C3.001,5.851,2.845,5.929,2.77,6.07C2.496,6.572,2.274,7.109,2.108,7.667c-0.044,0.154,0.01,0.32,0.137,0.417c0.106,0.079,0.187,0.148,0.256,0.22c0.938,0.936,0.938,2.458,0,3.394c-0.069,0.072-0.15,0.141-0.256,0.221c-0.127,0.096-0.181,0.262-0.137,0.416c0.166,0.557,0.388,1.096,0.662,1.596c0.075,0.143,0.231,0.221,0.392,0.199c0.129-0.02,0.237-0.027,0.335-0.027c1.325,0,2.401,1.076,2.401,2.402c0,0.098-0.007,0.205-0.027,0.334C5.85,16.996,5.929,17.154,6.07,17.23c0.501,0.273,1.04,0.496,1.597,0.66c0.154,0.047,0.32-0.008,0.417-0.137c0.079-0.105,0.148-0.186,0.22-0.256c0.454-0.453,1.055-0.703,1.697-0.703c0.643,0,1.244,0.25,1.697,0.703c0.071,0.07,0.141,0.15,0.22,0.256c0.073,0.098,0.188,0.152,0.307,0.152c0.036,0,0.073-0.004,0.109-0.016c0.558-0.164,1.096-0.387,1.597-0.66c0.141-0.076,0.22-0.234,0.199-0.393c-0.02-0.129-0.027-0.236-0.027-0.334c0-1.326,1.076-2.402,2.401-2.402c0.098,0,0.206,0.008,0.336,0.027c0.159,0.021,0.315-0.057,0.391-0.199c0.274-0.5,0.496-1.039,0.662-1.596c0.044-0.154-0.01-0.32-0.137-0.416C17.648,11.838,17.567,11.77,17.498,11.697 M16.671,13.334c-0.059-0.002-0.114-0.002-0.168-0.002c-1.749,0-3.173,1.422-3.173,3.172c0,0.053,0.002,0.109,0.004,0.166c-0.312,0.158-0.64,0.295-0.976,0.406c-0.039-0.045-0.077-0.086-0.115-0.123c-0.601-0.6-1.396-0.93-2.243-0.93s-1.643,0.33-2.243,0.93c-0.039,0.037-0.077,0.078-0.116,0.123c-0.336-0.111-0.664-0.248-0.976-0.406c0.002-0.057,0.004-0.113,0.004-0.166c0-1.75-1.423-3.172-3.172-3.172c-0.054,0-0.11,0-0.168,0.002c-0.158-0.312-0.293-0.639-0.405-0.975c0.044-0.039,0.085-0.078,0.124-0.115c1.236-1.236,1.236-3.25,0-4.486C3.009,7.719,2.969,7.68,2.924,7.642c0.112-0.336,0.247-0.664,0.405-0.976C3.387,6.668,3.443,6.67,3.497,6.67c1.75,0,3.172-1.423,3.172-3.172c0-0.054-0.002-0.11-0.004-0.168c0.312-0.158,0.64-0.293,0.976-0.405C7.68,2.969,7.719,3.01,7.757,3.048c0.6,0.6,1.396,0.93,2.243,0.93s1.643-0.33,2.243-0.93c0.038-0.039,0.076-0.079,0.115-0.123c0.336,0.112,0.663,0.247,0.976,0.405c-0.002,0.058-0.004,0.114-0.004,0.168c0,1.749,1.424,3.172,3.173,3.172c0.054,0,0.109-0.002,0.168-0.004c0.158,0.312,0.293,0.64,0.405,0.976c-0.045,0.038-0.086,0.077-0.124,0.116c-0.6,0.6-0.93,1.396-0.93,2.242c0,0.847,0.33,1.645,0.93,2.244c0.038,0.037,0.079,0.076,0.124,0.115C16.964,12.695,16.829,13.021,16.671,13.334 M10,5.417c-2.528,0-4.584,2.056-4.584,4.583c0,2.529,2.056,4.584,4.584,4.584s4.584-2.055,4.584-4.584C14.584,7.472,12.528,5.417,10,5.417 M10,13.812c-2.102,0-3.812-1.709-3.812-3.812c0-2.102,1.71-3.812,3.812-3.812c2.102,0,3.812,1.71,3.812,3.812C13.812,12.104,12.102,13.812,10,13.812"/>
    </symbol>
    <symbol id="visioconference" viewBox="0 0 20 20">
    <path d="M17.919,4.633l-3.833,2.48V6.371c0-1-0.815-1.815-1.816-1.815H3.191c-1.001,0-1.816,0.814-1.816,1.815v7.261c0,1.001,0.815,1.815,1.816,1.815h9.079c1.001,0,1.816-0.814,1.816-1.815v-0.739l3.833,2.478c0.428,0.226,0.706-0.157,0.706-0.377V5.01C18.625,4.787,18.374,4.378,17.919,4.633 M13.178,13.632c0,0.501-0.406,0.907-0.908,0.907H3.191c-0.501,0-0.908-0.406-0.908-0.907V6.371c0-0.501,0.407-0.907,0.908-0.907h9.079c0.502,0,0.908,0.406,0.908,0.907V13.632zM17.717,14.158l-3.631-2.348V8.193l3.631-2.348V14.158z">
    </path>
    </symbol>
    <symbol id="users" viewBox="0 0 16 16">
    <path d="M8,0a8,8,0,1,0,8,8A8,8,0,0,0,8,0ZM8,15a7,7,0,0,1-5.19-2.32,2.71,2.71,0,0,1,1.7-1,13.11,13.11,0,0,0,1.29-.28,2.32,2.32,0,0,0,.94-.34,1.17,1.17,0,0,0-.27-.7h0A3.61,3.61,0,0,1,5.15,7.49,3.18,3.18,0,0,1,8,4.07a3.18,3.18,0,0,1,2.86,3.42,3.6,3.6,0,0,1-1.32,2.88h0a1.13,1.13,0,0,0-.27.69,2.68,2.68,0,0,0,.93.31,10.81,10.81,0,0,0,1.28.23,2.63,2.63,0,0,1,1.78,1A7,7,0,0,1,8,15Z" />
    </symbol>
    <symbol id="connect" viewBox="0 0 16 16">
    <polygon points="0.64 11.85 -0.02 11.1 2.55 8.85 4.57 10.4 9.25 5.25 12.97 8.84 15.37 6.79 16.02 7.54 12.94 10.2 9.29 6.68 4.69 11.76 2.59 10.14 0.64 11.85"/>
    </symbol>
    <symbol id="links" viewBox="0 0 16 16">
    <rect x="9.78" y="5.34" width="1" height="7.97"/><polygon points="7.79 6.07 10.28 1.75 12.77 6.07 7.79 6.07"/><rect x="4.16" y="1.75" width="1" height="7.97"/><polygon points="7.15 8.99 4.66 13.31 2.16 8.99 7.15 8.99"/><rect x="1.28" width="1" height="4.97"/><polygon points="3.28 4.53 1.78 7.13 0.28 4.53 3.28 4.53"/><rect x="12.84" y="11.03" width="1" height="4.97"/><polygon points="11.85 11.47 13.34 8.88 14.84 11.47 11.85 11.47"/>
    </symbol>
    <symbol id="collapse" viewBox="0 0 16 16">
    <polygon points="11.62 3.81 7.43 8 11.62 12.19 10.09 13.71 4.38 8 10.09 2.29 11.62 3.81"/>
    </symbol>
    <symbol id="search" viewBox="0 0 16 16">
    <path d="M6.57,1A5.57,5.57,0,1,1,1,6.57,5.57,5.57,0,0,1,6.57,1m0-1a6.57,6.57,0,1,0,6.57,6.57A6.57,6.57,0,0,0,6.57,0Z"/><rect x="11.84" y="9.87" width="2" height="5.93" transform="translate(-5.32 12.84) rotate(-45)"/>
    </symbol>
    <symbol id="menu" viewBox="0 0 24 24">
    <path d="M4 22h-4v-4h4v4zm0-12h-4v4h4v-4zm0-8h-4v4h4v-4zm3 0v4h17v-4h-17zm0 12h17v-4h-17v4zm0 8h17v-4h-17v4z"/>
    </symbol>
    <symbol id="dx" viewBox="0 0 24 24">
    <path d="M8.416,3.943l1.12-1.12v9.031c0,0.257,0.208,0.464,0.464,0.464c0.256,0,0.464-0.207,0.464-0.464V2.823l1.12,1.12c0.182,0.182,0.476,0.182,0.656,0c0.182-0.181,0.182-0.475,0-0.656l-1.744-1.745c-0.018-0.081-0.048-0.16-0.112-0.224C10.279,1.214,10.137,1.177,10,1.194c-0.137-0.017-0.279,0.02-0.384,0.125C9.551,1.384,9.518,1.465,9.499,1.548L7.76,3.288c-0.182,0.181-0.182,0.475,0,0.656C7.941,4.125,8.234,4.125,8.416,3.943z M15.569,6.286h-2.32v0.928h2.32c0.512,0,0.928,0.416,0.928,0.928v8.817c0,0.513-0.416,0.929-0.928,0.929H4.432c-0.513,0-0.928-0.416-0.928-0.929V8.142c0-0.513,0.416-0.928,0.928-0.928h2.32V6.286h-2.32c-1.025,0-1.856,0.831-1.856,1.856v8.817c0,1.025,0.832,1.856,1.856,1.856h11.138c1.024,0,1.855-0.831,1.855-1.856V8.142C17.425,7.117,16.594,6.286,15.569,6.286z"/>
    </symbol>
</svg>

<header class="page-header">
  <nav>
    <a href="#0">
      <img class="logo" src="../elements/images/logo-dessus.gif" alt="SambaÉdu">
    </a>
    <button class="toggle-mob-menu" aria-expanded="false" aria-label="open menu">
      <svg width="20" height="20" aria-hidden="true">
        <use xlink:href="#menu"></use>
      </svg>
    </button>
    <ul class="admin-menu">
      <li class="menu-heading">
        <h3>Vos applications :</h3>
      </li>
      <li>
        <a href="?page=param">
          <svg>
            <use xlink:href="#users"></use>
          </svg>
          <span>Mes paramètres</span>
        </a>
      </li>
      <li ' . $selected_visio . '>
        <a href="?page=visio">
          <svg>
            <use xlink:href="#visioconference"></use>
          </svg>
          <span>Visioconférence</span>
        </a>
      </li>
      <li ' . $selected_connect . ' >
        <a href="?page=connect">
            <svg>
              <use xlink:href="#connect"></use>
            </svg>
            <span>Se connecter à un ordinateur</span>
          </a>
      </li>

      <li ' . $selected_links . '>
        <a href="?page=links">
          <svg>
            <use xlink:href="#links"></use>
          </svg>
          <span>Outils</span>
        </a>
      </li>

        ' . $html_profs . '
        
      <li>
        <a href="?page=dx">
          <svg>
            <use xlink:href="#dx"></use>
          </svg>
          <span>Se déconnecter</span>
        </a>
      </li>

      ' . $html_admin . '

      <li>
        <button class="collapse-btn" aria-expanded="true" aria-label="collapse menu">
          <svg aria-hidden="true">
            <use xlink:href="#collapse"></use>
          </svg>
          <span>Réduire le menu</span>
        </button>
      </li>
    </ul>
  </nav>
</header>
<section class="page-content">
  <section class="search-and-user">
Bienvenue sur l\'interface des utilisateurs de SambaÉdu 
    <div class="admin-profile">
      <span class="greeting">Bonjour ' . $user['prenom'] . '</span>
      <div class="notifications">
       <a href="?page=dx" title="Se déconnecter">
        <span class="badge"></span>
        <svg>
          <use xlink:href="#users"></use>
        </svg>
        </a>
      </div>
    </div>
  </section>
  <section class="grid">
';
    return $html;
}

function user_interface_footer()
{
    $html = '</section>
    <footer class="page-footer">
    <small> SambaÉdu</small>
    </footer>
    </section>
    <script id="rendered-js" src="user.interface.js"></script>
    </body>
    </html>
    ';
    return $html;
}

/**
 *
 * @return string
 */
function html_login_form()
{
    $html = '
        <!DOCTYPE html>
        <html>
            <head>
                <meta charset="utf-8" />
                <link rel="stylesheet" href="user.interface.login.css" />
                <title>Se connecter aux services de SambaÉdu</title>
            </head>
            <body>
            <div class="wrapper fadeInDown">
              <div id="formContent">
                <!-- Tabs Titles -->
                <h2 class="active">Retrouvez toutes vos applications en ligne !</h2>
                <!-- Icon -->
                <div class="fadeIn first">
                  <img src="/elements/images/LogoSambaEdu.png" id="icon" alt="Un service proposé par SambaÉdu" />
                </div>
                <!-- Login Form -->
                <form action="?page=login" method="post" >
                  <input type="text" id="login" class="fadeIn second" name="login" placeholder="Nom d\'utilisateur">
                  <input type="password" id="password" class="fadeIn third" name="password" placeholder="Mot de passe">
                  <input type="submit" class="fadeIn fourth" value="C\'est parti !">
                </form>
                <div id="formFooter">
                  <a class="underlineHover" href="#">Connectez vous avec vos identifiants de session habituels.</a>
                  <p>
                    En France, une attaque par déni de service (DDoS) peut avoir de graves conséquences judiciaires.
                    <a href="https://www.legifrance.gouv.fr/affichCodeArticle.do;jsessionid=2FB1E87673A7871CE407E1CB862F780D.tplgfr30s_2?idArticle=LEGIARTI000030939443&cidTexte=LEGITEXT000006070719&categorieLien=id&dateTexte=">
Le Code pénal</a> prévoit jusqu’à 5 ans de prison et 150 000 euros d’amende.

Quand elle vise un service de l’État, les sanctions passent à 7 ans de prison et 300 000 euros d’amende.

Ces sanctions n’incluent évidemment pas les dommages et intérêts que les victimes de l’attaque pourraient réclamer, au titre du préjudice, notamment matériel.
</p><p><b>
Toute tentative de DDoS sera poursuivie.
</b></p>

                  </p>
                </div>
              </div>
            </div>
        	</body>
        </html>
    ';
    return $html;
}

?>