<?php

/**
* Test si les mots de passe ont ete change
* @Version 02-2020 - keyser
* @Projet SambaEdu 
* @auteurs Equipe SambaEdu
* @Licence Distribue selon les termes de la licence GPL
* @note 
*/

/**

* @Repertoire: /
* file: infomdp.php

*/	
include "entete.inc.php";
include_once "ldap.inc.php";
include "ihm.inc.php";

require_once ("lang.inc.php");
bindtextdomain('se4-core', "/var/www/sambaedu/locale");
textdomain('se4-core');

// aide en ligne
$_SESSION["pageaide"]="Annuaire";

if (have_right($config, "annu_is_admin",$login)!="Y")
    die (gettext("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction")."</BODY></HTML>");


echo "<H1>".gettext("Test des mots de passe")."</H1>";

$classe_gr=$_POST['classe_gr'] ?? array();
$equipe_gr=$_POST['equipe_gr'] ?? array();
$matiere_gr=$_POST['matiere_gr'] ?? array();
$autres_gr=$_POST['autres_gr'] ?? array();

$validation=$_GET['validation'] ?? "";

function verify_default_password($config,$group)
{
    $list_users = search_ad($config, "*", "memberof", "$group");
    $total= count($list_users);
    $cpt=0;
    foreach ($list_users as $user) {
    $date = ($user['date']);
    $cn = ($user['cn']);
    
     system("smbclient -L 127.0.0.1 -U $cn%$date >/dev/null 2>&1 ",$return);
        if ($return) {
            true;
        } else {
            echo "<pre><class=listing>";
            echo "L'utilisateur <A HREF=\"/annu/people.php?cn=$cn\">$cn</A> a conserve sa date de naissance pour mot de passe<br>";
            echo "</pre>";
            $cpt++;
        }
     }
     echo "<p><b>$cpt</b> utilisateur(s) concernés sur <b>$total</b> membres</p>";
}

// on teste les mdp pour chaque groupe demande !!!
if (count($classe_gr) ) {
    foreach ($classe_gr as $grp){
        echo "<h4>".gettext("Liste des membres du groupe ".$grp." n'ayant jamais chang&#233; leur mot de passe&nbsp;:")."</h4>";
        
        verify_default_password($config,$grp);
        echo "";
        echo "<hr>";
    }
}

if (count($equipe_gr) ) {
    foreach ($equipe_gr as $grp){
            echo "<h4>".gettext("Liste des membres du groupe ".$grp." n'ayant jamais chang&#233; leur mot de passe&nbsp;:")."</h4>";
            echo "<PRE class=listing>";
            verify_default_password($config,$grp);
            echo "</PRE>";
            echo "<hr>";
    }
}

if (count($matiere_gr) ) {
    foreach ($matiere_gr as $grp){
            echo "<h4>".gettext("Liste des membres du groupe ".$grp." n'ayant jamais chang&#233; leur mot de passe&nbsp;:")."</h4>";
            echo "<PRE class=listing>";
            verify_default_password($config,$grp);
            echo "</PRE>";
            echo "<hr>";
    }
}

if (count($autres_gr) ) {
    foreach ($autres_gr as $grp){
            echo "<h4>".gettext("Liste des membres du groupe ".$grp." n'ayant jamais chang&#233; leur mot de passe&nbsp;:")."</h4>";
            echo "<PRE class=listing>";
            verify_default_password($config,$grp);
            echo "</PRE>";
            echo "<hr>";
    }
}

// on propose de tester d'autres groupes en bas de page
echo "<FORM ACTION=\"infomdp.php?validation=yes\" method=\"post\">\n";
echo "<h4>".gettext("Lister, parmi les groupes suivants, les utilisateurs ayant conserv&#233; leur date de naissance comme mot de passe&nbsp;:");
echo "<u onmouseover=\"this.T_SHADOWWIDTH=5;this.T_STICKY=1;return escape".gettext("('ATTENTION: cette op&#233;ration est assez longue... Ciblez votre recherche si possible.')")."\"><img name=\"action_image5\"  src=\"../elements/images/system-help.png\"></u>";
echo "</h4>\n";

// Etablissement des listes des groupes disponibles

$list_cours = filter_group($config, "(cn=Cours*)");

	// Affichage des boites de selection des groupes sur lesquels fixer les quotas + choix d'un user specifique
?>
<table align='center' border="0" cellspacing="10">
<thead>
<tr>
<td><?php echo gettext("Classes"); ?></td>
<td><?php echo gettext("Equipes"); ?></td>
<td><?php echo gettext("Mati&#232;res"); ?></td>
<td><?php echo gettext("Autres"); ?></td>
</tr>
</thead>
<tbody>
<tr>
<td valign="top">
<?php
$list_classes=filter_group_classes($config);
//var_dump($list_classes['cn']);
//exit();
echo "<select name= \"classe_gr[]\" size=\"8\" multiple=\"multiple\">\n";
for ($loop=0; $loop < count ($list_classes) ; $loop++) {
    echo "<option value=".$list_classes[$loop]["cn"].">".$list_classes[$loop]["cn"];
}
echo "</select>";
echo "</td>";

$list_equipes = filter_group_equipes($config);
echo "<td valign=\"top\">\n";
echo "<select name= \"equipe_gr[]\" size=\"8\" multiple=\"multiple\">\n";
for ($loop=0; $loop < count ($list_equipes) ; $loop++) {
    echo "<option value=".$list_equipes[$loop]['cn'].">".$list_equipes[$loop]['cn'];
}
echo "</select></td>\n";

$list_matieres = filter_group_matieres($config);
echo "<td valign=\"top\">\n";
echo "<select name= \"matiere_gr[]\"  size=\"8\" multiple=\"multiple\">\n";
for ($loop=0; $loop < count ($list_matieres) ; $loop++) {
    echo "<option value=".$list_matieres[$loop]['cn'].">".$list_matieres[$loop]['cn'];
}
echo "</select></td>\n";

$list_autres = filter_group_autres($config);
$list_autres_projets = filter_group_projets($config);
echo "<td valign=\"top\">";
echo "<select name=\"autres_gr[]\" size=\"8\" multiple=\"multiple\">";
echo "<option value=administratifs>administratifs";
echo "<option value=eleves>eleves";
echo "<option value=profs>profs";
for ($loop=0; $loop < count ($list_autres) ; $loop++) {
    echo "<option value=".$list_autres[$loop]['cn'].">".$list_autres[$loop]['cn'];
}
for ($loop=0; $loop < count ($list_autres_projets) ; $loop++) {
    echo "<option value=".$list_autres_projets[$loop]['cn'].">".$list_autres[$loop]['cn'];
}
echo "</select></td>\n";
echo "</tr></table>";

echo "<div id=\"attribution\" align='center'><input type=\"submit\" value=\"".gettext("Valider")."\">
<input type=\"reset\" value=\"".gettext("R&#233;initialiser")."\"></div>";
echo "</form>";
echo "</center>";

include ("pdp.inc.php");

?>

