<?php

/**

 * Page permettant de fixer des quotas en dur pour les utilisateurs 

 * @ Projet SambaEdu 

 * @auteurs Olivier Lacroix (Olikin), Denis Bonnenfant

 * @Licence Distribue selon les termes de la licence GPL

 */

/**
 *
 * @Repertoire: /
 * file: quota_fixer.php
 *
 */
require ("entete.inc.php");

// Verification existence utilisateur dans l'annuaire
require_once ("config.inc.php");
require_once ("ldap.inc.php");
require ("quotas.inc.php");
// permet l'authentification is_admin
require ("ihm.inc.php");
require_once ("fonc_outils.inc.php");
// Internationalisation
require_once ("lang.inc.php");
bindtextdomain('se-infos', "/var/www/sambaedu/locale");
textdomain('sambaedu-infos');

// aide
$_SESSION["pageaide"] = "Quotas#Fixer_les_quotas";

$partition = $_POST['partition'] ?? $_GET['partition'] ?? "/home";
$quota = $_POST['quota'] ?? $_GET['quota'] ?? "";
$depassement = $_POST['depassement'] ?? $_GET['depassement'] ?? "";
$browser = $_POST['browser'] ?? "";
$grace = $_POST['grace'] ?? $_GET['grace'] ?? "";
$valider_var_se = $_GET['valider_var_se'] ?? "";
$valider_home = $_GET['valider_home'] ?? "";
$classe_gr = $_POST['classe_gr'] ?? $_GET['classe_gr'] ?? array();
$equipe_gr = $_POST['equipe_gr'] ?? $_GET['equipe_gr'] ?? array();
$matiere_gr = $_POST['matiere_gr'] ?? $_GET['matiere_gr'] ?? array();
$autres_gr = $_POST['autres_gr'] ?? $_POST['autres_gr'] ?? array();
$user = $_POST['user'] ?? $_GET['user'] ?? "";
$messtxt_home = $_POST['messtxt_home'] ?? "";
$messtxt_var_se = $_POST['messtxt_var_se'] ?? "";
$nom = $_GET['nom'] ?? "";
$suppr = $_GET['suppr'] ?? "";

// AUTHENTIFICATION
if (! have_right($config, "system_is_admin"))
    die(gettext("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction") . "</BODY></HTML>");

// EVALUE SI UNE SAISIE A ETE EFFECTUEE: AUTO-APPEL DE LA PAGE APRES FORMULAIRE REMPLI
if (! empty($browser)) {
    // rajoute indirectement l'avertissement sur /home mais supprime dans la suite de la page si non choisi
    $browser = preg_replace('/\\\++/', '/', $browser); // gestion de \ qui passe mal (suppression des \\ en les rempla&#231;ant par un /)
    //exec("sudo /usr/share/sambaedu/scripts/warn_quota.sh $browser");
    set_config("quota_browser", $browser);
}

if (! empty($quota) or ! empty($suppr)) {

    $nbr_user = 0;

    if (! empty($suppr)) {
        $cns = search_user($config, $nom);
        if (count($cns) == 0) {
            $cns = search_group($config, $nom);
            $people = $cns['member'];
        } else {
            $people = $cns['memberof'];
        }
        $nbr_user = $nbr_user + count($people);
        $tabquota = array(
            'nom' => $nom,
            'quotahard' => - 1,
            'partition' => $partition
        );
        set_quota($config, $tabquota);
    }

    // EVALUE SI UN NOUVEAU QUOTA A ETE DEMANDE: AUTO-APPEL DE LA PAGE APRES FORMULAIRE REMPLI

    // si aucun quota specifie: quota par defaut de 20%
    if ($depassement == "") {
        $depassement = "20 %";
    }

    // transforme le depassement de quota en nombre
    $depassement = preg_replace('/\s%/', '', $depassement);

    // Teste si case quota non vide et si c'est un nombre et si superieur &#224; 10Mo dans le cas de la partition /home (pour eviter les problemes avec les repertories profiles, etc...
    if ($quota != "" and $quota >= 0 and $depassement >= 0 and (intval($quota) >= 10 or intval($quota) == 0 or $partition == "/var/sambaedu")) {
        // PB CI DESSUS AVEC LE TEST POUR SAVOIR SI LA CHAINE EST UN ENTIER VALIDE
        // and is_int($quota) => a modifier

        if ($depassement == "") {
            $depassement = "0";
        }

        // Si le quota est valide et les choix valides, fixe les quotas
        if (count($classe_gr)) {
            foreach ($classe_gr as $grp) {
                $cns = search_group($config, $grp);
                $people = $cns['member'];
                $nbr_user = $nbr_user + count($people);

                $hard_quota = (int) ($quota * ($depassement + 100) / 100);
                $tabquota = array(
                    'nom' => $grp,
                    'quotasoft' => $quota,
                    'quotahard' => $hard_quota,
                    'partition' => $partition
                );
                set_quota($config, $tabquota);
            }
        }

        if (count($equipe_gr)) {
            foreach ($equipe_gr as $grp) {
                $cns = search_group($config, $grp);
                $people = $cns['member'];
                $nbr_user = $nbr_user + count($people);

                $hard_quota = (int) ($quota * ($depassement + 100) / 100);
                $tabquota = array(
                    'nom' => $grp,
                    'quotasoft' => $quota,
                    'quotahard' => $hard_quota,
                    'partition' => $partition
                );
                set_quota($config, $tabquota);
            }
        }

        if (count($matiere_gr)) {
            foreach ($matiere_gr as $grp) {
                $cns = search_group($config, $grp);
                $people = $cns['member'];
                $nbr_user = $nbr_user + count($people);

                $hard_quota = (int) ($quota * ($depassement + 100) / 100);
                $tabquota = array(
                    'nom' => $grp,
                    'quotasoft' => $quota,
                    'quotahard' => $hard_quota,
                    'partition' => $partition
                );
                set_quota($config, $tabquota);
            }
        }

        if (count($autres_gr)) {
            foreach ($autres_gr as $grp) {
                $cns = search_group($config, $grp);
                $people = $cns['member'];
                $nbr_user = $nbr_user + count($people);

                $hard_quota = (int) ($quota * ($depassement + 100) / 100);
                $tabquota = array(
                    'nom' => $grp,
                    'quotasoft' => $quota,
                    'quotahard' => $hard_quota,
                    'partition' => $partition
                );
                set_quota($config, $tabquota);
            }
        }

        // teste si utilisateur saisi pour recherche dans ldap
        if (! empty($user)) {
            // recherche dans ldap si $user est valide
            $tabresult = search_user($config, $user);
            if (count($tabresult) > 0) {
                if ($user != "root" and $user != "www-admin") {
                    // comme $user existe et non admin et non root => fixe le quota!
                    $nbr_user ++;

                    $hard_quota = (int) ($quota * ($depassement + 100) / 100);
                    $tabquota = array(
                        'nom' => $user,
                        'quotasoft' => $quota,
                        'quotahard' => $hard_quota,
                        'partition' => $partition
                    );
                    set_quota($config, $tabquota);
                }
            }
        }
    }
    // fin du if($quota valide)

    // la page est affichee apres avoir clique sur valider: ce n'est pas juste une selection de partition
    if ($valider_home == "yes") {
        if ($messtxt_home == "on" and $partition == "/home") {
            set_config('quota_warn_home', 1);
        } else {
            set_config('quota_warn_home', 0);
        }
        // effet immediat
        // exec("sudo /usr/share/sambaedu/scripts/warn_quota.sh");
    } // fin du $valider_home=yes

    if ($valider_var_se == "yes") {
        if ($messtxt_var_se == "on" and $partition == "/var/sambaedu") {
            set_config('quota_warn_var_se', 1);
        } else {
            set_config('quota_warn_var_se', 0);
            ;
        }
        // effet immediat
        // exec("sudo /usr/share/sambaedu/scripts/warn_quota.sh");
    } // fin du $valider_var_se=yes
}
// fin du cas if (isset($quota) or isset($suppr))

if (isset($grace)) {
    if ($grace > 0) {
        $tabquota = array(
            'grace' => $grace,
            'partition' => $partition
        );
        set_quota_disk($config, $tabquota);
    }
}

// DEBUT DES AFFICHAGES HTML
echo "<h1>" . gettext("Quotas fix&#233;s sur /home et /var/sambaedu") . "</h1>\n\n";

// Affichage du contenu de la table en HTML
$arr = array(
    "/home",
    "/var/sambaedu"
);

echo "<center>\n";
foreach ($arr as $partit) {
    $quotas = list_quotas($config, $partit);

    echo "<FORM ACTION=\"quota_fixer.php\" method=\"post\">\n";
    echo "<table border=1 width=\"80%\">\n";
    echo "<TR><TD class=\"menuheader\" height=\"30\" align=center colspan=\"5\">";
    echo gettext("Quotas actuels sur") . " $partit</TD></TR>\n";

    $i = 0;
    foreach ($quotas as $quota) {
        if ($i == 0) {
            // ligne d'entetes
            echo "<tr><td align=center width=\"40%\">" . gettext("Nom (utilisateur ou groupe)") . "</td><td align=center  width=\"30%\">" . gettext("Quota") . "</td><td align=center width=\"30%\">" . gettext("D&#233;passement temporaire autoris&#233;") . "</td>\n";
        }
        echo "\t<tr>\n";
        for ($j = 0; $j < 3; $j ++) {
            if ($j == 0) {
                $nom = $quota['nom'] ?? "";
                if (count(search_user($config, $nom)) > 0) {
                    // rajouter le ? pour expliquer que l'user est preponderant sur tout groupe
                    $col_value = "$nom &nbsp;&nbsp; <u onmouseover=\"this.T_SHADOWWIDTH=5;this.T_STICKY=1;return escape" . gettext("('Les quotas fix&#233;s sur un utilisateur sont pr&#233;pond&#233;rants quelques soient les groupes d\'appartenance.')") . "\"><img name=\"action_image6\"  src=\"../elements/images/system-help.png\"></u>\n";
                } else {
                    $col_value = $nom;
                }
            } elseif ($j == 1) {
                $soft = $quota['quotasoft'];
                if ($soft == 0) {
                    $col_value = "Illimité;";
                } else {
                    $col_value = "$soft Mo";
                }
            } elseif ($j == 2) {
                if ($quota['quotahard'] == $soft) {
                    if ($soft == 0) {
                        $col_value = "-";
                    } else {
                        $col_value = "Non";
                    }
                } else {
                    $col_value = round(($quota['quotahard'] - $soft) * 100 / $soft) . "%";
                }
            }

            echo "\t\t<td align=center> $col_value </td>\n";
        }

        echo " <td align=center><a href=\"quota_fixer.php?suppr=suppr";
        echo "&amp;partition=$partit";
        echo "&amp;nom=$nom";
        echo "\"><img src=\"/elements/images/edittrash.png\" alt=\"" . gettext("Supprimer") . "\" title=\"" . gettext("Supprimer") . "\" width=\"16\" height=\"16\" border=\"0\" /></a></td>";
        echo "\t</tr>\n";
        $i ++;
    }

    // si aucun quota sur la partition, l'afficher
    // echo "valeur $i";
    if ($i == 0) {
        echo "<tr><td align=center>" . gettext("Aucun quota fixé sur cette partition") . "</td></tr>";
    }
    echo "</table>\n";
    echo "</FORM>\n";

    // CI DESSUS AFFICHER LA PERIODE DE GRACE ACTUELLE
    echo "<H3> Période de grâce sur $partit : ";
    $info = info_quota($partit);
    echo $info['grace'] . " jours";
    if ((("$partit" == "/home") && ($config['quota_warn_home'] ?? 0 == 1)) || (("$partit" == "/var/sambaedu") && ($config['quota_warn_var_se'] ?? 0 == 1))) {
        echo gettext(" avec message d'avertissement.<br>");
        $warn = true;
    } else {
        $warn = false;
        echo " <font color=\"#FF0000\">sans  message d'avertissement.</font>\n";
        echo "<u onmouseover=\"this.T_SHADOWWIDTH=5;this.T_STICKY=1;return escape" . gettext("('PARAMETRAGE FORTEMENT DECONSEILLE: en cas de d&#233;passement autoris&#233, l\'utilisateur ne sera pas pr&#233;venu qu\'il se situe au del&#224; de son quota. Il se trouvera bloqu&#233;, sans pr&#233;avis, &#224; la fin de la p&#233;riode de gr&#226;ce... Ce r&#233;glage revient plus ou moins &#224; ne pas autoriser de d&#233;passement temporaire de quota puisque l\'utilisateur n\'est pas averti...')") . "\"><img name=\"action_image3\"  src=\"../elements/images/system-help.png\"></u>\n";
    }

    // Insert ou update pour avertissement IE
    /*
     * if ($warn) {
     * if (isset($browser)) {
     * $browser = preg_replace('/\\\++/', '/', $browser); // gestion de \ qui passe mal (suppression des \\ en les rempla&#231;ant par un /)
     * } else
     * $browser = "$quota_browser";
     * //
     * $result = mysql_query("SELECT CleID FROM corresp WHERE Intitule='warnquotas'");
     * if (mysql_num_rows($result) == 0) {
     * $query = "INSERT INTO corresp VALUES('','warnquotas','$browser $urlse','','REG_SZ','systeme','','2000,XP,Vista,Seven','HKEY_CURRENT_USER\\\Software\\\Microsoft\\\Windows\\\CurrentVersion\\\Run\\\WarnQuota','Avertissement quota','config')";
     * mysql_query($query);
     * $result = mysql_query("SELECT CleID FROM corresp WHERE Intitule='warnquotas'");
     * }
     * //
     * $row = mysql_fetch_row($result);
     * $result = mysql_query("SELECT CleID FROM restrictions WHERE CleID='$row[0]'");
     * // echo $row[0];
     * if (mysql_num_rows($result) == 0) {
     * $query = "INSERT INTO restrictions VALUES('','$row[0]','overfill','$browser $urlse','')";
     * } else {
     * $query = "UPDATE restrictions SET valeur='$browser $urlse' where CleID='$row[0]'";
     * }
     * $result = mysql_query($query);
     * // echo $result;
     * } else {
     * }
     */
    echo "</h3>\n";
} // fin du for partition

echo "<h1>" . gettext(" Attribution (Modification) de quotas") . "</h1>\n";
echo "<FORM METHOD=\"post\" action=\"quota_fixer.php#attribution\">";

// si 1er affichage, afficher /home
if (! isset($partition)) {
    $partition = "/home";
}
$help = $objet = $parametre = array();

// preparation du tableau de parametres
$parametre[1] = gettext("Modifier la partition :");
$objet_var = "<select name=\"partition\" onchange=submit()>\n";
// creation du tableau des partitions
$arr_parts = array(
    "/home",
    "/var/sambaedu"
);
foreach ($arr_parts as $part) {
    $objet_var .= " <option value =\"" . $part . "\"";
    if ($part == $partition) {
        $objet_var .= " selected";
    }
    $objet_var .= "> " . $part . " </option>\n";
}
$objet_var .= " </select>\n";
$objet[1] = "$objet_var";
if ($partition == "/var/sambaedu") {
    $help[1] = gettext("Rappel: fixer un quota sur /var/sambaedu limite &#224 la fois l\'espace disponible dans les lecteurs r&#233;seaux Classes et Docs qui constituent une seule et unique partition.");
} else {
    $help[1] = gettext("Il est interdit de fixer un quota inf&#233;rieur &#224; 10 Mo sur la partition /home. En effet, cela pourrait cr&#233;er des dysfonctionnements: les quotas sont fix&#233;s pour tous les utilisateurs des groupes choisis sur la partition enti&#232;re: cela inclut notamment les r&#233;pertoires profile, etc...");
}

$parametre[2] = gettext("Indiquer l'espace maximum tol&#233;r&#233; en Mo (0 pour illimit&#233;) :");
$objet[2] = "<INPUT TYPE=\"TEXT\" NAME=\"quota\" size=4>\n";
if ($partition == "/var/sambaedu") {
    $help_var = gettext("Saisir un entier strictement positif.");
} else {
    $help_var = gettext("Il est interdit de fixer un quota inf&#233;rieur &#224; 10Mo sur la partition /home. En effet, cela pourrait cr&#233;er des dysfonctionnements: les quotas sont fix&#233;s pour tous les utilisateurs des groupes choisis sur la partition enti&#232;re: cela inclut notamment les r&#233;pertoires profile, etc...");
}
$help[2] = "$help_var";

$parametre[3] = gettext("D&#233;passement temporaire autoris&#233; :");
$arr_pourc = array(
    "0 %",
    "10 %",
    "20 %",
    "30 %",
    "40 %",
    "50 %",
    "60 %",
    "70 %",
    "80 %",
    "90 %",
    "100 %"
);
$objet_var = "<select name=\"depassement\" >\n";
foreach ($arr_pourc as $pourc) {
    $objet_var .= " <option value=\"" . $pourc . "\"";
    if ($pourc == "20 %") {
        $objet_var .= " selected";
    }
    $objet_var .= "> $pourc </option>\n";
}
$objet_var .= " </select>\n";
$objet[3] = "$objet_var";
$help[3] = gettext("Si le d&#233;passement est fix&#233; &#224; 0 %, l\'utilisateur sera bloqu&#233; au quota fix&#233; sans aucun pr&#233;avis et sans moyen d\'enregistrer son travail. A &#233;viter!");

$parametre[4] = gettext("P&#233;riode de gr&#226;ce en jour(s) :");
$help[4] = gettext("VALABLE POUR TOUTE LA PARTITION.");

$parametre[5] = gettext("Avertir les utilisateurs en cas de d&#233;passement :");

$objet_var = "<input type=\"checkbox\" checked>";

/*
 * // $test_exist=exec("cat /etc/cron.d/sambaedu | grep \"$(echo \"warn_quota.sh $partition\")\"");
 * // PERMET L'AFFICHAGE DE CE QU'IL Y A DEJA DE REGLE DANS MYSQL POUR LA PARTITION CONSIDEREE
 * if ("$partition" == "/home") {
 * $resultat = mysql_query("select value from params where name='quota_warn_home'");
 * } else {
 * $resultat = mysql_query("select value from params where name='quota_warn_varse'");
 * }
 *
 * $line = mysql_fetch_assoc($resultat);
 * // foreach ($line as $col_value) {
 * // if ( "$col_value" == "1" ) {$objet_var="$objet_var checked ";}
 * // }
 *
 * // if ( $test_exist != "" ) {$objet_var="$objet_var checked ";}
 *
 * $objet_var = "$objet_var name=\"";
 * if ($partition == "/home") {
 * $objet_var = "$objet_var messtxt_home\">";
 * } else {
 * $objet_var = "$objet_var messtxt_var_se\">";
 * }
 */
$objet[5] = "$objet_var";

$help[5] = gettext("VALABLE POUR TOUTE LA PARTITION: Cr&#233;ation d\'un message d\'avertissement &#224; chaque ouverture de session pour tout utilisateur en d&#233;passement de quota.");

$parametre[6] = gettext("Chemin du navigateur affichant les messages d'avertissement en cas de d&#233;passement :");
$objet[6] = "<INPUT TYPE=\"TEXT\" NAME=\"browser\" value=\"$browser\" size=20>\n";
$help[6] = gettext("Par d&#233;faut: la chaine de caractere \'iexplore\' fonctionne si internet explorer n\'est pas bloqu&#233; par une clef de registre. Sinon, le navigateur lynx convient en indiquant un chemin correct (par exemple, L:...lynx.exe). ATTENTION: firefox ne fonctionne pas si le quota est d&#233;pass&#233; sur /home car son profil y est stock&#233;. Utiliser firefoxportable sur L: par exemple.");

// creation du tableau proprement dite
$i = 1;
echo "<TABLE border=1 width=\"80%\">\n";

foreach ($parametre as $param) {
    echo "<TR><td>$param</td><TD align=center>\n";
    if ($i == 4) {
        echo "<INPUT TYPE=\"TEXT\" NAME=\"grace\" size=4 value=";
        echo info_quota($partition)['grace'];
        echo " >";
    } else {
        echo "$objet[$i]";
    }

    echo "</TD><TD align=center><u onmouseover=\"this.T_SHADOWWIDTH=5;this.T_STICKY=1;return escape('$help[$i]')\"><img name=\"action_image4\"  src=\"../elements/images/system-help.png\"></u></TD></TR>\n";
    /*
     * if ($i == 1) {
     * echo "</form>\n\n";
     * echo "<FORM ACTION=\"quota_fixer.php?partition=$partition&valider\" method=\"POST\">\n";
     * }
     */
    $i ++;
}

echo "</TABLE>\n\n";
// echo "</center>\n";

echo "<div align=center>";
echo "<h4>" . gettext("Fixer ce quota pour tous les membres des groupes suivants&nbsp;:");
echo "<u onmouseover=\"this.T_SHADOWWIDTH=5;this.T_STICKY=1;return escape" . gettext("('Le quota fix&#233; d&#233;pendra des groupes d\'appartenance des utilisateurs: le quota effectif sera le plus grand des quotas applicables aux divers groupes. Par contre, si un quota est appliqu&#233; &#224; un utilisateur sp&#233;cifique, celui-ci est pr&#233;pond&#233;rant quelques soient ses groupes d\'appartenance.')") . "\"><img name=\"action_image5\"  src=\"../elements/images/system-help.png\"></u>";
echo "</h4></div>\n";
// Etablissement des listes des groupes disponibles
affiche_all_groups($config, "center", "user");

echo "<div id=\"attribution\" align='center'><input type=\"submit\" value=\"" . gettext("Valider") . "\">
<input type=\"reset\" value=\"" . gettext("R&#233;initialiser") . "\"></div>";
echo "</form>";
echo "</center>";
// fin is_admin($login)

include ("pdp.inc.php");

?>
