<?php

/**

 * Page permettant de visualiser des quotas en dur pour les utilisateurs

 * @ Projet SambaEdu

 * @auteurs Olivier Lacroix (Olikin), Denis Bonnenfant

 * @Licence Distribue selon les termes de la licence GPL

 */

/**
 *
 * @Repertoire: infos
 * file: quota_visu.php
 *
 */
require ("entete.inc.php");

// Verification existence utilisateur dans l'annuaire
require_once ("config.inc.php");
require_once ("ldap.inc.php");
require ("quotas.inc.php");
// permet l'authentification is_admin
require ("ihm.inc.php");
require_once ("fonc_outils.inc.php");
// Internationalisation
require_once ("lang.inc.php");
bindtextdomain('se-infos', "/var/www/sambaedu/locale");
textdomain('sambaedu-infos');


// aide
$_SESSION["pageaide"] = "Quotas#Gestion_des_quotas";

// AUTHENTIFICATION
if (! have_right($config, "system_is_admin"))
    die(gettext("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction") . "</BODY></HTML>");

$partition = $_POST['partition'] ??  $_GET['partition'] ?? "";
$classe_gr = $_POST['classe_gr'] ?? $_GET['classe_gr'] ?? array();
$equipe_gr = $_POST['equipe_gr'] ?? $_GET['equipe_gr'] ?? array();
$matiere_gr = $_POST['matiere_gr'] ?? $_GET['matiere_gr'] ?? array();
$autres_gr = $_POST['autres_gr'] ?? $_GET['autre_gr'] ?? array();
$user = $_POST['user'] ?? $_GET['user'] ?? "";

$overfill = repquota();
if (count($overfill) > 0) {
 
    echo "<h1>" . gettext("Attention!") . "</h1>";
    affiche_quotas($overfill, "/home");
    affiche_quotas($overfill, "/var/sambaedu");
}
echo "<h1>" . gettext("Visualisation des quotas effectivement attribu&#233;s") . "</h1>";

// FILTRAGE
echo "<FORM ACTION=\"quota_visu.php\" METHOD=\"post\">
 <h2>" . gettext("Quotas sur") . " &nbsp;
	<select name=\"partition\">
	 <option>/home</option>
	 <option>/var/sambaedu</option>
	</select>
 </h2> ";

echo "<h2>" . gettext("Filtrer les membres des groupes suivants :") . " <u onmouseover=\"this.T_SHADOWWIDTH=5;this.T_STICKY=1;return escape" . gettext("('Pour afficher tous les quotas, valider directement.')") . "\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\"></u></h2>";

// Etablissement des listes des groupes disponibles
affiche_all_groups($config, "center", "user");
echo "<div align='center'><input type=\"submit\" value=\"" . gettext("Valider") . "\">
<input type=\"reset\" value=\"" . gettext("R&#233;initialiser") . "\"></div>";
echo "</form>";

if ($partition != "") {
    // AFFICHAGE DES RESULTATS
    echo "<hr>";

    // tableau des quotas: un tableau par groupe selection

    if ($classe_gr == "" and $equipe_gr == "" and $matiere_gr == "" and $autres_gr == "" and $user == "") {
        // si aucun filtre
        echo "<h3>" . gettext("Le traitement des quotas pour la totalit&#233; de l'annuaire est en cours: veuillez patienter...") . "</h3>";
        echo "<h3>P&#233;riode de gr&#226;ce actuelle sur $partition : ";
        $quotas = group_quota($config, "eleves", $partition);
        echo "</h3>";
        affiche_quotas($quotas);
    } else { // si il y a eu une demande de filtrage

        // concatne tous les groupes cherchs dans le tableau liste_sel
        $i = 0;
        $liste_sel = array();
        for ($loop = 0; $loop < count($classe_gr); $loop ++) {
            $liste_sel[$i] = $classe_gr[$loop];
            $i ++;
        }
        for ($loop = 0; $loop < count($equipe_gr); $loop ++) {
            $liste_sel[$i] = $equipe_gr[$loop];
            $i ++;
        }
        for ($loop = 0; $loop < count($matiere_gr); $loop ++) {
            $liste_sel[$i] = $matiere_gr[$loop];
            $i ++;
        }
        for ($loop = 0; $loop < count($autres_gr); $loop ++) {
            $liste_sel[$i] = $autres_gr[$loop];
            $i ++;
        }

        $liste_sel[$i] = $user;

        // cherche user pour savoir s'il existe ensuite
        $tabresult = search_user($config, $user);

        echo "<h3>P&#233;riode de gr&#226;ce actuelle sur $partition : ";
        system("sudo repquota $partition|grep \"Block grace time\"|cut -b19-25|sed -e \"s/ //g\"|sed -e \"s/days/ jours/g\"|sed -e \"s/;//g\"");
        echo "</h3>";

        // affiche tous les tableaux demands
        foreach ($liste_sel as $grp) {

            // TESTE si $user EXISTE OU si $grp est un utilisateur d'un groupe (et non $user) => il faut afficher le tableau!
            if (count($tabresult) != 0 or $grp != $user) {
                if ($grp != $user) {
                    echo "<h2>Liste des quotas actuels sur $partition pour $grp :</h2>";
                    $quotas = group_quota($config, $grp, $partition);
                    
                } else {
                    echo "<h2>Quota actuel sur $partition pour l'utilisateur $grp :</h2>";
                    $quotas = disk_quota($grp);
                }
                affiche_quotas($quotas, $partition);
            } else { // si utilisateur non valide
                if ($user != "")
                    echo "<h2>" . gettext("L'utilisateur sp&#233;cifi&#233;") . " \"$user\" " . gettext("n'est pas valide!") . "</h2>";
            }
        } // fin du foreach ($liste_sel...
    } // fin du else du if ($classe_gr=="" and $equipe_gr=="" and $autres_gr=="" and $user=="")
} // fin du if($partition <> "") et donc de l'affichage des tableaux

include ("pdp.inc.php");
?>

