<?php

/**

* @Projet SambaEdu

* @Auteurs Equipe Sambaedu

* @Note: 

* @Licence Distribue sous la licence GPL

*/

/**
 *
 * @Repertoire: parcs/
 * file: action_machine.php
 *
 */
include "entete.inc.php";
require_once "ldap.inc.php";
require_once "ihm.inc.php";
require_once "fonc_outils.inc.php";
require_once ('dhcpd.inc.php');
require_once ('fonc_parc.inc.php');

// Internationnalisation
require_once ("lang.inc.php");
bindtextdomain('sambaedu-parcs', "/var/www/sambaedu/locale");
textdomain('sambaedu-parcs');

// ***************Definition des droits de lecture et aide en ligne

// Verifie les droits
if ((have_right($config, "computers_is_admin")) or (have_right($config, "parc_can_view")) or (have_right($config, "parc_can_manage")) or (have_right($config, "inventaire_can_read"))) {

    // aide
    $_SESSION["pageaide"] = "Gestion_des_parcs#Action_sur_parcs";
} else {
    exit();
}
$acces_restreint = false;
// *****************cas des parcs delegues***********************************
if ((! have_right($config, "computers_is_admin", $login)) and ((have_right($config, "parc_can_view")) or (have_right($config, "parc_can_manage")))) {
    echo "<h3>" . gettext("Votre d&#233l&#233gation a &#233t&#233 prise en compte pour l'affichage de cette page.") . "</h3>";
    $acces_restreint = true;

    $list_delegate = list_delegations($config);
    echo "<ul>";
    foreach ($list_delegate as $info_parc_delegate) {
        echo "<li>$info_parc_delegate</li>";
    }
    echo "</ul>";
}

/**
 * *********************** Declaration des variables ***********************************
 */
// action peut etre shutdown ou wol
$action = $_POST['action'] ?? $_GET['action'] ?? "";
$ip = $_POST['ip'] ?? $_GET['ip'] ?? "";
$machine = $_POST['machine'] ?? $_GET['machine'] ?? "";
$retour = $_POST['retour'] ?? $_GET['retour'] ?? "show_parc";
$parc = $_GET['parc'] ?? "";
$content = "";

if ($acces_restreint) {
    if ((! have_delegation($config, $parc, "manage")) and (! have_delegation($config, $parc, "view"))) {
        exit();
    }
}

switch ($action) {
    case "shutdown":
        if (! empty($machine)) {
            echo "<HEAD>";
            echo "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            echo "</HEAD>";

            echo "<h1>Arr&#234;t de(s) machine(s)</h1>";
            echo gettext("Commandes prises en compte !") . "<br>";
            $content .= start_poste($config, "shutdown", $machine);
            echo "<h3>" . gettext("Arret lanc&#233 pour le poste") . " $machine. " . gettext("(Ne concerne que les machines XP/2000)") . "</h3>";
            echo "<font color=#FF0000>" . gettext("Un temps d'attente de plus une minute est n&#233c&#233ssaire pour voir le r&#233sultat dans l'interface") . "</font><br>";
        } else {
            echo gettext("Vous devez choisir un parc");
        }

        break;

    case "wol":
        if (! empty($machine)) {
            echo "<HEAD>";
            echo "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            echo "</HEAD>";

            echo "<h1>D&#233;marrage de(s) machine(s)</h1>";

            echo gettext("Commandes prises en compte !") . "<br>";

            echo "<h3>" . gettext("D&#233;marrage effectu&#233 pour le poste") . " $machine. " . gettext("(Ne concerne que les machines equip&#233es du syst&#232me 'wake on lan')") . "</h3>";
            $content .= start_poste($config, "wol", $machine);
            echo "<font color=#FF0000>" . gettext("Un temps d'attente de plus une minute est n&#233c&#233ssaire pour voir le r&#233sultat dans l'interface") . "</font><br>";
        } else {
            echo gettext("Vous devez choisir une machine");
        }

        break;

    case "reboot":
        if (! empty($machine)) {
            echo "<HEAD>";
            echo "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            echo "</HEAD>";
            
            echo "<h1>Redémarrage de(s) machine(s)</h1>";
            
            echo gettext("Commandes prises en compte !") . "<br>";
            
            echo "<h3>" . gettext("Redémarrage effectué pour le poste") . " $machine. " . gettext("(Ne concerne que les machines equip&#233es du syst&#232me 'wake on lan')") . "</h3>";
            $content .= start_poste($config, "reboot", $machine);
            echo "<font color=#FF0000>" . gettext("Un temps d'attente de plus une minute est n&#233c&#233ssaire pour voir le r&#233sultat dans l'interface") . "</font><br>";
        } else {
            echo gettext("Vous devez choisir une machine");
        }
        
        break;
        
        
    case "reservation":
        if (! empty($machine)) {
            echo "<HEAD>";
            echo "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            echo "</HEAD>";

            $content .= "<HEAD>";
            $content .= "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            $content .= "</HEAD>";
            $content .= start_poste($config, "wol", $machine);
            if (set_dhcp_reservation($config, $machine, $ip)) {
                $content .= "reservation pour " . $machine . "OK<br>\n";
                $content .= start_poste($config, "reboot", $machine);
            } else {
                $content .= "reservation pour" . $machine . "impossible<br>\n";
            }
        }
        break;
    case "dynamique":
        if (! empty($machine)) {
            echo "<HEAD>";
            echo "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            echo "</HEAD>";
            
            $content .= "<HEAD>";
            $content .= "<META HTTP-EQUIV=\"refresh\" CONTENT=\"5; URL=$retour.php?parc=$parc&action_poste=check&action=choix_time \">";
            $content .= "</HEAD>";
            $content .= start_poste($config, "wol", $machine);
            if (delete_dhcp_reservation($config, $machine)) {
                $content .= "suppression de la reservation pour " . $machine . "OK<br>\n";
                $content .= start_poste($config, "reboot", $machine);
            } else {
                $content .= "suppression de la reservation pour" . $machine . "impossible<br>\n";
            }
        }
        break;
        
}
echo $content . "<br>\n";
echo "<br><center>";
echo "<a href=\"$retour.php?parc=$parc&action_poste=check\">" . gettext("Retour") . "</a>";
echo "</center>";

include ("pdp.inc.php");
?>

