<?php

/**

 * Cree un nouveau parc
 * @Version $Id$

 * @Projet LCS / SambaEdu

 * @auteurs Equipe Tice acad&#233;mie de Caen

 * @Licence Distribue selon les termes de la licence GPL

 * @note

 */

/**
 *
 * @Repertoire: parcs/
 * file: create_parc.php
 *
 */
include "entete.inc.php";
include_once "ldap.inc.php";
include "ihm.inc.php";

// Traduction
require_once ("lang.inc.php");
bindtextdomain('se3-parcs', "/var/www/se3/locale");
textdomain('se3-parcs');

$parc = $_POST['parc'] ?? $_GET['parc'] ?? "";
$newparc = $_POST['newparc'] ?? "";
$description = $_POST['newparc'] ?? "";
$create_parc = $_POST['create_parc'] ?? "";
$parent = $_POST['parent'] ?? "";
$new_computers = $_POST['new_computers'] ?? $_GET['new_computers'] ?? array();
$type = $_POST['type'] ?? $_GET['type'] ?? "salle";
$move = $_POST['move'] ?? $_GET['move'] ?? "true";
if (have_right($config, "computers_is_admin")) {

    // aide
    $_SESSION["pageaide"] = "Gestion_des_parcs#Ajout_de_machines";

    // Titre
    echo "<h1>" . gettext("Ajout - Cr&#233;ation ") . "</h1>";

    if ((count($new_computers) == 0) && ($parc == "")) {
        echo "<H3>" . gettext("Cr&#233;ation d'un nouveau parc") . "</H3>";
        echo "<FORM method=\"post\" action=\"create_parc.php\">\n";
        echo "Nom : <INPUT TYPE=\"text\" SIZE=\"10\" value=\"$newparc\" name=\"newparc\"><br>\n";
        echo "Description : <INPUT TYPE=\"text\" SIZE=\"30\" value=\"$description\" name=\"description\">\n";

        echo "<u onmouseover=\"return escape" . gettext("('Indiquer le nom du nouveau parc que vous souhaitez cr&#233;er. Ne pas utiliser de caract&#232;res &#233;tranges.')") . "\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"help\"></u> ";

        // =============================================================
        // AJOUT
        echo gettext("Créer un parc de type Salle ?");
        echo "<u onmouseover=\"return escape" . gettext("('un parc de type salle permet, en plus des logiciels installés par wpkg, d\'associer des GPO et des imprimantes. Une machine ne peut appartenir qu\'à une seule salle, mais en revanche les salles peuvent avoir une autre salle pour parent. Dans ce cas les machines héritent des GPO et des applications.')") . "\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"help\"></u> ";
        echo gettext("salle:") . "<INPUT TYPE=\"radio\" VALUE=\"salle\" name=\"type\" CHECKED> Oui \n";
        echo "<INPUT TYPE=\"radio\" VALUE=\"parc\" name=\"type\"> Non \n";
        echo "<br>\n";
        // =============================================================

        if ($type == "salle") {
            // Choix du parent
            echo "<br>";
            echo "<H3>" . gettext("Créer des parcs de type salle pour pouvoir appliquer de GPO") . "</H3>";
            $list_parcs = search_parcs($config, "*", "salle");
            sort($list_parcs);
            if (count($list_parcs) > 0) {
                // echo "<FORM method=\"post\" action=\"create_parc.php\">\n";
                echo "<table>\n";
                echo "<tr><td valign=\"top\">" . gettext("Choisir un parc parent:") . " </td>\n";
                if (count($list_parcs) > 10)
                    $size = 10;
                else
                    $size = count($list_parcs);
                echo "<td><SELECT NAME=\"parent\" SIZE=\"$size\" >";
                for ($loop = 0; $loop < count($list_parcs); $loop ++) {
                    if ($list_parcs[$loop]["name"] != $parc)
                        echo "<option value=\"" . $list_parcs[$loop]["name"] . "\">" . $list_parcs[$loop]["name"] . "</option>\n";
                }

                echo "</SELECT></td></tr>\n";
                echo "</table>\n";
            }
        }
        echo "<input type=\"submit\" value=\"" . gettext("Valider") . "\">\n";
        echo "</FORM>\n";
    }
    if (($newparc == "") && ($parc == "")) {
        // Ajout de nouvelles machines dans les parcs
        echo "<H1>" . gettext("Alimentation du parc") . " <U>$parc</U></H1>";

        echo "<H3>" . gettext("S&#233;lection du parc &#224; alimenter") . "</H3>";
        $list_parcs = search_parcs($config, "*");
        if (count($list_parcs) > 0) {
            sort($list_parcs);
            echo "<FORM method=\"post\" action=\"create_parc.php\">\n";
            echo "<SELECT NAME=\"parc\" SIZE=\"1\">";
            for ($loop = 0; $loop < count($list_parcs); $loop ++) {
                echo "<option value=\"" . $list_parcs[$loop]["name"] . "\">" . $list_parcs[$loop]["name"] . "\n";
            }
            echo "</SELECT>&nbsp;&nbsp;\n";

            echo "<input type=\"hidden\" name=\"create_parc\" value=\"$create_parc\">\n";
            for ($loop = 0; $loop < count($new_computers); $loop ++) {
                echo "<input type=\"hidden\" name=\"new_computers[]\" value=\"" . $new_computers[$loop] . "\">\n";
            }

            echo "<input type=\"submit\" value=\"" . gettext("Valider") . "\">\n";
            echo "<u onmouseover=\"return escape" . gettext("('S&#233;lectionner un parc dans lequel vous souhaitez ajouter des machines.')") . "\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"help\"></u> ";
            echo "</FORM>\n";
        }
        echo "<BR>";

        // Cr&#233;ation de nouveau parc

        // on ne propose pas de creer un nouveau parc si la page d'origine est recherche
    /**
     * *******************************************************************************
     */
    }

    // Debut du traitement

    // Affichage du formulaire de remplissage du parc
    if ((($type == "salle") && ($parent != "")) || ($type == "parc")) {
        if ($newparc == "") {
            echo "<p>" . gettext("Le nom du parc ne doit pas &#234;tre vide.") . "</p>\n";
            include ("pdp.inc.php");
            exit();
        }

        // On pourrait meme ajouter un test ereg plus haut pour exclure les caracteres speciaux
        if (strlen(preg_replace("/[0-9a-z_]/", "", $newparc)) != 0) {
            echo "<p>" . gettext("Le nom du parc propos&#233; comporte des caract&#232;res non valides.") . "<br>\n";
            echo gettext("Veuillez n'utiliser que des caract&#232;res alphanum&#233;riques en minuscules (<i>surtout les chiffres;o</i>) et &#233;ventuellement le caract&#232;re '_'.") . "</p>\n";
            echo "<br><center>";
            echo "<a href=create_parc.php>Retour</a>";
            echo "</center>";
            include ("pdp.inc.php");
            exit();
        } else {
            // =============================================================
            // Cr&#233;ation d'un nouveau parc
            echo gettext("Cr&#233;ation du parc ") . $newparc;
            echo "<BR>\n";
            $newparc = strtolower($newparc);
            if (create_parc($config, $newparc, $description, $type, $parent))
                echo "parc $newparc créé<br>\n";
            else
                echo "ERREUR à la création de $newparc<br>\n";

            // =============================================================
        }
    } elseif ($parc != "") {
        echo "<H3>" . gettext("Alimentation du parc") . " <U>$parc</U></H3>";
        echo "<P>" . gettext("Vous avez s&#233;lectionn&#233; ") . count($new_computers) . gettext(" machine(s)") . "<BR>\n";
        for ($loop = 0; $loop < count($new_computers); $loop ++) {
            $computer = $new_computers[$loop];
            if ($move == "true") {
                echo gettext("Déplacement de l'ordinateur") . "<a href='show_histo.php?selectionne=2&mpenc=$computer' title='Voir les connexions'> $computer </a>" . gettext("au parc") . " <U><a href='show_parc.php?parc=$parc' title='Voir les machines du parc.'>$parc</a></U> <a href='action_parc.php?parc=$parc' title='Action sur les stations du parc'><img src='../elements/images/magic.png' width='22' height='24' /></a><br />";
                if (move_member_parc($config, $parc, $computer))
                    echo "OK<BR>";
            } else {
                echo gettext("Ajout de l'ordinateur") . "<a href='show_histo.php?selectionne=2&mpenc=$computer' title='Voir les connexions'> $computer </a>" . gettext("au parc") . " <U><a href='show_parc.php?parc=$parc' title='Voir les machines du parc.'>$parc</a></U> <a href='action_parc.php?parc=$parc' title='Action sur les stations du parc'><img src='../elements/images/magic.png' width='22' height='24' /></a><br />";
                if (add_member_parc($config, $parc, $computer))
                    echo "OK<BR>";
            }
        }

        $info = search_parcs($config, $parc);
        $type = $info[0]['type'];

        $filtrecomp = isset($_POST['filtrecomp']) ? $_POST['filtrecomp'] : "";

        echo "<H3>" . gettext("Alimentation du parc") . " <U>$parc</U></H3>";
        // Filtrage des noms
        echo "<FORM action=\"create_parc.php\" method=\"post\">\n";
        echo "<P>" . gettext("Lister les noms contenant: ");
        echo "<INPUT TYPE=\"text\" NAME=\"filtrecomp\"\n VALUE=\"$filtrecomp\" SIZE=\"8\">";

        if ($parc != "") {
            echo "<input type=\"hidden\" name=\"parc\" value=\"$parc\">\n";
        }
        echo "<input type=\"submit\" value=\"" . gettext("Valider") . "\">\n";
        echo "</FORM>\n";
        // Initialisation:
        $list_new_machines = array();
        // Lecture des membres du parc
        $members_of_parc = list_members_parc($config, $parc, true);
        // Creation d'un tableau des nouvelles machines &#224; int&#233;grer
        if ($filtrecomp == '')
            $filtrel = '*';
        else
            $filtrel = "*$filtrecomp*";
        $list_machines = search_ad($config, $filtrel, "machine");
        sort_by_key("cn", $list_machines);
        
        for ($loop = 0; $loop < count($list_machines); $loop ++) {
            $list_machines_cor[] = ldap_hostname($list_machines[$loop]); 
        }
        //$list_new_machines = array_diff($list_machines_cor, array_column($members_of_parc, "cn"));
        $list_new_machines = $list_machines_cor;
        // Affichage menu de s&#233;lection des machines &#224; ajouter au parc
        if (count($list_new_machines) > 15)
            $size = 15;
        else
            $size = count($list_new_machines);
        if (count($list_new_machines) > 0) {
            sort($list_new_machines);
            $form = "<form action=\"create_parc.php\" method=\"post\">\n";
            $form .= "<p>" . gettext("S&#233;lectionnez les nouvelles machines &#224; int&#233;grer au parc:") . "</p>\n";
            $form .= "<p><select size=\"" . $size . "\" name=\"new_computers[]\" multiple=\"multiple\">\n";
            echo $form;
            for ($loop = 0; $loop < count($list_new_machines); $loop ++) {
                if (($list_new_machines[$loop] != $config['se4ad_name']) && ($list_new_machines[$loop] != $config['se4fs_name'])) {
                    echo "<option value=\"" . $list_new_machines[$loop] . "\"";
                    if (in_array($list_new_machines[$loop], $new_computers))
                        echo "disabled";
                    echo ">" . $list_new_machines[$loop];
                }
            }
            $form = "</select></p>\n";
            if ($type == "salle") {
                $form .= "<u onmouseover=\"return escape" . gettext("('Si la case est cochée, la machine sera déplacée. Sinon elle sera ajoutée au parc.')") . "\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"help\"></u> ";
                $form .= "Déplacer la machine <INPUT TYPE=\"radio\" VALUE=\"true\" name=\"move\" CHECKED> Oui \n";
                $form .= "<INPUT TYPE=\"radio\" VALUE=\"false\" name=\"move\"> Non <br>\n";
            } else {
                $form .= "<input type=\"hidden\" name=\"move\" value=\"false\">\n";
            }

            $form .= "<input type=\"hidden\" name=\"parent\" value=\"$parent\">\n";
            $form .= "<input type=\"hidden\" name=\"parc\" value=\"$parc\">\n";
            $form .= "<input type=\"reset\" value=\"" . gettext("R&#233;initialiser la s&#233;lection") . "\">\n";
            $form .= "<input type=\"submit\" value=\"" . gettext("Valider") . "\">\n";
            $form .= "</form>\n";
            echo $form;
        } else {
            $message = gettext("Il n'y a pas de nouvelles machines &#224; ajouter !");
            echo $message;
        }

        echo "<BR><BR><CENTER>\n";
        echo "<A HREF=\"show_parc.php?parc=$parc\">Retour</A>";
    }
}

include ("pdp.inc.php");
?>
