<?php

/**

 * permet d'attribuer la gestion d'un parc a un utilisateur
 * @Version $Id$ 

 * @Projet LCS / SambaEdu 

 * @auteurs Equipe SambaEdu

 * @Licence Distribue selon les termes de la licence GPL

 * @note 

 */

/**
 *
 * @Repertoire: parcs/
 * file: delegate_parc.php
 *
 */
include "entete.inc.php";
include_once "ldap.inc.php";
include "ihm.inc.php";

// Traduction
require_once ("lang.inc.php");
bindtextdomain('se4-parcs', "/var/www/sambaedu/locale");
textdomain('se4-parcs');

$right = have_right($config, "computers_is_admin");

/**
 *
 * Affiche un bouton retour vers la page delegate_parc.php
 *
 * @Parametres
 * @return
 */
function retour_delegate()
{
    echo "<p><a href=\"delegate_parc.php?action=liste\">" . gettext("Voir la liste des d&#233;l&#233;gations en cours") . "</a></p>\n";
}

function form_choix_user($config, $action, $filtre, $choix)
{
    echo "Choix du de l'utilisateur ou du groupe";
    echo " <INPUT TYPE=\"text\" name=\"filtre\" VALUE=\"$filtre\" SIZE=\"14\">";
    echo "<input type=\"hidden\" name=\"action\" value=\"$action\">\n";
    echo "<input type=\"hidden\" name=\"choix\" value=\"1\">\n";

    echo "<br>";
    if (empty($filtre))
        $filtre = "*";
    else
        $filtre = "*" . $filtre . "*";
    if ($choix == 1) {
        $list_user = search_ad($config, $filtre, "user");
        $list_user = array_merge(search_ad($config, $filtre, "group"), $list_user);
        if (count($list_user) > 15)
            $size = 15;
        else
            $size = count($list_user);

        if (count($list_user) > 0) {
            sort($list_user);
            echo gettext("Nom : ");
            echo "<p><select size=\"" . $size . "\" name=\"users[]\" multiple>\n";
            foreach ($list_user as $user) {
                echo "<option value=\"" . $user['cn'] . "\">" . $user['cn'] . "</option>\n";
            }
        }
        echo "</select>\n";
        echo "<br>";
    }

    echo " <input type=\"submit\" value=\"" . gettext("Valider") . "\">\n";
    echo "<u onmouseover=\"return escape" . gettext("('Donner le début du nom du groupe ou de l\'utilisateur que vous souhaitez trouver.')") . "\"><img name=\"action_image2\"  src=\"../elements/images/system-help.png\" alt=\"help\"></u> ";
}

if ($right) {

    // Aide
    // aide
    $_SESSION["pageaide"] = "Gestion_des_parcs#D.C3.A9l.C3.A9gation_de_parc";

    // Titre
    echo "<h1>" . gettext("D&#233;l&#233;gation de parc") . "</h1>";

    // On teste si il existe des parcs

    $list_parcs = search_parcs($config, "*");
    if (count($list_parcs) == 0) {
        echo "<br><br>";
        echo gettext("Il n'existe aucun parc. Vous devez d'abord cr&#233;er un parc");
        exit();
    }

    if (! ($right) and (! have_right($config, "parc_can_manage"))) {
        echo gettext("Vous n'avez pas les droits n&#233;cessaires pour ouvrir cette page...");
        exit();
    }

    // ************************Definition des variables*******************
    $user = $_POST['nouveau'] ?? $_GET['nouveau'] ?? NULL;
    $salles = $_POST['salles'] ?? $_GET['salles'] ?? NULL;
    $action = $_POST['action'] ?? $_GET['action'] ?? "";
    $users = $_POST['users'] ?? $_GET['users'] ?? array();
    $filtre = $_POST['filtre'] ?? $_GET['filtre'] ?? NULL;
    $choix = $_POST['choix'] ?? $_GET['choix'] ?? 0;

    $parcs = array();
    switch ($action) {
        // ************Voir les delegations en cours***************************
        default:
            if ((! have_right($config, "computers_is_admin")) and (! have_right($config, "parc_can_manage"))) {
                echo "Droits insuffisants pour accéder à cette fonction";
                exit();
            }

            echo "<h3>" . gettext("D&#233;l&#233;gations en cours") . " </h3>";

            if ($right) {
                $delegations = search_delegations($config);
            } else {
                // @TODO gérer les délégations pour l'affichage du tableau
                $delegations = list_delegations($config);
            }
            if (count($delegations) == 0) {
                echo gettext("Aucune d&#233;l&#233;gation en cours");
            } else {
                echo "<table border=1 align=center width=\"50%\">\n";
                echo "<tr><td align=center class=menuheader colspan=\"6\" height=\"30\" >" . gettext("R&#233;capitulatif des d&#233;l&#233;gations par parc") . "</td>\n";
                echo "</tr>\n";
                echo "<tr><td class=menuheader height=\"30\" align=center>" . gettext("Utilisateur/groupe") . "</td>\n";
                echo "<td class=menuheader align=center>" . gettext("Parc") . "</td>\n";
                echo "<td class=menuheader colspan=3 align=center>" . gettext("Niveau de d&#233;l&#233;gation") . "</td></tr>\n";
                foreach ($delegations as $delegation) {
                    if (isset($delegation['member'])) {
                        foreach ($delegation['member'] as $member) {
                            $delegation['user'] = ldap_dn2cn($member);
                            echo "<tr><td align=center>" . $delegation['user'] . "</td>\n";
                            echo "<td align=center>" . $delegation['parc'] . "</td>\n";
                            echo "<td align=center>";
                            if ($delegation['level'] == "manage") {
                                echo gettext("D&#233;l&#233;gation forte") . "</td>";
                                if ($right) {
                                    echo "<td align=center><a href=\"delegate_parc.php?users[]=" . $delegation['user'] . "&salles=" . $delegation['parc'] . "&action=view\">";
                                    echo "<img src=\"../elements/images/stock_bottom.png\" alt=\"" . gettext("Diminuer le niveau de d&#233;l&#233;gation") . "\" title=\"" . gettext("Diminuer le niveau de d&#233;l&#233;gation") . "\" width=\"16\" height=\"16\" border=\"0\" /></a></td>\n";
                                    echo "</td>\n";
                                }
                            }
                            if ($delegation['level'] == "view") {
                                echo gettext("D&#233;l&#233;gation faible") . "</td>\n";

                                if ($right) {
                                    echo "<td align=center><a href=\"delegate_parc.php?users[]=" . $delegation['user'] . "&salles=" . $delegation['parc'] . "&action=manage\">";
                                    echo "<img src=\"../elements/images/stock_top.png\" alt=\"" . gettext("Augmenter le niveau de d&#233;l&#233;gation") . "\" title=\"" . gettext("Augmenter le niveau de d&#233;l&#233;gation") . "\" width=\"16\" height=\"16\" border=\"0\" /></a></td>\n";
                                    echo "</td>\n";
                                }
                            }
                            if ($delegation['level'] == "rdp") {
                                echo gettext("Accès à distance rdp") . "</td>\n";
                            }
                            if ($delegation['level'] == "vnc") {
                                echo gettext("Accès à distance vnc") . "</td>\n";
                            }
                            if (($right) or ((type_delegation($config, $delegation['parc']) == "manage") and ($delegation['level'] == "view"))) {
                                echo "<td align=center><a href=\"delegate_parc.php?users[]=" . $delegation['user'] . "&salles=" . $delegation['parc'] . "&action=nodelegate\">";
                                echo "<img src=\"../elements/images/edittrash.png\" alt=\"" . gettext("Supprimer cette d&#233l&#233gation") . "\" title=\"" . gettext("Supprimer cette d&#233;l&#233;gation") . "\" width=\"16\" height=\"16\" border=\"0\" /></a></td>\n";
                                echo "</td>\n";
                            } else {
                                echo "<td>&nbsp;</td>\n";
                            }

                            echo "</tr>";
                        }
                    }
                }
                echo "</table><br><br>\n";
            }
            include ("pdp.inc.php");
            // break;

            // *******************Choix d'une salle********************************
            if (! $salles) {
                // choix du template
                echo "<h3>" . gettext("Choisir un nouveau parc &#224; d&#233;l&#233;guer") . " </h3>";

                $list_parcs = search_parcs($config, "*");
                sort($list_parcs);

                echo "<FORM method=\"post\" action=\"delegate_parc.php\">\n";
                echo "<input type=\"hidden\" name=\"action\" value=\"new\" />";
                echo "<SELECT NAME=\"salles\" SIZE=\"1\" onchange=submit()>";
                echo "<option value=\"\">S&#233;lectionner</option>";
                if (count($list_parcs) > 0) {
                    for ($loop = 0; $loop < count($list_parcs); $loop ++) {
                        if (($right) or (type_delegation($config, $list_parcs[$loop]["name"]) == "manage")) {
                            array_push($parcs, $list_parcs[$loop]["name"]);
                            echo "<option value=\"" . $list_parcs[$loop]["name"] . "\"";
                            if ((isset($parc)) && ($parc == $list_parcs[$loop]["name"])) {
                                echo " selected";
                            }
                            echo ">" . $list_parcs[$loop]["name"] . "\n";
                            echo "</option>";
                        }
                    }
                }

                echo "</SELECT>&nbsp;&nbsp;\n";

                echo "<u onmouseover=\"return escape" . gettext("('Un parc correspond &#224; un groupe de machines. <br>Il peut vous servir &#224; regrouper vos machines (par salle par exemple).<br>Une machine peut appartenir &#224; plusieurs parcs en fonction de vos besoins. Il peut &#234;tre li&#233; &#224; un <font color=#FF0000>template</font> du m&#234;me nom si vous avez cr&#233;&#233; un r&#233;pertoire correspondant dans le r&#233;pertoire Admhomes/templates. Vous pourrez alors agir sur les machines du parc en utilisant les possibilit&#233;s des templates.')") . "\"><img name=\"action_image3\"  src=\"../elements/images/system-help.png\" alt=\"help\"></u> ";

                echo "</form>\n";
            }
            break;

        // *********************Choix d'un utilisateur******************************
        case "new":
            echo "<h3>" . gettext("Vous avez choisi de d&#233;l&#233;guer la gestion de") . " $salles";
            echo "</h3><form action=\"delegate_parc.php\" name=\"visu\" method=\"get\">\n";
            if (count($users) == 0) { // choix du user
                form_choix_user($config, $action, $filtre, $choix);
            } else {
                if ($right) {
                    echo "<input type=\"radio\" name=\"action\" id=\"action_manage\" value=\"manage\"  >\n";
                    echo "<label for='action_manage'>" . gettext("D&#233;l&#233;guer totalement la gestion de") . " <b> $salles </b></label><br>\n";
                    echo "<input type=\"radio\" name=\"action\" id=\"action_rdp\" value=\"rdp\"  CHECKED  >\n";
                    echo "<label for='action_rdp'>" . gettext("Permettre l'accès à distance RDP") . " <b> $salles </b></label><br>\n";
                    echo "<input type=\"radio\" name=\"action\" id=\"action_vnc\" value=\"vnc\">\n";
                    echo "<label for='action_vnc'>" . gettext("Permettre l'accès à distance VNC") . " <b> $salles </b></label><br>\n";
                }

                if (($right) or (type_delegation($config, $salles) == "manage")) {
                    // pour les templates, on est automatiquement dans une delegation forte !!!!!!!!!!!!
                    // en effet, la delegation sur les templates donne acces a logon.bat et a clients windows
                    // des qu'un parc a un template associe il est considere comme un template
                    // if (is_parc($salles)) {
                    echo "<input type=\"radio\" name=\"action\" id=\"action_view\" value=\"view\"/>\n";
                    echo "<label for='action_view'>" . gettext("Permettre &#224; l'utilisateur de suivre le parc ( pas d'action possible)") . "</label>";
                    // }
                    echo "<br><input type=\"radio\" name=\"action\" id=\"action_nodelegate\" value=\"nodelegate\">\n";
                    echo "<label for='action_nodelegate'>" . gettext("Retirer la d&#233;l&#233;gation de") . " <b> $salles </b> " . gettext("pour cet utilisateur") . "</label>";
                }
                foreach ($users as $user) {
                    echo "<input type=\"hidden\" name=\"users[]\" value=\"" . $user . "\">\n";
                }
                echo "<br><br><input type=\"submit\" name=\"submit\" value=\"" . gettext("Envoyer") . "\" />\n";
            }
            echo "<input type=\"hidden\" name=\"salles\" value=\"" . $salles . "\">\n";
            echo "</form>\n";
            break;

        // **********************************action manage***********************
        case "manage":
            // ********************************action commun a: manage, view, nodelegate
            if (count($users) == 0 or (! $salles)) {
                echo gettext("Vouz devez choisir un parc et un utilisateur");
                retour_delegate();
                exit();
            }

            echo "<h2>D&#233l&#233gation du parc $salles </h2>\n";
            foreach ($users as $user) {
                if (have_right($config, "computers_is_admin", $user)) {
                    echo "<font color=#FF0000>" . gettext("Cet utilisateur b&#233;n&#233;ficie du  droit computers_is_admin , il a d&#233;j&#224; tous les droits sur les parcs et les templates") . "</font><br>";
                }

                if (! $right) {
                    exit();
                }

                if (@is_dir("/home/$user")) {} else {
                    echo "<font color=#FF0000>" . gettext("Cet utilisateur n'a pas de r&#233;pertoire personnel. <br> Il est impossible de placer le raccourci du parc sur son bureau.<BR> Demandez &#224; cet utilisateur de se connecter au moins une fois sur le domaine.") . "</font>";
                    exit();
                }

                if (have_right($config, "parc_can_manage", $user)) {
                    echo "<p>" . gettext("Cet utilisateur b&#233n&#233ficie d&#233;j&#224; d'une d&#233;l&#233;gation forte") . "</p>";
                } else {
                    $right = "parc_can_manage";
                    add_right($config, $user, $right);
                    echo gettext("La d&#233;l&#233;gation forte (parc_can_manage) est prise en compe: Plus d'&#233;l&#233;ments du menu sont accessibles &#224;") . " <b>$user </b> " . gettext("dans") . " <b>$salles</b><br>\n";
                    echo "<ul><li>" . gettext("Clients Windows") . "</li>\n";
                    echo "<li>" . gettext("Inventaire") . "</li>\n";
                    echo "<li>.....</li></ul><br>";
                }

                // ajout dans la table delegation si necessaire
                $result = type_delegation($config, $salles, $user);
                if ($result) {
                    if (count($result > 0)) {

                        echo "<p><font color=#FF0000>" . gettext("L'utilisateur") . " <b>$user</b> " . "avait d&#233;j&#224; une d&#233;l&#233;gation sur ce parc</font></p>\n";
                        delete_delegation($config, $salles, $user, $result);
                    }

                    $result_verif = type_delegation($config, $salles, $user);

                    if ($result_verif != "view") {
                        $right = "parc_can_view";
                        remove_right($config, $user, $right);
                    }
                }
                create_delegation($config, $salles, $user, "manage");
            }
            retour_delegate();
            break;

        // **************************************action nodelegate********************************************
        case "nodelegate":

            // ********************************action commun a: manage, view, nodelegate
            if (count($users) == 0 or (! $salles)) {
                echo gettext("Vouz devez choisir un parc et un utilisateur");
                retour_delegate();
                exit();
            }

            echo "<h2>" . gettext("D&#233l&#233gation de parcs") . "</h2>\n";
            foreach ($users as $user) {

                if (have_right($config, "computers_is_admin", $user)) {
                    echo "<font color=#FF0000>" . gettext("Cet utilisateur b&#233;n&#233;ficie du  droit computers_is_admin , il a d&#233;j&#224; tous les droits sur les parcs et les templates") . "</font><br>";
                }

                $result = type_delegation($config, $salles, $user);
                $res = delete_delegation($config, $salles, $user, $result);
                if ($res) {
                    echo "<p>" . gettext("La d&#233;l&#233;gation est supprim&#233; pour") . " <b> $user </b> " . gettext("sur le") . " parc <b> $salles</b></p>\n";
                }
            }
            retour_delegate();

            break;

        // *******************************action view*******************************
        case "view":
        case "rdp":
        case "vnc":
            // ********************************action commun a: manage, view, nodelegate
            if (count($users) == 0 or (! $salles)) {
                echo gettext("Vouz devez choisir un parc et un utilisateur");
                retour_delegate();
                exit();
            }

            echo "<h2>" . "D&#233l&#233gation du parc : </h2>\n";
            foreach ($users as $user) {

                if (have_right($config, "computers_is_admin", $user)) {
                    echo "<font color=#FF0000>" . gettext("Cet utilisateur b&#233;n&#233;ficie du  droit computers_is_admin , il a d&#233;j&#224; tous les droits sur les parcs et les templates") . "</font><br>";
                }

                // ajout dans ldap du droit parc_can_view si le droit n'est pas deja mis
                $right = "parc_can_view";

                if (have_right($config, $right, $user)) {
                    echo gettext("Cet utilisateur b&#233n&#233ficie d&#233j&#224 d'une d&#233l&#233gation faible") . "<br>";
                } else {
                    add_right($config, $user, $right);
                }

                echo gettext("La délégation " . $action . " est prise en compte pour :") . " <b> $user </b> <br>";
                echo "<br><h3>" . gettext("L'utilisateur <B> $user</B> b&#233;n&#233;ficie d'une d&#233;l&#233;gation faible, il ne pourra pas modifier vos r&#233;glages.") . "</h3>";

                // ajout dans la table delegation si necessaire
                // $query = "select parc from delegation where login='$user' and parc='$salles';";
                $result = type_delegation($config, $salles, $user);

                if ($result) {
                    echo "<p><font color=#FF0000>" . gettext("L'utilisateur") . " <B> $user</B> " . gettext("avait d&#233j&#224 une d&#233l&#233gation sur le parc") . " <b>$salles</b></font></p>\n";
                    delete_delegation($config, $salles, $user, $result);
                    $result_verif = type_delegation($config, $salles, $user);

                    if ($result_verif != "manage") {
                        $right = "parc_can_manage";
                        remove_right($config, $user, $right);
                    }
                }

                create_delegation($config, $salles, $user, $action);
            }
            retour_delegate();

            break;
        // fin case "view":
    } // fin du switch($action)
}
include ("pdp.inc.php");
?>
