<?php
/**
 * Creation des repertoires classes et mise en place des ACL
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @auteurs Philippe Chadefaux, denis bonnenfant
 * @Licence Distribue selon les termes de la licence GPL
 * @note
 */
/**
 *
 * @Repertoire: partages/
 * file: rep_classes.php
 */
include "entete.inc.php";
require_once "ldap.inc.php";
require_once "ihm.inc.php";
require_once "samba.inc.php";
require_once "partages.inc.php";
require_once "partages_ui.inc.php";
require_once ("lang.inc.php");
bindtextdomain('sambaedu-partages', "/var/www/sambaedu/locale");
textdomain('sambaedu-partages');

// aide
$_SESSION["pageaide"] = "Ressources_et_partages";

$texte_alert = "Vous allez supprimer tout le repertoire classe. Voulez vous vraiment continuer ?";
?>
<script type="text/javascript">

    /**
     * Affiche une boite de dialogue pour demander confirmation
     * @language Javascript
     * @Parametres
     * @return
     */

    function areyousure() {
        var messageb = "<?php echo "$texte_alert"; ?>";
        if (confirm(messageb)) {
            return true;
        } else {
            return false;
        }
    }
</script>

<?php
$action = $_POST['action'] ?? "";
$select_folders_classes = $_POST['folders_classes'] ?? array();
if (! have_right($config, "se3_is_admin|annu_is_admin|sovajon_is_admin")) {
    echo "<p>Vous n'avez pas les droits suffisants</p>\n";
} else {
    $folders_classes = apcu_fetch("folders_classes_" . session_id());
    if ($action == "refresh_all"){
        $select_folders_classes = list_classes($config, "*");
        apcu_delete("html_partages_" . session_id()); 
        $action = "refresh";
    }
    if (empty($folders_classes) && ! empty($select_folders_classes)) {
        apcu_store("folders_classes_" . session_id(), $select_folders_classes, 500);
        $folders_classes = $select_folders_classes;
    }
    if (empty($action) || empty($folders_classes)) {
        echo form_partages($config, $action, $select_folders_classes);
        apcu_delete("html_partages_" . session_id());
        apcu_delete("folders_classes_" . session_id());
    } else {
        $end = apply_partages($config, $action);
        echo apcu_fetch("html_partages_" . session_id());
        batch_write();
        echo "<a id=\"end\"></a>";
        if ($end) {
            apcu_delete("html_partages_" . session_id());
            apcu_delete("folders_classes_" . session_id());
            echo "<b> Mise à jour terminée </b>";
        } else {
            echo "<script type=\"text/javascript\">";
            echo "var wait = setTimeout(document.partages.submit(), 29000)";
            echo "</script>";
        }
    }
}
echo "<p><a href=\"rep_classes.php\">Retour au menu principal</a></p>\n";
include ("pdp.inc.php");
?>
